//----------------------------------------------------------------------------------------------------------------------
// RGrids by (c)  RVA ( or DOGA, or BARDACk) (c) started at 28.10.2005
// Version 1.07 Beta (Test version) at 13.01.2007
// Only for Russian-speaking users !!!
// Only for registred visitors of a site www.cbuilder.ru !!!
// Only for noncommercial use !!!
// Absolutely any guarantees !!!
// EMail: rva@prolog.obninsk.ru
//----------------------------------------------------------------------------------------------------------------------
unit RGrids;

{$R-,T-,H+,X+}

//----------------------------------------------------------------------------------------------------------------------
interface

uses Messages, {$IFDEF LINUX} WinUtils, {$ENDIF} Windows, SysUtils, Classes,
  Variants, Graphics, Menus, Controls, Forms, StdCtrls, Mask, Math, Consts, RTLConsts,
  Commctrl, ImgList;

const
  RMaxCustomExtents = MaxListSize;
  RMaxShortInt = High(ShortInt);

type
  ERInvalidGridOperation = class(Exception);

  { Internal grid types }
  TRGetExtentsFunc = function(Index: Longint): Integer of object;

  TRGridAxisDrawInfo = record
    EffectiveLineWidth:  Integer;
    FixedBoundary:       Integer;
    GridBoundary:        Integer;
    GridExtent:          Integer;
    LastFullVisibleCell: Longint;
    FullVisBoundary:     Integer;
    FixedCellCount:      Integer;
    FirstGridCell:       Integer;
    GridCellCount:       Integer;
    GetExtent:           TRGetExtentsFunc;
  end;

  TRGridDrawInfo = record
    Horz, Vert: TRGridAxisDrawInfo;
  end;

  TRGridState =
  (
    rgsNormal,
    rgsFocusMoving,
    rgsMarking,
    rgsRangeMarking,
    rgsRowSizing,
    rgsColSizing,
    rgsRowMoving,
    rgsColMoving
  );

  TRGridMovement = rgsRowMoving..rgsColMoving;


  TRGridOption =
  (
    rgoFixedVertLine,
    rgoFixedHorzLine,
    rgoVertLine,
    rgoHorzLine,
    rgoShowFocusCell,
    rgoShowFocusFrame,
    rgoShowCurCol,
    rgoShowCurRow,
    rgoHideFocusCellOnExit,
    rgoHideCurColRowOnExit,
    rgoAutoColorCurColRow,
    rgoDrawMaskedImages,
    rgoSupportFixedButtons,
    rgoRowsMarking,
    rgoColsMarking,
    rgoCellsMarking,
    rgoZebraCols,
    rgoZebraRows,
    rgoRowSizing,
    rgoColSizing,
    rgoRowMoving,
    rgoColMoving,
    rgoTabs,
    rgoThumbTracking
  );

  TRGridOptions = set of TRGridOption;

  TRGridDrawState =
  (
    {
    rgdFocusedCellNotMark,
    rgdFocusedCellMark,
    rgdMarkedCell,
    rgdCurrentColRowNotMark,
    rgdCurrentColRowMark,
    rgdFixedCell,
    }

    // 
    rgdFocused,
    rgdMarked,
    rgdCurrent,
    // 
    rgdFixed,
    rgdDown
  );

  TRGridDrawStates = set of TRGridDrawState;

  TRDirection =
  (
    rsdLeft,
    rsdRight,
    rsdUp,
    rsdDown
  );

  TRGridScrollDirection = set of TRDirection;

  TRGridFocusFrameStyle =
  (
    rffDotRect,
    rffRect
  );

  TRGridCoord = record
    X: Longint;
    Y: Longint;
  end;

  TRGridRect = record
    case Integer of
      0: (Left, Top, Right, Bottom: Longint);
      1: (TopLeft, BottomRight: TRGridCoord);
  end;

  PLongintArray = ^TLongintArray;
  TLongintArray = array[0..RMaxCustomExtents] of Longint;

  PIntArray = ^TIntArray;
  TIntArray = array[0..RMaxCustomExtents] of Integer;

  TXorRects = array[0..3] of TRect;

  //THack = class(TCustomControl);
  TRVertAlignment = (rvaTopJustify, rvaCenter, rvaBottomJustify);


//----------------------------------------------------------------------------------------------------------------------
  TRGridColors  = class;
  TRCell        = class;
  TRCellsVector = class;
  TRGridUnion   = class;
  TRCellsUnion  = class;
  TRCellsUnions = class;
  TRCellsHolder = class;
  TRCustomGrid  = class;
//----------------------------------------------------------------------------------------------------------------------
// TRGridColors - class to collect all switchable colors into one place
//----------------------------------------------------------------------------------------------------------------------
  TRGridColors = class(TPersistent)
  private
    FOwner: TRCustomGrid;
    FColors: array[0..22] of TColor;

    function GetColor(const Index: Integer): TColor;
    procedure SetColor(const Index: Integer; const Value: TColor);

    function AutoColor(Color1, Color2: TColor): TColor;

    procedure RefreshColors;

    property _BakgroundFieldColor:           TColor index 0  read GetColor;
    property _CurColRowColorNotMark:         TColor index 17 read GetColor;
    property _CurColRowColorMark:            TColor index 18 read GetColor;
    property _CurColRowColorNotMarkUnActive: TColor index 19 read GetColor;
    property _CurColRowColorMarkUnActive:    TColor index 20 read GetColor;
    property _DefaultCellColor1NotMark:      TColor index 5  read GetColor;
    property _DefaultCellColor2NotMark:      TColor index 6  read GetColor;
    property _DefaultCellColorMark:          TColor index 7  read GetColor;
    property _DefaultCellColorMarkUnActive:  TColor index 8  read GetColor;
    property _FocusCellColorNotMark:         TColor index 9  read GetColor;
    property _FocusCellColorMark:            TColor index 10 read GetColor;
    property _FocusCellColorNotMarkUnActive: TColor index 11 read GetColor;
    property _FocusCellColorMarkUnActive:    TColor index 12 read GetColor;
    property _FocusFrameColorNotMark:        TColor index 21 read GetColor;
    property _FocusFrameColorMark:           TColor index 22 read GetColor;
    property _FixedButtonsColor:             TColor index 15 read GetColor;
    property _GridLineColor:                 TColor index 16 read GetColor;

  public
    constructor Create(AOwner: TRCustomGrid);

    procedure Assign(Source: TPersistent); override;

  published
    property BakgroundFieldColor:           TColor index 0  read GetColor write SetColor default clBtnFace;
    property CurColRowColorNotMark:         TColor index 1  read GetColor write SetColor default clSkyBlue;
    property CurColRowColorMark:            TColor index 2  read GetColor write SetColor default clMoneyGreen;
    property CurColRowColorNotMarkUnActive: TColor index 3  read GetColor write SetColor default $00D9CEBD;
    property CurColRowColorMarkUnActive:    TColor index 4  read GetColor write SetColor default $00C8D5C8;
    property DefaultCellColor1NotMark:      TColor index 5  read GetColor write SetColor default clWindow;
    property DefaultCellColor2NotMark:      TColor index 6  read GetColor write SetColor default $00EFEFEF;
    property DefaultCellColorMark:          TColor index 7  read GetColor write SetColor default clGreen;
    property DefaultCellColorMarkUnActive:  TColor index 8  read GetColor write SetColor default $00638365;
    property FocusCellColorNotMark:         TColor index 9  read GetColor write SetColor default clHighlight;
    property FocusCellColorMark:            TColor index 10 read GetColor write SetColor default clTeal;
    property FocusCellColorNotMarkUnActive: TColor index 11 read GetColor write SetColor default $00917064;
    property FocusCellColorMarkUnActive:    TColor index 12 read GetColor write SetColor default $005B7D5E;
    property FocusFrameColorNotMark:        TColor index 13 read GetColor write SetColor default clSkyBlue;
    property FocusFrameColorMark:           TColor index 14 read GetColor write SetColor default clMoneyGreen;
    property FixedButtonsColor:             TColor index 15 read GetColor write SetColor default clBtnFace;
    property GridLineColor:                 TColor index 16 read GetColor write SetColor default clBtnShadow;
  end;
//----------------------------------------------------------------------------------------------------------------------
// TRGridFonts
//----------------------------------------------------------------------------------------------------------------------
  TRGridFonts = class(TPersistent)
  private
    FOwner: TRCustomGrid;
    FFonts: array[0..12] of TFont;

    function GetFont(const Index: Integer): TFont;
    procedure SetFont(const Index: Integer; const Value: TFont);

  public
    constructor Create(AOwner: TRCustomGrid);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;

  published
    property CurColRowFontNotMark:         TFont index 0  read GetFont write SetFont;
    property CurColRowFontMark:            TFont index 1  read GetFont write SetFont;
    property CurColRowFontNotMarkUnActive: TFont index 2  read GetFont write SetFont;
    property CurColRowFontMarkUnActive:    TFont index 3  read GetFont write SetFont;
    property DefaultCellFont1NotMark:      TFont index 4  read GetFont write SetFont;
    property DefaultCellFont2NotMark:      TFont index 5  read GetFont write SetFont;
    property DefaultCellFontMark:          TFont index 6  read GetFont write SetFont;
    property DefaultCellFontMarkUnActive:  TFont index 7  read GetFont write SetFont;
    property FocusCellFontNotMark:         TFont index 8  read GetFont write SetFont;
    property FocusCellFontMark:            TFont index 9  read GetFont write SetFont;
    property FocusCellFontNotMarkUnActive: TFont index 10 read GetFont write SetFont;
    property FocusCellFontMarkUnActive:    TFont index 11 read GetFont write SetFont;
    property FixedButtonsFont:             TFont index 12 read GetFont write SetFont;

  end;

//----------------------------------------------------------------------------------------------------------------------
// TRCell
//----------------------------------------------------------------------------------------------------------------------
  TRCell = class(TObject)
  private
    FColOwner: TRCellsVector;
    FRowOwner: TRCellsVector;

    FCellsUnion: TRCellsUnion;
    FGridUnionIndex: Longint;

    FMarked: Boolean;

    FData: Pointer;

    function GetHolderCol: Longint;
    function GetHolderRow: Longint;
    function GetGridCol: Longint;
    function GetGridRow: Longint;
    function GetBelongsToUnion: Boolean;
    function GetUnioned: Boolean;
    function GetMarked: Boolean;
    function GetGridUnion: TRGridUnion;
    //function GetText: string;
    procedure SetMarked(Value: Boolean);

  public
    constructor Create(AColOwner, ARowOwner: TRCellsVector{; AVisible: Boolean});
    destructor Destroy; override;

    property ColOwner : TRCellsVector read FColOwner;
    property RowOwner : TRCellsVector read FRowOwner;
    property HolderCol: Longint read GetHolderCol;
    property HolderRow: Longint read GetHolderRow;
    property GridCol: Longint read GetGridCol;
    property GridRow: Longint read GetGridRow;
    property Marked: Boolean read GetMarked write SetMarked;
    property BelongsToUnion: Boolean read GetBelongsToUnion;
    property Unioned: Boolean read GetUnioned;
    property CellsUnion: TRCellsUnion read FCellsUnion;
    property GridUnion: TRGridUnion read GetGridUnion;
    //property Text: string read GetText;
    property Data: Pointer read FData write FData;
  end;

//----------------------------------------------------------------------------------------------------------------------
// TRCellsVector
//----------------------------------------------------------------------------------------------------------------------
  TRCellsVector = class(TObject)
  private
    FOwner: TRCellsHolder;
    FIsColumn: Boolean;
    FFixed: Boolean;
    FVisible: Boolean;
    FMarked: Boolean;
    FSize: Integer;   //    
    FHolderIndex: Longint;
    FGridIndex: Longint;
    FCellsList: Tlist;

    FData: Pointer;

    procedure SetSize(Value: Integer);
    //function GetCells(CellIndex: Longint): TRCell;
    procedure SetMarked(Value: Boolean);
    procedure SetVisible(Value: Boolean);

  public
    constructor Create(AOwner: TRCellsHolder; AIsColumn, AFixed, AVisible: Boolean; ASize: Integer; ACellsList: TList); //virtual;
    destructor Destroy; override;

    property Owner: TRCellsHolder read FOwner;
    property IsColumn: Boolean read FIsColumn;
    property Visible: Boolean read FVisible write SetVisible;
    property Fixed: Boolean read FFixed;
    property Marked: Boolean read FMarked write SetMarked;
    property Size: Integer read FSize write SetSize;
    property HolderIndex: Longint read FHolderIndex;
    property GridIndex: Longint read FGridIndex;
    //property Cells[CellIndex: Longint]: TRCell read GetCells;
    property Data: Pointer read FData write FData;

  end;
//----------------------------------------------------------------------------------------------------------------------
// TRGridUnion
//----------------------------------------------------------------------------------------------------------------------
  TRGridUnion = class(TObject)
  private
    FOwner: TRCellsUnion;
    FUnionRect: TRGridRect;
    FPaintCount: Integer;
    FCellsList: TList;

    function GetMainCell(): TRCell;
    function GetCells(CellIndex: Longint): TRCell;
    function GetCount(): Longint;
    function GetMarked: Boolean;

  public
    constructor Create(AOwner: TRCellsUnion; AUnionRect: TRGridRect; ACellsList: TList);
    destructor Destroy; override;

    property Owner: TRCellsUnion read FOwner;
    property MainCell: TRCell read {F}GetMainCell;
    property Cells[CellIndex: Longint]: TRCell read GetCells;
    property CellsCount: Longint read GetCount;
    property UnionRect: TRGridRect read FUnionRect;
    //property PaintCount: Integer read FPaintCount write FPaintCount;
    property Marked: Boolean read GetMarked;
  end;
//----------------------------------------------------------------------------------------------------------------------
// TRCellsUnion
//----------------------------------------------------------------------------------------------------------------------
  TRCellsUnion = class(TObject)
  private
    FOwner: TRCellsUnions;
    FMainCell: TRCell;

    FCellsList: TList;
    FGridUnionList: TList;

    //FFixed: Boolean;
    FMarked: Boolean;
    FMarkStatus: Boolean;
    FEnabled: Boolean;

    procedure SetMarked(Value: Boolean);
    //procedure TrySetMarked(Value: Boolean);

    function GetCells(CellIndex: Longint): TRCell;
    function GetCellsCount(): Longint;

    function GetGridUnions(CellIndex: Longint): TRGridUnion;
    function GetGridUnionsCount(): Longint;

    procedure SetEnabled(Value: Boolean);
    procedure Enable();
    procedure Disable();

  public
    constructor Create(AOwner: TRCellsUnions; AMainCell: TRCell; ACellsList: TList);
    destructor Destroy; override;

    procedure Refresh();
    procedure Invalidate();

    property Owner: TRCellsUnions read FOwner;
    property MainCell: TRCell read FMainCell;
    property Cells[CellIndex: Longint]: TRCell read GetCells;
    property CellsCount: Longint read GetCellsCount;
    property GridUnions[UnionIndex: Longint]: TRGridUnion read GetGridUnions;
    property GridUnionsCount: Longint read GetGridUnionsCount;
    property Marked: Boolean read FMarked write SetMarked;
    property Enabled: Boolean read FEnabled write SetEnabled;
    
  end;
//----------------------------------------------------------------------------------------------------------------------
// TRCellsUnions
//----------------------------------------------------------------------------------------------------------------------
  TRCellsUnions = class(TObject)
  private
    FOwner: TRCellsHolder;

    FUnionsList: TList;

    function  GetUnions(UnionIndex: Longint): TRCellsUnion;
    function  GetUnionsCount: Longint;
    procedure ResetPaintCounters();
    procedure StoreMarkStatuses();
    function  TryChangeMarked(AVector: TRCellsVector; Value: Boolean): Boolean;

  public
    constructor Create(AOwner: TRCellsHolder);
    destructor Destroy; override;

    procedure Add(MainCellCoord, StartAnchor, EndAnchor: TRGridCoord; IsGridCoord: Boolean = False); overload;
    procedure Add(AMainCell: TRCell; ACellsList: TList; IsGridCoord: Boolean = False); reintroduce; overload;
    procedure Delete(Index: Longint);
    procedure Clear;
    procedure Refresh;

    property Unions[UnionIndex: Longint]: TRCellsUnion read GetUnions;
    property UnionsCount: Longint read GetUnionsCount;
    property Owner: TRCellsHolder read FOwner;
  end;
//----------------------------------------------------------------------------------------------------------------------
// TRCellsHolder
//----------------------------------------------------------------------------------------------------------------------
  TRCellsHolder = class(TPersistent)
  private
    FOwner: TRCustomGrid;

    FCols: TList;
    FRows: TList;
    FMarkList: TList;

    FCellsUnions: TRCellsUnions;

    FVisibleColCount: Longint;
    FVisibleRowCount: Longint;

    FFixedCols: Integer; //   
    FFixedRows: Integer; //... 

    FMarkCount: Longint;

    FNeedReGenerateMarks: Boolean;
    FDeleting: Boolean;

    procedure SetColCount(Value: Longint);
    function GetColCount: Longint;

    procedure SetRowCount(Value: Longint);
    function GetRowCount: Longint;

    procedure SetFixedCols(Value: Integer);
    procedure SetFixedRows(Value: Integer);

    procedure DoChangeSize(NewColCount, NewRowCount: Longint);

    procedure EnumerateCols;
    procedure EnumerateRows;

    procedure SetColWidths(ACol: Longint; Value: Integer);
    function GetColWidths(ACol: Longint): Integer;

    procedure SetRowHeights(ARow: Longint; Value: Integer);
    function GetRowHeights(ARow: Longint): Integer;
    {
    procedure SetColsVisibles(ACol: Longint; Value: Boolean);
    function GetColsVisibles(ACol: Longint): Boolean;

    procedure SetRowsVisibles(ARow: Longint; Value: Boolean);
    function GetRowsVisibles(ARow: Longint): Boolean;
    }

    //procedure SetMarkedCols(ACol: Longint; Value: Boolean);
    function GetMarkedCols(AIndex: Longint): TRCellsVector;

    //procedure SetMarkedRows(ARow: Longint; Value: Boolean);
    function GetMarkedRows(AIndex: Longint): TRCellsVector;

    //procedure SetMarkedCells(ACol, ARow: Longint; Value: Boolean);
    function GetMarkedCells(AIndex: Longint): TRCell;

    function GetMarkedCount: Longint;

    function GetCols(ACol: Longint): TRCellsVector;
    function GetRows(ARow: Longint): TRCellsVector;
    function GetCells(ACol, ARow: Longint): TRCell;

    {
    function GetColsText(ACol: Longint) :string;
    function GetRowsText(ARow: Longint) :string;
    }

    procedure DoMoveColumn(FromIndex, ToIndex: Longint);
    procedure DoMoveRow(FromIndex, ToIndex: Longint);

    procedure ReadColWidths(Reader: TReader);
    procedure WriteColWidths(Writer: TWriter);

    procedure ReadRowHeights(Reader: TReader);
    procedure WriteRowHeights(Writer: TWriter);

    procedure GenerateMarkList();

  protected
    procedure DefineProperties(Filer: TFiler); override;

  public
    constructor Create(AOwner: TRCustomGrid);
    destructor Destroy; override;

    procedure ChangeSize(NewColCount, NewRowCount: Longint);

    procedure SetVisibleColsRange(AColsList: TList; Reverse: Boolean = False);
    procedure SetVisibleRowsRange(ARowsList: TList; Reverse: Boolean = False);
    procedure SetVisibleAllCols();
    procedure SetVisibleAllRows();
    procedure DeleteColsRange(AColsList: TList);
    procedure DeleteRowsRange(ARowsList: TList);
    procedure DeleteCol(ACol: Longint);
    procedure DeleteRow(ARow: Longint);
    function  AddCol(AVisible: Boolean): TRCellsVector;
    function  AddRow(AVisible: Boolean): TRCellsVector;
    function  InsertCol(APosition: Longint; AVisible: Boolean): TRCellsVector;
    function  InsertRow(APosition: Longint; AVisible: Boolean): TRCellsVector;
    procedure FreeCellsRangeData(AStart, AEnd: TRGridCoord);
    procedure InitCellsRangeData(AStart, AEnd: TRGridCoord);
    procedure FreeVectorsRangeData(AIsColumn: Boolean; AStart, AEnd: Longint);
    procedure InitVectorsRangeData(AIsColumn: Boolean; AStart, AEnd: Longint);
    procedure ClearMark();
    procedure Sort(Compare: TListSortCompare; WithoutFixed: Boolean);
    
    property Cols[ACol: Longint]: TRCellsVector read GetCols;
    property Rows[ARow: Longint]: TRCellsVector read GetRows;
    property Cells[ACol, ARow: Longint]: TRCell read GetCells;
    {
    property ColsText[ACol: Longint]: string read GetColsText;
    property RowsText[ARow: Longint]: string read GetRowsText;
    }
    property ColWidths[ACol: Longint]: Integer read GetColWidths write SetColWidths;
    property RowHeights[ARow: Longint]: Integer read GetRowHeights write SetRowHeights;
    {
    property ColsVisibles[ACol: Longint]: Boolean read GetColsVisibles write SetColsVisibles;
    property RowsVisibles[ARow: Longint]: Boolean read GetRowsVisibles write SetRowsVisibles;
    }

    property MarkedCols[AIndex: Longint]: TRCellsVector read GetMarkedCols{ write SetMarkedCols};
    property MarkedRows[AIndex: Longint]: TRCellsVector read GetMarkedRows{ write SetMarkedRows};
    property MarkedCells[AIndex: Longint]: TRCell read GetMarkedCells{ write SetMarkedCells};
    property MarkedCount: Longint read GetMarkedCount;

    property CellsUnions: TRCellsUnions read FCellsUnions;

  published
    property ColCount: Longint read GetColCount write SetColCount default 5;
    property RowCount: Longint read GetRowCount write SetRowCount default 5;

    property FixedCols: Integer read FFixedCols write SetFixedCols default 1;
    property FixedRows: Integer read FFixedRows write SetFixedRows default 1;
  end;
//----------------------------------------------------------------------------------------------------------------------
// TRCustomGrid
//----------------------------------------------------------------------------------------------------------------------
  TRFocusCellEvent       = procedure (Sender: TRCustomGrid; Cell: TRCell; var ACol: Longint; var ARow: Longint) of object;
  TRMovedEvent           = procedure (Sender: TRCustomGrid; FromIndex, ToIndex: Longint) of object;
  TRFixedCellClickEvent  = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint) of object;
  TRFixedCellCheckEvent  = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint; var Enabled: Boolean) of object;
  TRMarkVectorEvent      = procedure (Sender: TRCustomGrid; CellsVector: TRCellsVector; MarkValue: Boolean;  var CanMark: Boolean) of object;
  TRMarkCellEvent        = procedure (Sender: TRCustomGrid; Cell: TRCell; MarkValue: Boolean; var CanMark: Boolean) of object;
  TRFreeCellEvent        = procedure (Sender: TRCustomGrid; Cell: TRCell) of object;
  TRInitCellEvent        = procedure (Sender: TRCustomGrid; Cell: TRCell) of object;
  TRFreeVectorEvent      = procedure (Sender: TRCustomGrid; CellsVector: TRCellsVector) of object;
  TRInitVectorEvent      = procedure (Sender: TRCustomGrid; CellsVector: TRCellsVector) of object;
  TRBeforeDrawCellEvent  = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; Rect: TRect; var CustomDraw: Boolean) of object;
  TRDrawCellFieldEvent   = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; Rect: TRect; var CustomDraw: Boolean) of object;
  //TRGetCellTextEvent     = procedure (Sender: TRCustomGrid; Cell: TRCell; var CellText: string) of object;
  TRDrawCellTextEvent    = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; var Rect: TRect; var CellText: string; var Multiline: Boolean; var HorAlignment: TAlignment; var VertAlignment: TRVertAlignment) of object;
  //TRGetImageIndexEvent   = procedure (Sender: TRCustomGrid; Cell: TRCell; var ImageIndex: Longint) of object;
  TRDrawImageEvent       = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; var Rect: TRect; var ImageIndex: Longint; var HorAlignment: TAlignment; var VertAlignment: TRVertAlignment) of object;
  TRAfterDrawCellEvent   = procedure (Sender: TRCustomGrid; Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; Rect: TRect) of object;

  TRCustomGrid = class(TCustomControl)
  private
    FCurrentCell: TRCell; //     
  
    FCurrent: TRGridCoord;
    FTopLeft: TRGridCoord;
    FMarkingAnchor: TRGridCoord;
    FOldMarkingEnd: TRGridCoord;
    FKeyboardMarkRange: Boolean;

    FCurrentRect: TRGridRect;

    FColCount: Longint;
    FRowCount: Longint;

    FFixedCols: Longint;
    FFixedRows: Longint;

    FDefaultColWidth: Integer;
    FDefaultRowHeight: Integer;

    FSizingIndex: Longint;
    FSizingPos, FSizingOfs: Integer;

    FMoveIndex, FMovePos: Longint;

    FColOffset: Integer;

    FGridLineWidth: Integer;

    FColsEnumerator: Pointer;
    FRowsEnumerator: Pointer;

    FColors: TRGridColors; // class comprising all customizable colors in the tree
    FFonts: TRGridFonts;
    FHolder: TRCellsHolder;

    FMarkList: TList;

    FMarkCount: Longint;

    FOptions: TRGridOptions;
    FFocusFrameStyle: TRGridFocusFrameStyle;

    FBorderStyle: TBorderStyle;
    FScrollBars: TScrollStyle;

    FHitTest: TPoint;

    FOnColumnMoved: TRMovedEvent;
    FOnRowMoved: TRMovedEvent;
    FOnFocusCell: TRFocusCellEvent;
    FOnTopLeftChanged: TNotifyEvent;


    {  PrepereChangeSize  DoChangeSize}
    FOldDrawInfo: TRGridDrawInfo;
    FOldColCount: Longint;
    FOldRowCount: Longint;
    {. ...}

    //From TRxDrawGrid:
    FDrawBitmap: TBitmap;
    //FCellImage: TBitmap;

    FTracking: Boolean;
    FPressed: Boolean;
    FPressedCell: TRGridCoord;
    //FPressedRect: TRGridRect;

    FOnFixedCellClick: TRFixedCellClickEvent;
    FOnCheckButton: TRFixedCellCheckEvent;
    FOnColumnSized: TNotifyEvent;
    FOnRowSized: TNotifyEvent;
    FOnChangeFocus: TNotifyEvent;

    FOnMarkCol: TRMarkVectorEvent;
    FOnMarkRow: TRMarkVectorEvent;
    FOnMarkCell: TRMarkCellEvent;

    FOnFreeCell: TRFreeCellEvent;
    FOnInitCell: TRInitCellEvent;
    FOnFreeVector: TRFreeVectorEvent;
    FOnInitVector: TRInitVectorEvent;
    //FOnGetCellText: TRGetCellTextEvent;
    //FOnGetImageIndex: TRGetImageIndexEvent;
    FOnBeforeDrawCell: TRBeforeDrawCellEvent;
    FOnDrawCellField: TRDrawCellFieldEvent;
    FOnDrawImage: TRDrawImageEvent;
    FOnDrawCellText: TRDrawCellTextEvent;
    FOnAfterDrawCell: TRAfterDrawCellEvent;
    //FOnCompareRows: TRCompareRowsEvent;

    FImageChangeLink: TChangeLink;
    FImages: TCustomImageList;
    procedure ImageListChange(Sender: TObject);
    procedure SetImages(Value: TCustomImageList);

    procedure SetFocusFrameStyle(Value: TRGridFocusFrameStyle);
    procedure SetColors(const Value: TRGridColors);
    procedure SetFonts(const Value: TRGridFonts);
    function CalcCoordFromPoint(X, Y: Integer;  const DrawInfo: TRGridDrawInfo): TRGridCoord;
    procedure CalcDrawInfoXY(var DrawInfo: TRGridDrawInfo; UseWidth, UseHeight: Integer);
    function CalcMaxTopLeft(const Coord: TRGridCoord;  const DrawInfo: TRGridDrawInfo): TRGridCoord;
    procedure CancelMode;

    procedure PrepareChangeSize;
    procedure DoChangeSize;

    procedure ClampInView(const Coord: TRGridCoord);
    procedure DrawSizingLine(const DrawInfo: TRGridDrawInfo);
    procedure DrawMove;
    procedure GridRectToScreenRect(GridRect: TRGridRect; var ScreenRect: TRect; IncludeLine: Boolean);
    procedure Initialize;
    procedure InvalidateRect(ARect: TRGridRect);
    procedure ModifyScrollBar(ScrollBar, ScrollCode, Pos: Cardinal; UseRightToLeft: Boolean);
    procedure MoveAdjust(var CellPos: Longint; FromIndex, ToIndex: Longint);
    procedure MoveAndScroll(Mouse, CellHit: Integer; var DrawInfo: TRGridDrawInfo; var Axis: TRGridAxisDrawInfo; Scrollbar: Integer; const MousePt: TPoint);
    procedure MoveCurrent(ACol, ARow: Longint; Show: Boolean);

    procedure RefreshCurrentRect;

    procedure MoveTopLeft(ALeft, ATop: Longint);
    procedure ResizeCol(Index: Longint; OldSize, NewSize: Integer);
    procedure ResizeRow(Index: Longint; OldSize, NewSize: Integer);
    procedure ScrollDataInfo(DX, DY: Integer; var DrawInfo: TRGridDrawInfo);
    procedure TopLeftMoved(const OldTopLeft: TRGridCoord);
    procedure UpdateScrollPos;
    procedure UpdateScrollRange;
    function GetColWidths(Index: Longint): Integer;
    function GetRowHeights(Index: Longint): Integer;
    function GetVisibleColCount: Integer;
    function GetVisibleRowCount: Integer;
    function IsActiveControl: Boolean;
    function HasFocus: Boolean;

    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetCol(Value: Longint);
    procedure SetRow(Value: Longint);

    function GetCols(ACol: Longint) :TRCellsVector;
    function GetRows(ARow: Longint) :TRCellsVector;
    function GetCells(ACol, ARow: Longint) :TRCell;

    //procedure SetMarkedCols(ACol: Longint; Value: Boolean);
    function GetMarkedCols(AIndex: Longint): TRCellsVector;

    //procedure SetMarkedRows(ARow: Longint; Value: Boolean);
    function GetMarkedRows(AIndex: Longint): TRCellsVector;

    //procedure SetMarkedCells(ACol, ARow: Longint; Value: Boolean);
    function GetMarkedCells(AIndex: Longint): TRCell;

    function GetMarkedCount: Longint;
    {
    function GetColsText(ACol: Longint) :string;
    function GetRowsText(ARow: Longint) :string;
    }

    procedure SetDefaultColWidth(Value: Integer);
    procedure SetDefaultRowHeight(Value: Integer);

    procedure SetColWidths(Index: Longint; Value: Integer);
    procedure SetRowHeights(Index: Longint; Value: Integer);

    procedure SetGridLineWidth(Value: Integer);
    procedure SetLeftCol(Value: Longint);
    procedure SetOptions(Value: TRGridOptions);

    procedure SetScrollBars(Value: TScrollStyle);

    procedure SetTopRow(Value: Longint);

    procedure CMCancelMode(var Msg: TMessage); message CM_CANCELMODE;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure CMDesignHitTest(var Msg: TCMDesignHitTest); message CM_DESIGNHITTEST;
    procedure CMWantSpecialKey(var Msg: TCMWantSpecialKey); message CM_WANTSPECIALKEY;
    procedure CMShowingChanged(var Message: TMessage); message CM_SHOWINGCHANGED;
    procedure WMChar(var Msg: TWMChar); message WM_CHAR;
    procedure WMCancelMode(var Msg: TWMCancelMode); message WM_CANCELMODE;
    procedure WMGetDlgCode(var Msg: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure WMHScroll(var Msg: TWMHScroll); message WM_HSCROLL;
    procedure WMKillFocus(var Msg: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMLButtonDown(var Message: TMessage); message WM_LBUTTONDOWN;
    procedure WMNCHitTest(var Msg: TWMNCHitTest); message WM_NCHITTEST;
    procedure WMSetCursor(var Msg: TWMSetCursor); message WM_SETCURSOR;
    procedure WMSetFocus(var Msg: TWMSetFocus); message WM_SETFOCUS;
    procedure WMSize(var Msg: TWMSize); message WM_SIZE;
    procedure WMTimer(var Msg: TWMTimer); message WM_TIMER;
    procedure WMVScroll(var Msg: TWMVScroll); message WM_VSCROLL;


    procedure ChangeMarkRange;
    //From RxDrawGrid:
    procedure DoFixedCellClick(ACol, ARow: Longint); dynamic;
    procedure CheckFixedCellButton(ACol, ARow: Longint; var Enabled: Boolean); dynamic;
    procedure StopTracking;
    procedure TrackButton(X, Y: Integer);
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;

    //     RxLib (VclUtils.pas)
    function PaletteColor(Color: TColor): Longint;
    procedure DrawBitmapTransparent(Dest: TCanvas; DstX, DstY: Integer; Bitmap: TBitmap; TransparentColor: TColor);
    procedure StretchBitmapTransparent(Dest: TCanvas; Bitmap: TBitmap; TransparentColor: TColor; DstX, DstY, DstW, DstH, SrcX, SrcY, SrcW, SrcH: Integer);
    procedure StretchBltTransparent(DstDC: HDC; DstX, DstY, DstW, DstH: Integer; SrcDC: HDC; SrcX, SrcY, SrcW, SrcH: Integer; Palette: HPalette; TransparentColor: TColorRef);
    procedure DrawCellTextEx(const S: string; {const }ARect: TRect; Align: TAlignment; VertAlign: TRVertAlignment; WordWrap: Boolean);
    //procedure WriteText({ACanvas: TCanvas;} ARect: TRect; DX, DY: Integer; const Text: string; Alignment: TAlignment; WordWrap: Boolean);

  protected
    FGridState: TRGridState;
    DesignOptionsBoost: TRGridOptions;
    VirtualView: Boolean;
    FRecursionTrap: Boolean;

    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    procedure CalcDrawInfo(var DrawInfo: TRGridDrawInfo);
    procedure CalcFixedInfo(var DrawInfo: TRGridDrawInfo);
    procedure CalcSizingState(X, Y: Integer; var State: TRGridState;
      var Index: Longint; var SizingPos, SizingOfs: Integer;
      var FixedInfo: TRGridDrawInfo); virtual;
    procedure ChangeGridOrientation(RightToLeftOrientation: Boolean);
    procedure CreateParams(var Params: TCreateParams); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    function BoxRect(ALeft, ATop, ARight, ABottom: Longint): TRect;
    procedure DoExit; override;
    function CanGridAcceptKey(Key: Word; Shift: TShiftState): Boolean; dynamic;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    procedure FocusCell(ACol, ARow: Longint; MoveAnchor: Boolean);
    function GetGridWidth: Integer;
    function GetGridHeight: Integer;
    procedure InvalidateGrid;
    procedure MoveColumn(FromIndex, ToIndex: Longint);
    procedure MoveRow(FromIndex, ToIndex: Longint);
    procedure MoveColRow(ACol, ARow: Longint; MoveAnchor, Show: Boolean);
    procedure SizeChanged(OldColCount, OldRowCount: Longint); dynamic;
    function Sizing(X, Y: Integer): Boolean;
    procedure ScrollData(DX, DY: Integer);
    {
    procedure InvalidateCell(ACol, ARow: Longint);
    procedure InvalidateCol(ACol: Longint);
    procedure InvalidateRow(ARow: Longint);
    }
    procedure TimedScroll(Direction: TRGridScrollDirection); dynamic;
    procedure Paint; override;
    procedure ColWidthsChanged; dynamic;
    procedure RowHeightsChanged; dynamic;
    procedure UpdateDesigner;
    function BeginColumnDrag(var Origin, Destination: Integer;
      const MousePt: TPoint): Boolean; dynamic;
    function BeginRowDrag(var Origin, Destination: Integer;
      const MousePt: TPoint): Boolean; dynamic;
    function CheckColumnDrag(var Origin, Destination: Integer;
      const MousePt: TPoint): Boolean; dynamic;
    function CheckRowDrag(var Origin, Destination: Integer;
      const MousePt: TPoint): Boolean; dynamic;
    function EndColumnDrag(var Origin, Destination: Integer;
      const MousePt: TPoint): Boolean; dynamic;
    function EndRowDrag(var Origin, Destination: Integer;
      const MousePt: TPoint): Boolean; dynamic;

    function  DoMarkCol(CellsVector: TRCellsVector; MarkValue: Boolean): Boolean; virtual;
    function  DoMarkRow(CellsVector: TRCellsVector; MarkValue: Boolean): Boolean; virtual;
    function  DoMarkCell(Cell: TRCell; MarkValue: Boolean): Boolean; virtual;

    procedure DoInitCell(Cell: TRCell); virtual;
    procedure DoFreeCell(Cell: TRCell); virtual;
    procedure DoInitCellsVector(CellsVector: TRCellsVector);
    procedure DoFreeCellsVector(CellsVector: TRCellsVector);
    //procedure DoGetImageIndex(Cell: TRCell; var ImageIndex: Longint); virtual;
    //procedure DoGetCellText(Cell: TRCell; var CellText: string); virtual;
    function  DoBeforeDrawCell(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; CellRect: TRect): Boolean; virtual;
    function  DoDrawCellField(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; Rect: TRect): Boolean; virtual;
    procedure DoDrawImage(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; var Rect: TRect; var ImageIndex: Longint; var HorAlignment: TAlignment; var VertAlignment: TRVertAlignment); virtual;
    procedure DoDrawCellText(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; var Rect: TRect; var CellText: string; var Multiline: Boolean; var HorAlignment: TAlignment; var VertAlignment: TRVertAlignment); virtual;
    procedure DoAfterDrawCell(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; CellRect: TRect); virtual;
    //function  DoCompareRows(Row1, Row2: Pointer{TRCellsVector}): Integer; virtual;   
    //DoCompareRows: TListSortCompare;

    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsSingle;
    property FocusFrameStyle: TRGridFocusFrameStyle read FFocusFrameStyle write SetFocusFrameStyle;// default rffDotRect;
    property Colors: TRGridColors read FColors write SetColors;
    property Fonts: TRGridFonts read FFonts write SetFonts;
    property Col: Longint read FCurrent.X write SetCol;
    property Row: Longint read FCurrent.Y write SetRow;
    
    property ColCount: Longint read FColCount;
    property RowCount: Longint read FRowCount;

    property DefaultColWidth: Integer read FDefaultColWidth write SetDefaultColWidth default 64;
    property DefaultRowHeight: Integer read FDefaultRowHeight write SetDefaultRowHeight default 24;
    property FixedCols: Integer read FFixedCols;
    property FixedRows: Integer read FFixedRows;



    property GridHeight: Integer read GetGridHeight;
    property GridLineWidth: Integer read FGridLineWidth write SetGridLineWidth default 1;
    property GridWidth: Integer read GetGridWidth;
    property HitTest: TPoint read FHitTest;
    property LeftCol: Longint read FTopLeft.X write SetLeftCol;
    property Options: TRGridOptions read FOptions write SetOptions default [rgoFixedVertLine, rgoFixedHorzLine, rgoVertLine, rgoHorzLine];
    property ParentColor default False;   //   Colors.BakgroundColor



    property ScrollBars: TScrollStyle read FScrollBars write SetScrollBars default ssBoth;
    property TopRow: Longint read FTopLeft.Y write SetTopRow;
    property VisibleColCount: Integer read GetVisibleColCount;
    property VisibleRowCount: Integer read GetVisibleRowCount;

    procedure DoColumnMoved(FromIndex, ToIndex: Longint); dynamic;
    procedure DoRowMoved(FromIndex, ToIndex: Longint); dynamic;
    //function DoCanFocusCell(ACol, ARow: Longint): Boolean; virtual;
    procedure DoCanFocusCell(var ACol: Longint; var ARow: Longint); virtual;

    procedure TopLeftChanged; dynamic;
    property OnColumnMoved: TRMovedEvent read FOnColumnMoved write FOnColumnMoved;
    property OnRowMoved: TRMovedEvent read FOnRowMoved write FOnRowMoved;
    property OnFocusCell: TRFocusCellEvent read FOnFocusCell write FOnFocusCell;
    property OnTopLeftChanged: TNotifyEvent read FOnTopLeftChanged write FOnTopLeftChanged;

    property OnCheckButton: TRFixedCellCheckEvent read FOnCheckButton write FOnCheckButton;
    property OnFixedCellClick: TRFixedCellClickEvent read FOnFixedCellClick write FOnFixedCellClick;
    property OnColumnSized: TNotifyEvent read FOnColumnSized write FOnColumnSized;
    property OnRowSized: TNotifyEvent read FOnRowSized write FOnRowSized;
    property OnChangeFocus: TNotifyEvent read FOnChangeFocus write FOnChangeFocus;

    property OnMarkCol: TRMarkVectorEvent read FOnMarkCol write FOnMarkCol;
    property OnMarkRow: TRMarkVectorEvent read FOnMarkRow write FOnMarkRow;
    property OnMarkCell: TRMarkCellEvent read FOnMarkCell write FOnMarkCell;

    property OnFreeCell: TRFreeCellEvent read FOnFreeCell write FOnFreeCell;
    property OnInitCell: TRInitCellEvent read FOnInitCell write FOnInitCell;

    property OnFreeCellsVector: TRFreeVectorEvent read FOnFreeVector write FOnFreeVector;
    property OnInitCellsVector: TRInitVectorEvent read FOnInitVector write FOnInitVector;

    //property OnGetCellText: TRGetCellTextEvent read FOnGetCellText write FOnGetCellText;
    //property OnGetImageIndex: TRGetImageIndexEvent read FOnGetImageIndex write FOnGetImageIndex;
    property OnDrawCellField: TRDrawCellFieldEvent read FOnDrawCellField write FOnDrawCellField;
    property OnDrawCellText: TRDrawCellTextEvent read FOnDrawCellText write FOnDrawCellText;
    property OnDrawImage: TRDrawImageEvent read FOnDrawImage write FOnDrawImage;
    property OnBeforeDrawCell: TRBeforeDrawCellEvent read FOnBeforeDrawCell write FOnBeforeDrawCell;
    property OnAfterDrawCell: TRAfterDrawCellEvent read FOnAfterDrawCell write FOnAfterDrawCell;
    //property OnCompareRows: TRCompareRowsEvent read FOnCompareRows write FOnCompareRows;

    property Holder: TRCellsHolder read FHolder write FHolder;
    property Cols[ACol: Longint]: TRCellsVector read GetCols;
    property Rows[ARow: Longint]: TRCellsVector read GetRows;
    property Cells[ACol, ARow: Longint]: TRCell read GetCells;
    {
    property ColsText[ACol: Longint]: string read GetColsText;
    property RowsText[ARow: Longint]: string read GetRowsText;
    }
    property MarkedCols[AIndex: Longint]: TRCellsVector read GetMarkedCols{ write SetMarkedCols};
    property MarkedRows[AIndex: Longint]: TRCellsVector read GetMarkedRows{ write SetMarkedRows};
    property MarkedCells[AIndex: Longint]: TRCell read GetMarkedCells{ write SetMarkedCells};
    property MarkedCount: Longint read GetMarkedCount;

    property ColWidths[Index: Longint]: Integer read GetColWidths write SetColWidths;
    property RowHeights[Index: Longint]: Integer read GetRowHeights write SetRowHeights;

    property Images: TCustomImageList read FImages write SetImages;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure InvalidateCell(ACol, ARow: Longint);
    procedure InvalidateCol(ACol: Longint);
    procedure InvalidateRow(ARow: Longint);
    
    function CellRect(ACol, ARow: Longint): TRect;
    function UnionRect(ACol, ARow: Longint): TRect;
    function MouseCoord(X, Y: Integer): TRGridCoord;
    procedure MouseToCell(X, Y: Integer; var ACol, ARow: Longint); //   MouseCoord

    function GridToHolderCol(ACol: Longint): Longint;
    function GridToHolderRow(ARow: Longint): Longint;
    function GridToHolderCell(ACoord: TRGridCoord): TRGridCoord;

    //procedure DrawStr(ARect: TRect; const S: string; Align: TAlignment);
    //procedure DrawMultiline(ARect: TRect; const S: string; Align: TAlignment);
    //procedure DrawPicture(ARect: TRect; Graphic: TGraphic);
    procedure DrawMaskedBitmap(ARect: TRect; X, Y: Integer; Graphic: TBitmap);
    procedure DrawCellText(const S: string; {const }ARect: TRect; Align: TAlignment; VertAlign: TRVertAlignment; WordWrap: Boolean);

  published
    property TabStop default True;
  end;
//----------------------------------------------------------------------------------------------------------------------
// TRGrid
//----------------------------------------------------------------------------------------------------------------------
  TRGrid = class(TRCustomGrid)
  public
    property Canvas;
    property Col;
    property ColWidths;
    property GridHeight;
    property GridWidth;
    property LeftCol;
    property Row;
    property RowHeights;
    property TopRow;
    property MarkedCols;
    property MarkedRows;
    property MarkedCells;

    property Cols;
    property Rows;
    property Cells;
    {
    property ColsText;
    property RowsText;
    }
  published
    property Align;
    property Anchors;
    property BiDiMode;
    property BorderStyle;
    property Colors;
    property Fonts;
    property Holder;
    property Images;
    property ColCount;
    property RowCount;
    property FixedCols;
    property FixedRows;
    property DefaultColWidth;
    property DefaultRowHeight;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusFrameStyle;
    property GridLineWidth;
    property Options;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ScrollBars;
    property ShowHint;
    property TabOrder;
    property Visible;
    property VisibleColCount;
    property VisibleRowCount;
    property OnClick;
    property OnColumnMoved;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
    property OnRowMoved;
    property OnFocusCell;
    property OnStartDock;
    property OnStartDrag;
    property OnTopLeftChanged;

    property OnMarkCol;
    property OnMarkRow;
    property OnMarkCell;

    property OnFreeCell;
    property OnInitCell;

    property OnFreeCellsVector;
    property OnInitCellsVector;
    //property OnGetCellText;
    //property OnGetImageIndex;
    property OnDrawCellField;
    property OnDrawCellText;
    property OnDrawImage;
    property OnBeforeDrawCell;
    property OnAfterDrawCell;
    //property OnCompareRows;

    property OnCheckButton;
    property OnFixedCellClick;
    property OnColumnSized;
    property OnRowSized;
    property OnChangeFocus;
  end;

procedure Register;  
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
implementation

uses Types;
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
// .  'RvaLib'       ,     RGrids
procedure Register;
begin
  RegisterComponents('RvaLib', [TRGrid]);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure InvalidOp(const id: string);
begin
  raise ERInvalidGridOperation.Create(id);
end;
//----------------------------------------------------------------------------------------------------------------------
function GridRect(Coord1, Coord2: TRGridCoord): TRGridRect;
begin
  with Result do
  begin
    Left := Coord2.X;
    if Coord1.X < Coord2.X then Left := Coord1.X;
    Right := Coord1.X;
    if Coord1.X < Coord2.X then Right := Coord2.X;
    Top := Coord2.Y;
    if Coord1.Y < Coord2.Y then Top := Coord1.Y;
    Bottom := Coord1.Y;
    if Coord1.Y < Coord2.Y then Bottom := Coord2.Y;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function PointInGridRect(Col, Row: Longint; const Rect: TRGridRect): Boolean;
begin
  Result := (Col >= Rect.Left) and (Col <= Rect.Right) and (Row >= Rect.Top)
    and (Row <= Rect.Bottom);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure XorRects(const R1, R2: TRect; var XorRects: TXorRects);
var
  Intersect, Union: TRect;

  function PtInRect(X, Y: Integer; const Rect: TRect): Boolean;
  begin
    with Rect do Result := (X >= Left) and (X <= Right) and (Y >= Top) and
      (Y <= Bottom);
  end;

  function Includes(const P1: TPoint; var P2: TPoint): Boolean;
  begin
    with P1 do
    begin
      Result := PtInRect(X, Y, R1) or PtInRect(X, Y, R2);
      if Result then P2 := P1;
    end;
  end;

  function Build(var R: TRect; const P1, P2, P3: TPoint): Boolean;
  begin
    Build := True;
    with R do
      if Includes(P1, TopLeft) then
      begin
        if not Includes(P3, BottomRight) then BottomRight := P2;
      end
      else if Includes(P2, TopLeft) then BottomRight := P3
      else Build := False;
  end;

begin
  FillChar(XorRects, SizeOf(XorRects), 0);
  if not Bool(IntersectRect(Intersect, R1, R2)) then
  begin
    { Don't intersect so its simple }
    XorRects[0] := R1;
    XorRects[1] := R2;
  end
  else
  begin
    UnionRect(Union, R1, R2);
    if Build(XorRects[0],
      Point(Union.Left, Union.Top),
      Point(Union.Left, Intersect.Top),
      Point(Union.Left, Intersect.Bottom)) then
      XorRects[0].Right := Intersect.Left;
    if Build(XorRects[1],
      Point(Intersect.Left, Union.Top),
      Point(Intersect.Right, Union.Top),
      Point(Union.Right, Union.Top)) then
      XorRects[1].Bottom := Intersect.Top;
    if Build(XorRects[2],
      Point(Union.Right, Intersect.Top),
      Point(Union.Right, Intersect.Bottom),
      Point(Union.Right, Union.Bottom)) then
      XorRects[2].Left := Intersect.Right;
    if Build(XorRects[3],
      Point(Union.Left, Union.Bottom),
      Point(Intersect.Left, Union.Bottom),
      Point(Intersect.Right, Union.Bottom)) then
      XorRects[3].Top := Intersect.Bottom;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function CrossedRects(Rect1, Rect2: TRGridRect): Boolean;
begin
  Result := (((Rect1.Left >= Rect2.Left) and (Rect1.Left <= Rect2.Right))
              or ((Rect1.Right >= Rect2.Left) and (Rect1.Right <= Rect2.Right))
              or((Rect2.Left >= Rect1.Left) and (Rect2.Left <= Rect1.Right))
              or ((Rect2.Right >= Rect1.Left) and (Rect2.Right <= Rect1.Right)))
            and
            (((Rect1.Top >= Rect2.Top) and (Rect1.Top <= Rect2.Bottom))
              or ((Rect1.Bottom >= Rect2.Top) and (Rect1.Bottom <= Rect2.Bottom))
              or ((Rect2.Top >= Rect1.Top) and (Rect2.Top <= Rect1.Bottom))
              or ((Rect2.Bottom >= Rect1.Top) and (Rect2.Bottom <= Rect1.Bottom)));
end;
//----------------------------------------------------------------------------------------------------------------------
//  TRGridColors
//----------------------------------------------------------------------------------------------------------------------
constructor TRGridColors.Create(AOwner: TRCustomGrid);
begin
  FOwner := AOwner;

  FColors[0]  := clBtnFace;     //BakgroundFieldColor
  FColors[1]  := clSkyBlue;     //CurColRowColorNotMark
  FColors[2]  := clMoneyGreen;  //CurColRowColorMark
  FColors[3]  := $00D9CEBD;     //CurColRowColorNotMarkUnActive
  FColors[4]  := $00C8D5C8;     //CurColRowColorMarkUnActive
  FColors[5]  := clWindow;      //DefaultCellColor1NotMark
  FColors[6]  := $00EFEFEF;     //DefaultCellColor2NotMark
  FColors[7]  := clGreen;       //DefaultCellColorMark
  FColors[8]  := $00638365;     //DefaultCellColorMarkUnActive
  FColors[9]  := clHighlight;   //FocusCellColorNotMark
  FColors[10] := clTeal;        //FocusCellColorMark
  FColors[11] := $00917064;     //FocusCellColorNotMarkUnActive
  FColors[12] := $005B7D5E;     //FocusCellColorMarkUnActive
  FColors[13] := clSkyBlue;     //FocusFrameColorNotMark
  FColors[14] := clMoneyGreen;  //FocusFrameColorMark
  FColors[15] := clBtnFace;     //FixedButtonsColor
  FColors[16] := clBtnShadow;   //GridLineColor

  RefreshColors();
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridColors.GetColor(const Index: Integer): TColor;
begin
  Result := FColors[Index];
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRGridColors.SetColor(const Index: Integer; const Value: TColor);
begin
  if (FColors[Index] <> Value) then
  begin
    FColors[Index] := Value;

    if (Index = 1) or (Index = 2) or (Index = 3) or (Index = 4) or (Index = 13) or (Index = 14) then
      RefreshColors;

    if not (csLoading in FOwner.ComponentState) and FOwner.HandleAllocated then
    begin
      FOwner.InvalidateGrid;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRGridColors.RefreshColors;
begin
  if (rgoAutoColorCurColRow in FOwner.FOptions) then
  begin
    //_CurColRowColorNotMark
    FColors[17] := AutoColor(DefaultCellColor1NotMark, FocusCellColorNotMark);
    //_CurColRowColorMark
    FColors[18] := AutoColor(DefaultCellColor1NotMark, DefaultCellColorMark);
    //_CurColRowColorNotMarkUnActive
    FColors[19] := AutoColor(DefaultCellColor1NotMark, FocusCellColorNotMarkUnActive);
    //_CurColRowColorMarkUnActive
    FColors[20] := AutoColor(DefaultCellColor1NotMark, DefaultCellColorMarkUnActive);
    //_FocusFrameColorNotMark
    FColors[21] := AutoColor(DefaultCellColor1NotMark, FocusCellColorNotMark);
    //_FocusFrameColorMark
    FColors[22] := AutoColor(DefaultCellColor1NotMark, DefaultCellColorMark);
  end
  else
  begin
    //_CurColRowColorNotMark
    FColors[17] := CurColRowColorNotMark;
    //_CurColRowColorMark
    FColors[18] := CurColRowColorMark;
    //_CurColRowColorNotMarkUnActive
    FColors[19] := CurColRowColorNotMarkUnActive;
    //_CurColRowColorMarkUnActive
    FColors[20] := CurColRowColorMarkUnActive;
    //_FocusFrameColorNotMark
    FColors[21] := FocusFrameColorNotMark;
    //_FocusFrameColorMark
    FColors[22] := FocusFrameColorMark;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRGridColors.Assign(Source: TPersistent);
begin
  if Source is TRGridColors then
  begin
    FColors := TRGridColors(Source).FColors;
    FOwner.InvalidateGrid;
  end
  else
    inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridColors.AutoColor(Color1, Color2: TColor): TColor;
var
  RGBColor, RGBMaskColor: Integer;

begin
  RGBColor := ColorToRGB(Color1);
  RGBMaskColor := ColorToRGB(Color2);
    
  Result := TColor(RGB(max(GetRValue(RGBColor),GetRValue(RGBMaskColor))-abs(GetRValue(RGBColor)-GetRValue(RGBMaskColor)) div 4, max(GetGValue(RGBColor),GetGValue(RGBMaskColor))-abs(GetGValue(RGBColor)-GetGValue(RGBMaskColor)) div 4, max(GetBValue(RGBColor),GetBValue(RGBMaskColor))-abs(GetBValue(RGBColor)-GetBValue(RGBMaskColor)) div 4)); 
end;
//----------------------------------------------------------------------------------------------------------------------
// TRGridFonts
//----------------------------------------------------------------------------------------------------------------------
constructor TRGridFonts.Create(AOwner: TRCustomGrid);
var
  k: Integer;
begin
  for k := 0 to 12 do
  begin
    FFonts[k] := TFont.Create();

    TFont(FFonts[k]).Name := 'Tahoma';
    TFont(FFonts[k]).Size := 8;

    case k of
      0:  //CurColRowFontNotMark
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;

      1:  //CurColRowFontMark
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;

      2:  //CurColRowFontNotMarkUnActive
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;

      3:  //CurColRowFontMarkUnActive
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;

      4:  //DefaultCellFont1NotMark
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;

      5:  //DefaultCellFont2NotMark
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;

      6:  //DefaultCellFontMark
      begin
        TFont(FFonts[k]).Color := clHighlightText;
        TFont(FFonts[k]).Style := [fsBold];
      end;

      7:  //DefaultCellFontMarkUnActive
      begin
        TFont(FFonts[k]).Color := clHighlightText;
        TFont(FFonts[k]).Style := [fsBold];
      end;

      8:  //FocusCellFontNotMark
      begin
        TFont(FFonts[k]).Color := clHighlightText;
        TFont(FFonts[k]).Style := [fsBold];
      end;

      9:  //FocusCellFontMark
      begin
        TFont(FFonts[k]).Color := clHighlightText;
        TFont(FFonts[k]).Style := [fsBold];
      end;

      10: //FocusCellFontNotMarkUnActive
      begin
        TFont(FFonts[k]).Color := clHighlightText;
        TFont(FFonts[k]).Style := [fsBold];
      end;

      11: //FocusCellFontMarkUnActive
      begin
        TFont(FFonts[k]).Color := clHighlightText;
        TFont(FFonts[k]).Style := [fsBold];
      end;

      12: //FixedButtonsFont
      begin
        TFont(FFonts[k]).Color := clWindowText;
        TFont(FFonts[k]).Style := [];
      end;
    end;

  end;
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRGridFonts.Destroy; 
var
  k: Integer;
begin
  for k := 0 to 12 do
  begin
    TFont(FFonts[k]).Free();
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridFonts.GetFont(const Index: Integer): TFont;
begin
  Result := FFonts[Index];
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRGridFonts.SetFont(const Index: Integer; const Value: TFont);
begin
  if (FFonts[Index] <> Value) then
  begin
    TFont(FFonts[Index]).Assign(Value);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRGridFonts.Assign(Source: TPersistent);
var
  k: Integer;
begin
  if Source is TRGridFonts then
  begin
    for k := 0 to 12 do
    begin
      TFont(FFonts[k]).Assign(TFont(TRGridFonts(Source).FFonts[k]));
    end;
    if not (csDesigning in FOwner.ComponentState) then
      FOwner.InvalidateGrid;
  end
  else
    inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
// TRCell
//----------------------------------------------------------------------------------------------------------------------
constructor TRCell.Create(AColOwner, ARowOwner: TRCellsVector{; AVisible: Boolean});
begin
  FColOwner := AColOwner;
  FRowOwner := ARowOwner;

  FCellsUnion := NIL;
  FGridUnionIndex := -1;

  FMarked := False;
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRCell.Destroy;
begin
  FRowOwner.FOwner.FOwner.DoFreeCell(Self);
  inherited Destroy;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetHolderCol: Longint;
begin
  Result := FColOwner.FHolderIndex;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetHolderRow: Longint;
begin
  Result := FRowOwner.FHolderIndex;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetGridCol: Longint;
begin
  Result := FColOwner.FGridIndex;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetGridRow: Longint;
begin
  Result := FRowOwner.FGridIndex;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetBelongsToUnion: Boolean;
begin
  Result := (FCellsUnion <> NIL);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetUnioned: Boolean;
begin
  if (FCellsUnion <> NIL) then
  begin
    if (FGridUnionIndex > -1) and (FGridUnionIndex < FCellsUnion.FGridUnionList.Count) then
      Result := True
    else
      Result := False;
  end
  else
    Result := False;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetMarked: Boolean;
begin
  Result := FMarked;

  if (not Result) then
  begin
    if (FCellsUnion <> NIL) then
      Result := FCellsUnion.Marked;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCell.GetGridUnion: TRGridUnion;
begin
  if Unioned then
    Result := TRGridUnion(FCellsUnion.GridUnions[FGridUnionIndex])
  else
    Result := NIL;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCell.SetMarked(Value: Boolean);
var
  CanMark: Boolean;
begin
  if (rgoCellsMarking in FRowOwner.FOwner.FOwner.FOptions) then
  begin
    if (FMarked <> Value) then
    begin
      if (not TRCellsVector(FColOwner).FFixed) and (not TRCellsVector(FRowOwner).FFixed) then
      begin
        if (FCellsUnion <> NIL{Unioned}) then
        begin
          FCellsUnion.Marked := Value;
          //FCellsUnion.SetMarked(Value);
        end
        else
        begin
          CanMark := FRowOwner.FOwner.FOwner.DoMarkCell(Self, Value);

          if CanMark then
          begin
            FMarked := Value;

            FRowOwner.FOwner.FNeedReGenerateMarks := True;

            if (Value) then
            begin
              Inc(FRowOwner.FOwner.FMarkCount);
              if (FRowOwner.FVisible and FColOwner.FVisible) then
              begin
                Inc(FRowOwner.FOwner.FOwner.FMarkCount);
              end;
            end
            else
            begin
              Dec(FRowOwner.FOwner.FMarkCount);
              if (FRowOwner.FVisible and FColOwner.FVisible) then
              begin
                Dec(FRowOwner.FOwner.FOwner.FMarkCount);
              end;
            end;
            {
            if (FColOwner.FGridIndex >= FRowOwner.FOwner.FOwner.FTopLeft.X)
              and (FColOwner.FGridIndex <= FRowOwner.FOwner.FOwner.FTopLeft.X + FRowOwner.FOwner.FOwner.VisibleColCount)
              and (TRCellsVector(FRowOwner).FGridIndex >= FRowOwner.FOwner.FOwner.FTopLeft.Y)
              and (TRCellsVector(FRowOwner).FGridIndex <= FRowOwner.FOwner.FOwner.FTopLeft.Y + FRowOwner.FOwner.FOwner.VisibleRowCount) then
            begin
              FRowOwner.FOwner.FOwner.InvalidateCell(TRCellsVector(FColOwner).FGridIndex, TRCellsVector(FRowOwner).FGridIndex);
            end;
            }
            if (TRCellsVector(FColOwner).FVisible) and (TRCellsVector(FRowOwner).FVisible) then
            begin
              FRowOwner.FOwner.FOwner.InvalidateCell(TRCellsVector(FColOwner).FGridIndex, TRCellsVector(FRowOwner).FGridIndex);
            end;
          end;
        end;
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
{
function TRCell.GetText: string;
begin
  Result := '';

  FRowOwner.FOwner.FOwner.DoGetCellText(self, Result);
end;
}
//----------------------------------------------------------------------------------------------------------------------
// TRCellsVector
//----------------------------------------------------------------------------------------------------------------------
constructor TRCellsVector.Create(AOwner: TRCellsHolder; AIsColumn, AFixed, AVisible: Boolean; ASize: Integer; ACellsList: TList);
begin
  FOwner := AOwner;
  FIsColumn := AIsColumn;
  FFixed := AFixed;
  FVisible := AVisible;
  FSize := ASize;
  FCellsList := ACellsList;

  FMarked := False;
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRCellsVector.Destroy;
var
  k: Longint;
begin
  if FCellsList <> Nil then
  begin
    for k:= 0 to FCellsList.Count - 1  do
    begin
      TRCell(FCellsList[k]).Free;
    end;
    FCellsList.Free;
  end;

  FOwner.FOwner.DoFreeCellsVector(TRCellsVector(Self));

  inherited Destroy;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsVector.SetSize(Value: Integer);
begin
  if FSize <> Value then
  begin
    FSize := Value;

    // -  Grid  !!!
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
{
function TRCellsVector.GetCells(CellIndex: Longint): TRCell;
begin
  if FIsColumn then
    Result := FOwner.GetCells(FHolderIndex, CellIndex)
  else
    Result := FOwner.GetCells(CellIndex, FHolderIndex);
end;
}
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsVector.SetMarked(Value: Boolean);
var
  CanMark: Boolean;

begin
  if FIsColumn then
  begin
    if (rgoColsMarking in FOwner.FOwner.FOptions) then
    begin
      if (not FFixed) then
      begin
        if (FMarked <> Value) then
        begin
          CanMark := FOwner.FOwner.DoMarkCol(Self, Value);

          if CanMark then
          begin
            FMarked := Value;

            FOwner.FNeedReGenerateMarks := True;

            if (Value) then
            begin
              Inc(FOwner.FMarkCount);
              if (FVisible) then
              begin
                Inc(FOwner.FOwner.FMarkCount);
              end;
            end
            else
            begin
              Dec(FOwner.FMarkCount);
              if (FVisible) then
              begin
                Dec(FOwner.FOwner.FMarkCount);
              end;
            end;

            FOwner.FCellsUnions.TryChangeMarked(Self, Value);

            if FVisible then
            begin
              FOwner.FOwner.InvalidateCol(FGridIndex);
            end;
          end;
        end;
      end;
    end;
  end
  else
  begin
    if (rgoRowsMarking in FOwner.FOwner.FOptions) then
    begin
      if (not FFixed) then
      begin
        if FMarked <> Value then
        begin
          CanMark := FOwner.FOwner.DoMarkRow(Self, Value);

          if CanMark then
          begin
            FMarked := Value;

            FOwner.FNeedReGenerateMarks := True;

            if (Value) then
            begin
              Inc(FOwner.FMarkCount);
              if (FVisible) then
              begin
                Inc(FOwner.FOwner.FMarkCount);
              end;
            end
            else
            begin
              Dec(FOwner.FMarkCount);
              if (FVisible) then
              begin
                Dec(FOwner.FOwner.FMarkCount);
              end;
            end;

            FOwner.FCellsUnions.TryChangeMarked(Self, Value);

            if FVisible then
            begin
              FOwner.FOwner.InvalidateRow(FGridIndex);
            end;
          end;
        end;
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsVector.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    //    
    FOwner.FOwner.FCurrentCell := FOwner.Cells[FOwner.FOwner.Col, FOwner.FOwner.Row];
  
    FOwner.FOwner.PrepareChangeSize;

    FVisible := Value;

    //FOwner.FCellsUnions.TrySetMarked(Self, FMarked);     ,
    //..  EnumerateCols(Rows)   FCellsUnions.Refresh()

    FOwner.FOwner.VirtualView := True; //???

    if FIsColumn then
    begin
      FOwner.EnumerateCols;

      {
      if (FOwner.FOwner.FCurrent.X < FOwner.FOwner.FFixedCols) then
        FOwner.FOwner.FCurrent.X := FOwner.FOwner.FFixedCols;

      if (FOwner.FOwner.FCurrent.X >= FOwner.FOwner.FColCount) then
        FOwner.FOwner.FCurrent.X := FOwner.FOwner.FColCount - 1;
      }  
    end
    else
    begin
      FOwner.EnumerateRows;
      {
      if (FOwner.FOwner.FCurrent.Y < FOwner.FOwner.FFixedRows) then
        FOwner.FOwner.FCurrent.Y := FOwner.FOwner.FFixedRows;

      if (FOwner.FOwner.FCurrent.Y >= FOwner.FOwner.FRowCount) then
        FOwner.FOwner.FCurrent.Y := FOwner.FOwner.FRowCount - 1;
      }  
    end;

    if (FMarked) then
    begin
      FOwner.FNeedReGenerateMarks := True;

      if (Value) then
      begin
        Inc(FOwner.FOwner.FMarkCount);
      end
      else
      begin
        Dec(FOwner.FOwner.FMarkCount);
      end;
    end;

    FOwner.FOwner.DoChangeSize;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
// TRGridUnion
//----------------------------------------------------------------------------------------------------------------------
constructor TRGridUnion.Create(AOwner: TRCellsUnion; AUnionRect: TRGridRect; ACellsList: TList);
begin
  FOwner := AOwner;
  FUnionRect := AUnionRect;
  FPaintCount:= 0;
  FCellsList := ACellsList;
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRGridUnion.Destroy;
begin
  inherited Destroy;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridUnion.GetMainCell(): TRCell;
begin
  Result := TRCell(FOwner.FMainCell);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridUnion.GetCells(CellIndex: Longint): TRCell;
begin
  if (CellIndex < 0) or (CellIndex >= FCellsList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);  //,     ???

  Result := TRCell(FCellsList[CellIndex]);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridUnion.GetCount(): Longint;
begin
  Result := FCellsList.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRGridUnion.GetMarked: Boolean;
begin
  Result := FOwner.FMarked;
end;
//----------------------------------------------------------------------------------------------------------------------
// TRCellsUnion
//----------------------------------------------------------------------------------------------------------------------
constructor TRCellsUnion.Create(AOwner: TRCellsUnions; AMainCell: TRCell; ACellsList: TList);
begin
  FOwner := AOwner;
  FMainCell := AMainCell;
  FCellsList := ACellsList;
  FMarked := False;
  FMarkStatus := False;
  FEnabled := False;

  FGridUnionList := TList.Create();
  FGridUnionList.Clear();

  SetEnabled(True);
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRCellsUnion.Destroy;
begin
  SetEnabled(False);

  FCellsList.Free();
  FGridUnionList.Free();

  inherited Destroy;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnion.SetMarked(Value: Boolean);
var
  k: Longint;
  CanMark: Boolean;
begin
  if FMarked <> Value then
  begin
    CanMark := FOwner.FOwner.FOwner.DoMarkCell(FMainCell, Value);

    if CanMark then
    begin
      FMarked := Value;

      for k := 0 to FCellsList.Count - 1 do
      begin
        TRCell(FCellsList[k]).FMarked := Value;
      end;
      Invalidate();
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCellsUnion.TrySetMarked(Value: Boolean);
begin
end;
}
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnion.GetCells(CellIndex: Longint): TRCell;
begin
  if (CellIndex < 0) or (CellIndex >= FCellsList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);  //,     ???

  Result := TRCell(FCellsList[CellIndex]);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnion.GetCellsCount: Longint;
begin
  Result := FCellsList.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnion.GetGridUnions(CellIndex: Longint): TRGridUnion;
begin
  if (CellIndex < 0) or (CellIndex >= FGridUnionList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);  //,     ???

  Result := TRGridUnion(FGridUnionList[CellIndex]);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnion.GetGridUnionsCount(): Longint;
begin
  Result := FGridUnionList.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnion.SetEnabled(Value: Boolean);
{
var
  k: Longint;
}  
begin
  if FEnabled <> Value then
  begin
    FEnabled := Value;

    if FEnabled then
    begin
      Refresh();
      Invalidate();
    end
    else
    begin
      Disable();
      Invalidate();
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnion.Enable();
var
  k: Longint;
begin
  FMarked := False;

  for k := 0 to FCellsList.Count - 1 do
  begin
    TRCell(FCellsList[k]).FCellsUnion := Self;
    TRCell(FCellsList[k]).FGridUnionIndex := -1;
  end;

  for k := 0 to FGridUnionList.Count - 1 do
  begin
    TRGridUnion(FGridUnionList[k]).Free();
  end;
  FGridUnionList.Clear();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnion.Disable();
var
  k: Longint;
begin
  FMarked := False;

  for k := 0 to FCellsList.Count - 1 do
  begin
    TRCell(FCellsList[k]).FCellsUnion := NIL;
    TRCell(FCellsList[k]).FGridUnionIndex := -1;
  end;

  for k := 0 to FGridUnionList.Count - 1 do
  begin
    TRGridUnion(FGridUnionList[k]).Free();
  end;
  FGridUnionList.Clear();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnion.Invalidate();
var
  k: Longint;
  OldCurrent: TRGridCoord;
  OldCurrentRect: TRGridRect;

  procedure InvalidateCurrent(ACol, ARow: Longint);
  var
    Coord1, Coord2: TRGridCoord;
    GlobalRect, InvalidRange: TRGridRect;
    OldCellIsUnioned, CurCellIsUnioned: Boolean;
    OldCurrentIsTrue, OldCurrentRectIsTrue: Boolean;
  begin
    Coord1.X := 0;
    Coord1.Y := 0;
    Coord2.X := FOwner.FOwner.FOwner.FColCount - 1;
    Coord2.Y := FOwner.FOwner.FOwner.FRowCount - 1;
    GlobalRect := GridRect(Coord1, Coord2);

    OldCurrentIsTrue := (OldCurrent.X > -1) and (OldCurrent.X < FOwner.FOwner.FOwner.FColCount) and (OldCurrent.Y > -1) or (OldCurrent.Y < FOwner.FOwner.FOwner.FRowCount);
    OldCurrentRectIsTrue := CrossedRects(GlobalRect, OldCurrentRect);

    if (OldCurrentRectIsTrue) then
    begin
      if (OldCurrentRect.Left < 0) then
        OldCurrentRect.Left := 0;
      if (OldCurrentRect.Top < 0) then
        OldCurrentRect.Top := 0;
      if (OldCurrentRect.Right > (FOwner.FOwner.FOwner.FColCount - 1)) then
        OldCurrentRect.Right := FOwner.FOwner.FOwner.FColCount - 1;
      if (OldCurrentRect.Bottom > (FOwner.FOwner.FOwner.FRowCount - 1)) then
        OldCurrentRect.Bottom := FOwner.FOwner.FOwner.FRowCount - 1;
    end;

    if (OldCurrentIsTrue) then
      OldCellIsUnioned := FOwner.FOwner.FOwner.Cells[OldCurrent.X, OldCurrent.Y].Unioned
    else
      OldCellIsUnioned := false;

    CurCellIsUnioned := FOwner.FOwner.FOwner.Cells[FOwner.FOwner.FOwner.FCurrent.X, FOwner.FOwner.FOwner.FCurrent.Y].Unioned;

    if ([rgoShowCurCol, rgoShowCurRow] * FOwner.FOwner.FOwner.Options = []) then
    begin
      if OldCurrentRectIsTrue then
        FOwner.FOwner.FOwner.InvalidateRect(OldCurrentRect);

      FOwner.FOwner.FOwner.InvalidateRect(FOwner.FOwner.FOwner.FCurrentRect);
    end
    else
    begin
      if (rgoShowCurCol in FOwner.FOwner.FOwner.Options) then
      begin
        if (OldCellIsUnioned and OldCurrentRectIsTrue) then
        begin
          InvalidRange := OldCurrentRect;
          InvalidRange.Top := 0;
          InvalidRange.Bottom := FOwner.FOwner.FOwner.FTopLeft.Y + FOwner.FOwner.FOwner.VisibleRowCount;
          FOwner.FOwner.FOwner.InvalidateRect(InvalidRange);
        end
        else
        begin
          if (OldCurrentIsTrue) then
            FOwner.FOwner.FOwner.InvalidateCol(OldCurrent.X);
        end;

        if CurCellIsUnioned then
        begin
          InvalidRange := FOwner.FOwner.FOwner.FCurrentRect;
          InvalidRange.Top := 0;
          InvalidRange.Bottom := FOwner.FOwner.FOwner.FTopLeft.Y + FOwner.FOwner.FOwner.VisibleRowCount;
          FOwner.FOwner.FOwner.InvalidateRect(InvalidRange);
        end
        else
          with FOwner.FOwner.FOwner.FCurrent do FOwner.FOwner.FOwner.InvalidateCol(X);
      end;
      if (rgoShowCurRow in FOwner.FOwner.FOwner.Options) then
      begin
        if (OldCellIsUnioned and OldCurrentRectIsTrue) then
        begin
          InvalidRange := OldCurrentRect;
          InvalidRange.Left := 0;
          InvalidRange.Right := FOwner.FOwner.FOwner.FTopLeft.X + FOwner.FOwner.FOwner.VisibleColCount;
          FOwner.FOwner.FOwner.InvalidateRect(InvalidRange);
        end
        else
        begin
          if (OldCurrentIsTrue) then
            FOwner.FOwner.FOwner.InvalidateRow(OldCurrent.Y);
        end;

        if CurCellIsUnioned then
        begin
          InvalidRange := FOwner.FOwner.FOwner.FCurrentRect;
          InvalidRange.Left := 0;
          InvalidRange.Right := FOwner.FOwner.FOwner.FTopLeft.X + FOwner.FOwner.FOwner.VisibleColCount;
          FOwner.FOwner.FOwner.InvalidateRect(InvalidRange);
        end
        else
          with FOwner.FOwner.FOwner.FCurrent do FOwner.FOwner.FOwner.InvalidateRow(Y);
      end;
    end
  end;

begin
  // 
  if (not FOwner.FOwner.FDeleting) then
  begin
    OldCurrent := FOwner.FOwner.FOwner.FCurrent;
    OldCurrentRect := FOwner.FOwner.FOwner.FCurrentRect;
    FOwner.FOwner.FOwner.RefreshCurrentRect;

    if FGridUnionList.Count > 0 then
    begin
      // 
      for k := 0 to FGridUnionList.Count - 1 do
      begin
        if PointInGridRect(FOwner.FOwner.FOwner.FCurrent.X, FOwner.FOwner.FOwner.FCurrent.Y, TRGridUnion(FGridUnionList[k]).FUnionRect) then
          InvalidateCurrent(FOwner.FOwner.FOwner.FCurrent.X, FOwner.FOwner.FOwner.FCurrent.Y) 
        else
          FOwner.FOwner.FOwner.InvalidateCell(TRGridUnion(FGridUnionList[k]).FUnionRect.Left, TRGridUnion(FGridUnionList[k]).FUnionRect.Top);
      end;

      // ,     
      for k := 0 to FCellsList.Count - 1 do
      begin
        if (TRCell(FCellsList[k]).FGridUnionIndex < 0) then
        begin
          if (TRCell(FCellsList[k]).GridCol > -1) and (TRCell(FCellsList[k]).GridRow > -1) then
            FOwner.FOwner.FOwner.InvalidateCell(TRCell(FCellsList[k]).GridCol, TRCell(FCellsList[k]).GridRow);
        end;
      end;
    end
    else
    begin
      for k := 0 to FCellsList.Count - 1 do
      begin
        //   OldCurrentRect,     FCurrentRect,
        //     rgoShowCurCol, rgoShowCurRow
        if PointInGridRect(TRCell(FCellsList[k]).GridCol, TRCell(FCellsList[k]).GridRow, OldCurrentRect) then
        begin
          if ([rgoShowCurCol, rgoShowCurRow] * FOwner.FOwner.FOwner.FOptions <> []) then
          begin
            if (rgoShowCurCol in FOwner.FOwner.FOwner.FOptions) and (TRCell(FCellsList[k]).GridCol > -1)then
              FOwner.FOwner.FOwner.InvalidateCol(TRCell(FCellsList[k]).GridCol);

            if (rgoShowCurRow in FOwner.FOwner.FOwner.FOptions) and (TRCell(FCellsList[k]).GridRow > -1) then
              FOwner.FOwner.FOwner.InvalidateRow(TRCell(FCellsList[k]).GridRow);
          end
          else
            if (TRCell(FCellsList[k]).GridCol > -1) and (TRCell(FCellsList[k]).GridRow > -1) then
              FOwner.FOwner.FOwner.InvalidateCell(TRCell(FCellsList[k]).GridCol, TRCell(FCellsList[k]).GridRow);
        end
        else
          if (TRCell(FCellsList[k]).GridCol > -1) and (TRCell(FCellsList[k]).GridRow > -1) then
            FOwner.FOwner.FOwner.InvalidateCell(TRCell(FCellsList[k]).GridCol, TRCell(FCellsList[k]).GridRow);
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnion.Refresh();
var
  k, GridUnionIndex: Longint;
  TmpList1, TmpList2: TList;
  NotFinded: Boolean;

  function GetMinDifference(ComparedCell: TRCell; ComparedList: TList): Longint;
  var
    k, MinX, MinY, MinDifference: Longint;
  begin
    Result := 100;
    MinDifference := 100;

    for k := 0 to ComparedList.Count - 1 do
    begin
      MinX := Abs(ComparedCell.ColOwner.FGridIndex - TRCell(ComparedList[k]).ColOwner.FGridIndex);
      MinY := Abs(ComparedCell.RowOwner.FGridIndex - TRCell(ComparedList[k]).RowOwner.FGridIndex);

      if ((MinX > 0) and (MinY = 0)) or ((MinX = 0) and (MinY > 0)) then
        MinDifference := Max(MinX, MinY);

      if (k = 0) then
        Result := MinDifference
      else
        Result := Min(Result, MinDifference);

      if (Result = 1) then
        Break;
    end;
  end;

  function CreateGridUnion(CellsUnionList: TList): TRGridUnion;
  var
    k: Longint;
    UnionGridRect: TRGridRect;
  begin
    for k := 0 to CellsUnionList.Count - 1 do
    begin
      if (k = 0) then
      begin
        UnionGridRect.Left   := TRCell(CellsUnionList[k]).ColOwner.FGridIndex;
        UnionGridRect.Right  := TRCell(CellsUnionList[k]).ColOwner.FGridIndex;
        UnionGridRect.Top    := TRCell(CellsUnionList[k]).RowOwner.FGridIndex;
        UnionGridRect.Bottom := TRCell(CellsUnionList[k]).RowOwner.FGridIndex;
      end
      else
      begin
        UnionGridRect.Left   := Min(UnionGridRect.Left, TRCell(CellsUnionList[k]).GridCol);
        UnionGridRect.Right  := Max(UnionGridRect.Right, TRCell(CellsUnionList[k]).GridCol);
        UnionGridRect.Top    := Min(UnionGridRect.Top, TRCell(CellsUnionList[k]).GridRow);
        UnionGridRect.Bottom := Max(UnionGridRect.Bottom, TRCell(CellsUnionList[k]).GridRow);
      end;
    end;

    Result := TRGridUnion.Create(Self, UnionGridRect, CellsUnionList);
  end;

begin
  if (FEnabled) then
  begin
    Enable();

    TmpList1 := TList.Create();
    TmpList1.Clear;
    TmpList1.Assign(FCellsList);

    if (not FMainCell.FColOwner.FFixed)
      and (not FMainCell.FRowOwner.FFixed) then
    begin
      if (rgoCellsMarking in FOwner.FOwner.FOwner.FOptions) then
      begin
        for k := 0 to TmpList1.Count - 1 do
        begin
          if (TRCell(FCellsList[k]).FColOwner.FVisible)
            and (TRCell(FCellsList[k]).FRowOwner.FVisible) then
          begin
            if (TRCell(FCellsList[k]).FMarked) then
            begin
              FMarked := True;
              Break;
            end;
          end;
        end;
      end
      else if (rgoColsMarking in FOwner.FOwner.FOwner.FOptions) then
      begin
        for k := 0 to TmpList1.Count - 1 do
        begin
          if (TRCell(FCellsList[k]).FColOwner.FVisible) then
          begin
            if (TRCell(FCellsList[k]).FColOwner.FMarked) then
            begin
              FMarked := True;
              Break;
            end;
          end;
        end;
      end
      else if (rgoRowsMarking in FOwner.FOwner.FOwner.FOptions) then
      begin
        for k := 0 to TmpList1.Count - 1 do
        begin
          if (TRCell(FCellsList[k]).FRowOwner.FVisible) then
          begin
            if (TRCell(FCellsList[k]).FRowOwner.FMarked) then
            begin
              FMarked := True;
              Break;
            end;
          end;
        end;
      end;
    end;

    //     
    //     
    k := 0;
    while (k < TmpList1.Count) do
    begin
      if (rgoCellsMarking in FOwner.FOwner.FOwner.FOptions) then
        TRCell(TmpList1[k]).FMarked := FMarked;

      if (TRCell(TmpList1[k]).GridCol < 0) or (TRCell(TmpList1[k]).GridRow < 0) then
        TmpList1.Delete(k)
      else
        Inc(k);
    end;

    if (TmpList1.Count > 1) then
    begin
      repeat
        TmpList2 := TList.Create();
        TmpList2.Clear;
        TmpList2.Add(TRCell(TmpList1[0]));

        TmpList1.Delete(0);

        repeat
          NotFinded := True;
          for k := 0 to TmpList1.Count - 1 do
          begin
            if (GetMinDifference(TRCell(TmpList1[k]), TmpList2) = 1) then
            begin
              TmpList2.Add(TRCell(TmpList1[k]));
              TmpList1.Delete(k);
              NotFinded := False;
              Break;
            end;
          end;
        until NotFinded;

        if (TmpList2.Count > 1) then
        begin
          GridUnionIndex := FGridUnionList.Add(CreateGridUnion(TmpList2));
          for k := 0 to TmpList2.Count - 1 do
          begin
            TRCell(TmpList2[k]).FGridUnionIndex := GridUnionIndex;
          end;
        end;
      until (TmpList1.Count < 2)
    end;

    TmpList1.Free();
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
// TRCellsUnions
//----------------------------------------------------------------------------------------------------------------------
constructor TRCellsUnions.Create(AOwner: TRCellsHolder);
begin
  FOwner := AOwner;

  FUnionsList := TList.Create();
  FUnionsList.Clear;
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRCellsUnions.Destroy;
var
  k: Longint;
begin
  if FUnionsList <> NIL then
  begin
    for k := 0 to FUnionsList.Count - 1 do
    begin
      TRCellsUnion(FUnionsList[k]).Free;
    end;
    FUnionsList.Free;
    FUnionsList := NIL;
  end;

  inherited Destroy;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnions.GetUnions(UnionIndex: Longint): TRCellsUnion;
begin
  if (UnionIndex < 0) or (UnionIndex >= FUnionsList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);  //,     ???

  Result := TRCellsUnion(FUnionsList[UnionIndex]);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnions.GetUnionsCount: Longint;
begin
  Result := FUnionsList.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.Add(MainCellCoord, StartAnchor, EndAnchor: TRGridCoord; IsGridCoord: Boolean);
var
  k, i, ListIndex, MainCellIndex: Longint;
  FirstCellType, CurCellType, IsConflictArea: Boolean;
  CellsList: TList;
  ACell: TRCell;
begin
  ListIndex := -1;
  MainCellIndex := -1;
  IsConflictArea := False;
  FirstCellType := False; //   :)

  if (StartAnchor.X > EndAnchor.X) then
  begin
    k := StartAnchor.X;
    StartAnchor.X := EndAnchor.X;
    EndAnchor.X := k;
  end;

  if (StartAnchor.Y > EndAnchor.Y) then
  begin
    k := StartAnchor.Y;
    StartAnchor.Y := EndAnchor.Y;
    EndAnchor.Y := k;
  end;

  if IsGridCoord then
  begin
    if (StartAnchor.X < 0) or (StartAnchor.Y < 0) or (EndAnchor.X >= FOwner.FOwner.FColCount) or (EndAnchor.Y >= FOwner.FOwner.FRowCount) then
    begin
      InvalidOp(ClassName + '::' + SIndexOutOfRange);
      //Exit;
    end;
  end
  else
  begin
    if (StartAnchor.X < 0) or (StartAnchor.Y < 0) or (EndAnchor.X >= FOwner.ColCount) or (EndAnchor.Y >= FOwner.RowCount) then
    begin
      InvalidOp(ClassName + '::' + SIndexOutOfRange);
      //Exit;
    end;
  end;

  if (MainCellCoord.X >= StartAnchor.X) and (MainCellCoord.X <= EndAnchor.X)
    and (MainCellCoord.Y >= StartAnchor.Y) and (MainCellCoord.Y <= EndAnchor.Y) then
  begin
    CellsList := TList.Create();
    CellsList.Clear;

    for k := StartAnchor.X to EndAnchor.X do
    begin
      for i := StartAnchor.Y to EndAnchor.Y do
      begin
        if IsGridCoord then
        begin
          ACell := FOwner.Cells[FOwner.FOwner.GridToHolderCol(k), FOwner.FOwner.GridToHolderRow(i)];

          if (ACell.GridCol < FOwner.FOwner.FFixedCols) or (ACell.GridRow < FOwner.FOwner.FFixedRows) then
            CurCellType := True
          else
            CurCellType := False;
        end
        else
        begin
          ACell := FOwner.Cells[k, i];

          if (k < FOwner.FFixedCols) or (i < FOwner.FFixedRows) then
            CurCellType := True
          else
            CurCellType := False;
        end;

        if (ListIndex = -1) then
        begin
          FirstCellType := CurCellType;
          ListIndex := CellsList.Add(ACell);
        end
        else
        begin
          if (FirstCellType = CurCellType) then
          begin
            ListIndex := CellsList.Add(ACell);
          end
          else
          begin
            IsConflictArea := True;
            Break;
          end;
        end;

        if (k = MainCellCoord.X) and (i = MainCellCoord.Y) and (not IsConflictArea) then
        begin
          MainCellIndex := ListIndex;
        end;
      end;

      if IsConflictArea then
      begin
        Break;
      end;
    end;

    if (CellsList.Count > 1) and (MainCellIndex > -1) then
    begin
      // ,      
      for k := 0 to FUnionsList.Count - 1 do
      begin
        if (TRCellsUnion(FUnionsList[k]).FMainCell = TRCell(CellsList[MainCellIndex])) then
        begin
          TRCellsUnion(FUnionsList[k]).Free;
          FUnionsList[k] := NIL;
        end
        else
        begin
          for i := 0 to TRCellsUnion(FUnionsList[k]).FCellsList.Count - 1 do
          begin
            if (CellsList.IndexOf(TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i])) > -1)  then
            begin
              TRCellsUnion(FUnionsList[k]).Free;
              FUnionsList[k] := NIL;
              Break;
            end;
          end;
        end;
      end;
      FUnionsList.Pack;

      FUnionsList.Add(TRCellsUnion.Create(Self, TRCell(CellsList[MainCellIndex]), CellsList));
    end
    else
    begin
      CellsList.Free();
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.Add(AMainCell: TRCell; ACellsList: TList; IsGridCoord: Boolean);
var
  k, i: Longint;
  FirstCellType, CurCellType, MainCellInList, IsConflictArea: Boolean;
begin
  MainCellInList := False;
  IsConflictArea := False;
  FirstCellType := False; //   :)

  if (AMainCell <> NIL) and (ACellsList <> NIL) then
  begin
    if (ACellsList.Count > 1) then
    begin
      for k := 0 to ACellsList.Count - 1 do
      begin
        if IsGridCoord then
        begin
          if (TRCell(ACellsList[k]).GridCol < FOwner.FOwner.FFixedCols) or (TRCell(ACellsList[k]).GridRow < FOwner.FOwner.FFixedRows) then
            CurCellType := True
          else
            CurCellType := False;
        end
        else
        begin
          if (TRCell(ACellsList[k]).HolderCol < FOwner.FFixedCols) or (TRCell(ACellsList[k]).HolderRow < FOwner.FFixedRows) then
            CurCellType := True
          else
            CurCellType := False;
        end;

        if (k = 0) then
        begin
          FirstCellType := CurCellType;
        end
        else
        begin
          if (FirstCellType <> CurCellType) then
          begin
            IsConflictArea := True;
            Break;
          end;
        end;

        if (AMainCell = TRCell(ACellsList[k])) then
          MainCellInList := True;
      end;
    end;
  end;

  if MainCellInList and (not IsConflictArea) then
  begin
    // ,      
    for k := 0 to FUnionsList.Count - 1 do
    begin
      if (TRCellsUnion(FUnionsList[k]).FMainCell = AMainCell) then
      begin
        TRCellsUnion(FUnionsList[k]).Free;
        FUnionsList[k] := NIL;
      end
      else
      begin
        for i := 0 to TRCellsUnion(FUnionsList[k]).FCellsList.Count - 1 do
        begin
          if (ACellsList.IndexOf(TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i])) > -1)  then
          begin
            TRCellsUnion(FUnionsList[k]).Free;
            FUnionsList[k] := NIL;
            Break;
          end;
        end;
      end;
    end;
    FUnionsList.Pack();

    FUnionsList.Add(TRCellsUnion.Create(Self, AMainCell, ACellsList));
  end
  else
  begin
    ACellsList.Free;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.Delete(Index: Longint);
begin
  if (Index < 0) or (Index >= FUnionsList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);  //,     ???

  TRCellsUnion(FUnionsList[Index]).Free;
  FUnionsList.Delete(Index);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.Clear;
var
  k{, i}: Longint;
begin
  for k := 0 to FUnionsList.Count - 1 do
  begin
    TRCellsUnion(FUnionsList[k]).Free;
  end;
  FUnionsList.Clear;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.Refresh;
var
  k: Longint;
begin
  for k := 0 to FUnionsList.Count - 1 do
  begin
    TRCellsUnion(FUnionsList[k]).Refresh;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.ResetPaintCounters();
var
  k, i: LongInt;
begin
  for k := 0 to FUnionsList.Count - 1 do
    for i := 0 to TRCellsUnion(FUnionsList[k]).FGridUnionList.Count - 1 do
      TRGridUnion(TRCellsUnion(FUnionsList[k]).FGridUnionList[i]).FPaintCount := 0;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsUnions.StoreMarkStatuses();
var
  k: LongInt;
begin
  for k := 0 to FUnionsList.Count - 1 do
    TRCellsUnion(FUnionsList[k]).FMarkStatus := TRCellsUnion(FUnionsList[k]).FMarked;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsUnions.TryChangeMarked(AVector: TRCellsVector; Value: Boolean): Boolean;
var
  k, i{, m}: LongInt;
  UnionFinded, CanChangeMark: Boolean;
  VectorList: TList;
begin
  Result := False;

  if (AVector.FVisible) then
  begin
    UnionFinded := False;
    CanChangeMark := True;

    if (AVector.FIsColumn) and (rgoColsMarking in FOwner.FOwner.FOptions) then
    begin
      //    
      for k := 0 to FUnionsList.Count - 1 do
      begin
        if (not TRCellsUnion(FUnionsList[k]).FMainCell.FColOwner.FFixed)
          and (not TRCellsUnion(FUnionsList[k]).FMainCell.FRowOwner.FFixed) then
        begin
          if (TRCellsUnion(FUnionsList[k]).FEnabled) then
          begin
            //    
            for i := 0 to TRCellsUnion(FUnionsList[k]).FCellsList.Count - 1 do
            begin
              if (TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FColOwner = AVector) then
              begin
                UnionFinded := True;
                Break;
              end;
            end;

            if UnionFinded then
            begin
              if (TRCellsUnion(FUnionsList[k]).FMarked <> Value) then
              begin
                VectorList := TList.Create();
                VectorList.Clear();

                //      
                //(AVector   )
                for i := 0 to TRCellsUnion(FUnionsList[k]).FCellsList.Count - 1 do
                begin
                  if (TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FColOwner <> AVector) then
                  begin
                    if (TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FColOwner.FVisible) then
                    begin
                      if (VectorList.IndexOf(TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FColOwner) < 0) then
                      begin
                        VectorList.Add(TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FColOwner);
                      end;
                    end;
                  end;
                end;

                for i := 0 to VectorList.Count - 1 do
                begin
                  if (TRCellsVector(VectorList[i]).FMarked) then
                  begin
                    CanChangeMark := False;
                    Break;
                  end;
                end;

                VectorList.Free();

                if CanChangeMark then
                begin
                  TRCellsUnion(FUnionsList[k]).FMarked := Value;
                  Result := True; //       ...
                end;
              end;

              //Break; ...    
            end;
          end;
        end;
      end;
    end
    else if (not AVector.FIsColumn) and (rgoRowsMarking in FOwner.FOwner.FOptions) then
    begin
      for k := 0 to FUnionsList.Count - 1 do
      begin
        if (not TRCellsUnion(FUnionsList[k]).FMainCell.FColOwner.FFixed)
          and (not TRCellsUnion(FUnionsList[k]).FMainCell.FRowOwner.FFixed) then
        begin
          if (TRCellsUnion(FUnionsList[k]).FEnabled) then
          begin
            for i := 0 to TRCellsUnion(FUnionsList[k]).FCellsList.Count - 1 do
            begin
              if (TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FRowOwner = AVector) then
              begin
                UnionFinded := True;
                Break;
              end;
            end;

            if UnionFinded then
            begin
              if (TRCellsUnion(FUnionsList[k]).FMarked <> Value) then
              begin
                VectorList := TList.Create();
                VectorList.Clear();

                //      
                //(AVector   )
                for i := 0 to TRCellsUnion(FUnionsList[k]).FCellsList.Count - 1 do
                begin
                  if (TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FRowOwner <> AVector) then
                  begin
                    if (TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FRowOwner.FVisible) then
                    begin
                      if (VectorList.IndexOf(TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FRowOwner) < 0) then
                      begin
                        VectorList.Add(TRCell(TRCellsUnion(FUnionsList[k]).FCellsList[i]).FRowOwner);
                      end;
                    end;
                  end;
                end;

                for i := 0 to VectorList.Count - 1 do
                begin
                  if (TRCellsVector(VectorList[i]).FMarked) then
                  begin
                    CanChangeMark := False;
                    Break;
                  end;
                end;

                VectorList.Free();

                if CanChangeMark then
                begin
                  TRCellsUnion(FUnionsList[k]).FMarked := Value;
                  Result := True; //       ...
                end;
              end;

              //Break; ...    
            end;
          end;
        end;
      end;
    end
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
// TRCellsHolder
//----------------------------------------------------------------------------------------------------------------------
constructor TRCellsHolder.Create(AOwner: TRCustomGrid);
begin
  inherited Create();

  FOwner := AOwner;

  FFixedCols := 1;
  FFixedRows := 1;

  FDeleting := False;

  FCols := TList.Create();
  FCols.Clear();

  // 
  FRows := TList.Create();
  FRows.Clear();

  // 
  FMarkList := TList.Create();
  FMarkList.Clear();
  FMarkCount := 0;

  FNeedReGenerateMarks := False;

  FCellsUnions := TRCellsUnions.Create(Self);

  //    
  //??? FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];

  DoChangeSize(5, 5); //Default ColCount, RowCount
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRCellsHolder.Destroy;
var
  k: Longint;
begin
  FDeleting := True;

  FCellsUnions.Free;
  FMarkList.Free;

  for k := 0 to FCols.Count - 1 do
  begin
    TRCellsVector(FCols[k]).Free;
  end;
  FCols.Free;

  for k := 0 to FRows.Count - 1 do
  begin
    TRCellsVector(FRows[k]).Free;
  end;
  FRows.Free;

  inherited Destroy;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetColCount(Value: Longint);
begin
  if (Value < 1) then
    Value := 1;

  if FCols.Count <> Value then
  begin
    ChangeSize(Value, FRows.Count);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetColCount: Longint;
begin
  Result := FCols.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetRowCount(Value: Longint);
begin
  if (Value < 1) then
    Value := 1;

  if FRows.Count <> Value then
  begin
    ChangeSize(FCols.Count, Value);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetRowCount: Longint;
begin
  Result := FRows.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetFixedCols(Value: Integer);
var
  k: Longint;
begin
  if FFixedCols <> Value then
  begin
    if Value < 0 then
    begin
      InvalidOp(ClassName + '::' + SIndexOutOfRange);
      //Exit;
    end;

    if Value >= FCols.Count then
    begin
      InvalidOp(ClassName + '::' + SFixedColTooBig);
      //Exit;
    end;

    FFixedCols := Value;
    for k := 0 to FCols.Count - 1 do
    begin
      if k < FFixedCols then
        TRCellsVector(FCols[k]).FFixed := True
      else
        TRCellsVector(FCols[k]).FFixed := False;
    end;

    EnumerateCols;
    FOwner.Initialize;
    FOwner.InvalidateGrid;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetFixedRows(Value: Integer);
var
  k: Longint;
begin
  if FFixedRows <> Value then
  begin
    if Value < 0 then
    begin
      InvalidOp(ClassName + '::' + SIndexOutOfRange);
      //Exit;
    end;

    if Value >= FRows.Count then
    begin
      InvalidOp(ClassName + '::' + SFixedRowTooBig);
      //Exit;
    end;

    FFixedRows := Value;
    for k := 0 to FRows.Count - 1 do
    begin
      if k < FFixedRows then
        TRCellsVector(FRows[k]).FFixed := True
      else
        TRCellsVector(FRows[k]).FFixed := False;
    end;

    EnumerateRows;
    FOwner.Initialize;
    FOwner.InvalidateGrid;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.ChangeSize(NewColCount, NewRowCount: Longint);
begin
  //    
  FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];

  FOwner.PrepareChangeSize;
  DoChangeSize(NewColCount, NewRowCount);
  FOwner.DoChangeSize;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DoChangeSize(NewColCount, NewRowCount: Longint);
var
  k, i, OldColCount, OldRowCount: Longint;
  NeedCreateCells: Boolean;
begin
  NeedCreateCells := False;

  if (NewColCount < 0) then
    NewColCount := 0;

  if (NewRowCount < 0) then
    NewRowCount := 0;

  OldColCount := FCols.Count;
  OldRowCount := FRows.Count;

  if (FFixedCols >= NewColCount) then
  begin
    if (NewColCount > 1) then
      FFixedCols := NewColCount - 1
    else
      FFixedCols := 0;
  end;

  if FFixedRows >= NewRowCount then
  begin
    if (NewRowCount > 1) then
      FFixedRows := NewRowCount - 1
    else
      FFixedRows := 0;
  end;

  //  
  if ((NewColCount - FCols.Count) > 0) then
  begin
    NeedCreateCells := True;

    FCols.Capacity := NewColCount;
    for k := FCols.Count to (NewColCount - 1) do
    begin
      if k < FFixedCols then
        FCols.Add(TRCellsVector.Create(Self, True, True, True, FOwner.FDefaultColWidth, NIL))
      else
        FCols.Add(TRCellsVector.Create(Self, True, False, True, FOwner.FDefaultColWidth, NIL));
    end;
  end
  else
  begin
    for k := NewColCount to FCols.Count - 1 do
    begin
      //FOwner.DoFreeCellsVector(TRCellsVector(FCols[k]));
      TRCellsVector(FCols[k]).Free;
      FCols[k] := NIL;
    end;
    FCols.Pack();
    FCols.Capacity := FCols.Count;
  end;

  //  
  if ((NewRowCount - FRows.Count) < 0) then
  begin
    for k := NewRowCount to FRows.Count - 1 do
    begin
      //FOwner.DoFreeCellsVector(TRCellsVector(FRows[k]));
      TRCellsVector(FRows[k]).Free;
      FRows[k] := NIL;
    end;
    FRows.Pack();
    FRows.Capacity := FRows.Count;
  end;

  //    
  if ((OldColCount - FCols.Count) > 0) then
  begin
    for k := 0 to FRows.Count - 1 do
    begin
      for i := NewColCount to TRCellsVector(FRows[k]).FCellsList.Count - 1 do
      begin
        TRCell(TRCellsVector(FRows[k]).FCellsList[i]).Free;
        TRCellsVector(FRows[k]).FCellsList[i] := NIL;
      end;
      TRCellsVector(FRows[k]).FCellsList.Pack();
      TRCellsVector(FRows[k]).FCellsList.Capacity := TRCellsVector(FRows[k]).FCellsList.Count;
    end;
  end;

  //  
  if ((NewRowCount - FRows.Count) > 0) then
  begin
    NeedCreateCells := True;

    FRows.Capacity := NewRowCount;

    for k := FRows.Count to (NewRowCount - 1) do
    begin
      if k < FFixedRows then
        FRows.Add(TRCellsVector.Create(Self, False, True, True, FOwner.FDefaultRowHeight, TList.Create()))
      else
        FRows.Add(TRCellsVector.Create(Self, False, False, True, FOwner.FDefaultRowHeight, TList.Create()));
    end;
  end;

  EnumerateCols;
  EnumerateRows;

  //   ()
  for k := OldColCount to FCols.Count - 1 do
  begin
    FOwner.DoInitCellsVector(TRCellsVector(FCols[k]));
  end;

  //   ()
  for k := OldRowCount to FRows.Count - 1 do
  begin
    FOwner.DoInitCellsVector(TRCellsVector(FRows[k]));
  end;

  //    
  if NeedCreateCells then
  begin
    for k := 0 to FRows.Count - 1 do
    begin
      TRCellsVector(FRows[k]).FCellsList.Capacity := NewColCount;
      i := TRCellsVector(FRows[k]).FCellsList.Count;
      while TRCellsVector(FRows[k]).FCellsList.Count < NewColCount do
      begin
        TRCellsVector(FRows[k]).FCellsList.Add(TRCell.Create(TRCellsVector(FCols[i]), TRCellsVector(FRows[k]){, True}));
        FOwner.DoInitCell(TRCell(TRCellsVector(FRows[k]).FCellsList.Last()));
        Inc(i);
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.EnumerateCols;
var
  k, i, FixedCount: Longint;
begin
  FVisibleColCount := 0;
  FixedCount := 0;

  for k := 0 to FCols.Count - 1 do
  begin
    TRCellsVector(FCols[k]).FHolderIndex := k;

    if (k < FFixedCols) then
      TRCellsVector(FCols[k]).FFixed := True
    else
      TRCellsVector(FCols[k]).FFixed := False;

    if TRCellsVector(FCols[k]).FVisible then
    begin
      TRCellsVector(FCols[k]).FGridIndex := FVisibleColCount;
      Inc(FVisibleColCount);
    end
    else
    begin
      TRCellsVector(FCols[k]).FGridIndex := -1;
    end;
  end;

  if FOwner.FColsEnumerator <> NIL then
  begin
    FreeMem(FOwner.FColsEnumerator, SizeOf(FOwner.FColsEnumerator));
    FOwner.FColsEnumerator := NIL;
  end;

  if FVisibleColCount > 0 then
  begin
    GetMem(FOwner.FColsEnumerator, FVisibleColCount * SizeOf(Longint));

    i := 0;
    for k := 0 to FCols.Count - 1 do
    begin
      if TRCellsVector(FCols[k]).FVisible then
      begin
        if TRCellsVector(FCols[k]).FFixed then
        begin
          Inc(FixedCount);
        end;
        PLongintArray(FOwner.FColsEnumerator)^[i] := TRCellsVector(FCols[k]).FHolderIndex;
        Inc(i);
      end;
    end;
  end;

  if (FixedCount >= FVisibleColCount) then
    FixedCount := FVisibleColCount - 1;

  FOwner.FFixedCols := FixedCount;
  FOwner.FColCount := FVisibleColCount;

  FCellsUnions.Refresh();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.EnumerateRows;
var
  k, i, FixedCount: Longint;
begin
  FVisibleRowCount := 0;
  FixedCount := 0;

  for k := 0 to FRows.Count - 1 do
  begin
    TRCellsVector(FRows[k]).FHolderIndex := k;

    if (k < FFixedRows) then
      TRCellsVector(FRows[k]).FFixed := True
    else
      TRCellsVector(FRows[k]).FFixed := False;
    

    if TRCellsVector(FRows[k]).FVisible then
    begin
      TRCellsVector(FRows[k]).FGridIndex := FVisibleRowCount;
      Inc(FVisibleRowCount);
    end
    else
    begin
      TRCellsVector(FRows[k]).FGridIndex := -1;
    end;
  end;

  if FOwner.FRowsEnumerator <> NIL then
  begin
    FreeMem(FOwner.FRowsEnumerator, SizeOf(FOwner.FRowsEnumerator));
    FOwner.FRowsEnumerator := NIL;
  end;

  if FVisibleRowCount > 0 then
  begin
    GetMem(FOwner.FRowsEnumerator, FVisibleRowCount * SizeOf(Longint));

    i := 0;
    for k := 0 to FRows.Count - 1 do
    begin
      if TRCellsVector(FRows[k]).FVisible then
      begin
        if TRCellsVector(FRows[k]).FFixed then
        begin
          Inc(FixedCount);
        end;
        PLongintArray(FOwner.FRowsEnumerator)^[i] := TRCellsVector(FRows[k]).FHolderIndex;
        Inc(i);
      end;
    end;
  end;

  if (FixedCount >= FVisibleRowCount) then
    FixedCount := FVisibleRowCount - 1;

  FOwner.FFixedRows := FixedCount;
  FOwner.FRowCount := FVisibleRowCount;

  FCellsUnions.Refresh();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetColWidths(ACol: Longint; Value: Integer);
begin
  if ACol >= FCols.Count then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if TRCellsVector(FCols[ACol]).FSize <> Value then
  begin
    FOwner.ResizeCol(TRCellsVector(FCols[ACol]).FGridIndex, TRCellsVector(FCols[ACol]).FSize, Value);
    TRCellsVector(FCols[ACol]).FSize := Value;
    FOwner.ColWidthsChanged;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetColWidths(ACol: Longint): Integer;
begin
  Result := TRCellsVector(FCols[ACol]).FSize;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetRowHeights(ARow: Longint; Value: Integer);
begin
  if ARow >= FRows.Count then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if TRCellsVector(FRows[ARow]).FSize <> Value then
  begin
    FOwner.ResizeRow(TRCellsVector(FRows[ARow]).FGridIndex, TRCellsVector(FRows[ARow]).FSize, Value);
    TRCellsVector(FRows[ARow]).FSize := Value;
    FOwner.RowHeightsChanged;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetRowHeights(ARow: Longint): Integer;
begin
  Result := TRCellsVector(FRows[ARow]).FSize;
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCellsHolder.SetColsVisibles(ACol: Longint; Value: Boolean);
begin
  if TRCellsVector(FCols[ACol]).FVisible <> Value then
  begin
    FOwner.PrepareChangeSize;

    TRCellsVector(FCols[ACol]).FVisible := Value;

    FOwner.VirtualView := True; //???

    EnumerateCols;

    if (FOwner.FCurrent.X < FOwner.FFixedCols) then
      FOwner.FCurrent.X := FOwner.FFixedCols;

    if (FOwner.FCurrent.X >= FOwner.FColCount) then
      FOwner.FCurrent.X := FOwner.FColCount - 1;

    FOwner.DoChangeSize;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCellsHolder.GetColsVisibles(ACol: Longint): Boolean;
begin
  Result := TRCellsVector(FCols[ACol]).FVisible;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCellsHolder.SetRowsVisibles(ARow: Longint; Value: Boolean);
begin
  if TRCellsVector(FRows[ARow]).FVisible <> Value then
  begin
    FOwner.PrepareChangeSize;

    TRCellsVector(FRows[ARow]).FVisible := Value;

    FOwner.VirtualView := True; //???

    EnumerateRows;

    if (FOwner.FCurrent.Y < FOwner.FFixedRows) then
      FOwner.FCurrent.Y := FOwner.FFixedRows;

    if (FOwner.FCurrent.Y >= FOwner.FRowCount) then
      FOwner.FCurrent.Y := FOwner.FRowCount - 1;

    FOwner.DoChangeSize;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCellsHolder.GetRowsVisibles(ARow: Longint): Boolean;
begin
  Result := TRCellsVector(FRows[ARow]).FVisible;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCellsHolder.SetMarkedCols(ACol: Longint; Value: Boolean);
var
  k, i: Longint;
  UnionFinded: Boolean;
begin
  if (ACol < 0) or (ACol >= FCols.Count) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if (rgoColsMarking in FOwner.FOptions) then
  begin
    if (TRCellsVector(FCols[ACol]).FMarked <> Value) then
    begin
      if (not TRCellsVector(FCols[ACol]).FFixed) then
      begin
        TRCellsVector(FCols[ACol]).FMarked := Value;

        UnionFinded := False;
        for k := 0 to FCellsUnions.FUnionsList.Count - 1 do
        begin
          for i := 0 to  TRCellsUnion(FCellsUnions.FUnionsList[k]).FGridUnionList.Count - 1 do
          begin
            if (ACol >= TRGridUnion(TRCellsUnion(FCellsUnions.FUnionsList[k]).FGridUnionList[i]).FUnionRect.Left)
             and (ACol <= TRGridUnion(TRCellsUnion(FCellsUnions.FUnionsList[k]).FGridUnionList[i]).FUnionRect.Right) then
            begin
              TRCellsUnion(FCellsUnions.FUnionsList[k]).FMarked := Value;
              UnionFinded := True;
              Break;
            end;
          end;

          if UnionFinded then
            Break;
        end;

        if   (TRCellsVector(FCols[ACol]).FGridIndex >= FOwner.FTopLeft.X)
          and (TRCellsVector(FCols[ACol]).FGridIndex <= FOwner.FTopLeft.X + FOwner.VisibleColCount) then
        begin
          FOwner.InvalidateCol(TRCellsVector(FCols[ACol]).FGridIndex);
        end;
      end;
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetMarkedCols(AIndex: Longint): TRCellsVector;
begin
  if FNeedReGenerateMarks then
  begin
    GenerateMarkList();
  end;

  if (AIndex < 0) or (AIndex >= FMarkList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (rgoColsMarking in FOwner.FOptions) then
    Result := TRCellsVector(FMarkList[AIndex])
  else
    Result := Nil;
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCellsHolder.SetMarkedRows(ARow: Longint; Value: Boolean);
var
  k, i: Longint;
  UnionFinded: Boolean;
begin
  if (ARow < 0) or (ARow >= FRows.Count) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if (rgoRowsMarking in FOwner.FOptions) then
  begin
    if TRCellsVector(FRows[ARow]).FMarked <> Value then
    begin
      if (not TRCellsVector(FRows[ARow]).FFixed) then
      begin
        TRCellsVector(FRows[ARow]).FMarked := Value;

        UnionFinded := False;
        for k := 0 to FCellsUnions.UnionsCount - 1 do
        begin
          for i := 0 to  TRCellsUnion(FCellsUnions.FUnionsList[k]).FGridUnionList.Count - 1 do
          begin
            if (ARow >= TRGridUnion(TRCellsUnion(FCellsUnions.FUnionsList[k]).FGridUnionList[i]).FUnionRect.Top)
             and (ARow <= TRGridUnion(TRCellsUnion(FCellsUnions.FUnionsList[k]).FGridUnionList[i]).FUnionRect.Bottom) then
            begin
              TRCellsUnion(FCellsUnions.FUnionsList[k]).FMarked := Value;
              UnionFinded := True;
              Break;
            end;
          end;

          if UnionFinded then
            Break;
        end;

        if (TRCellsVector(FRows[ARow]).FGridIndex >= FOwner.FTopLeft.Y)
          and (TRCellsVector(FRows[ARow]).FGridIndex <= FOwner.FTopLeft.Y + FOwner.VisibleRowCount) then
        begin
          FOwner.InvalidateRow(TRCellsVector(FRows[ARow]).FGridIndex);
        end;
      end;
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetMarkedRows(AIndex: Longint): TRCellsVector;
begin
  if FNeedReGenerateMarks then
  begin
    GenerateMarkList();
  end;

  if (AIndex < 0) or (AIndex >= FMarkList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (rgoRowsMarking in FOwner.FOptions) then
    Result := TRCellsVector(FMarkList[AIndex])
  else
    Result := Nil;
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCellsHolder.SetMarkedCells(ACol, ARow: Longint; Value: Boolean);
begin
  if (ACol < 0) or (ACol >= FCols.Count) or (ARow < 0) or (ARow >= FRows.Count) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if rgoCellsMarking in FOwner.FOptions then
  begin
    if TRCell(TRCellsVector(FRows[ARow]).FCellsList[ACol]).FMarked <> Value then
    begin
      if (not TRCellsVector(FCols[ACol]).FFixed) and (not TRCellsVector(FRows[ARow]).FFixed) then
      begin
        if (TRCell(TRCellsVector(FRows[ARow]).FCellsList[ACol]).FCellsUnion <> NIL) then
        begin
          TRCell(TRCellsVector(FRows[ARow]).FCellsList[ACol]).FCellsUnion.Marked := Value;
        end
        else
        begin
          TRCell(TRCellsVector(FRows[ARow]).FCellsList[ACol]).FMarked := Value;

          if (TRCellsVector(FCols[ACol]).FGridIndex >= FOwner.FTopLeft.X)
            and (TRCellsVector(FCols[ACol]).FGridIndex <= FOwner.FTopLeft.X + FOwner.VisibleColCount)
            and (TRCellsVector(FRows[ARow]).FGridIndex >= FOwner.FTopLeft.Y)
            and (TRCellsVector(FRows[ARow]).FGridIndex <= FOwner.FTopLeft.Y + FOwner.VisibleRowCount) then
          begin
            FOwner.InvalidateCell(TRCellsVector(FCols[ACol]).FGridIndex, TRCellsVector(FRows[ARow]).FGridIndex);
          end;
        end;
      end;
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetMarkedCells(AIndex: Longint): TRCell;
begin
  if FNeedReGenerateMarks then
  begin
    GenerateMarkList();
  end;

  if (AIndex < 0) or (AIndex >= FMarkList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (rgoCellsMarking in FOwner.FOptions) then
    Result := TRCell(FMarkList[AIndex])
  else
    Result := Nil;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetMarkedCount: Longint;
begin
  if FNeedReGenerateMarks then
  begin
    //GenerateMarkList();
    Result := FMarkCount;
  end
  else
    Result := FMarkList.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.ClearMark();
var
  k, i: Longint;
begin
  for k := 0 to FCols.Count - 1 do
  begin
    TRCellsVector(FCols[k]).FMarked := False;
  end;

  for k := 0 to FRows.Count - 1 do
  begin
    TRCellsVector(FRows[k]).FMarked := False;
    for i := 0 to FCols.Count - 1 do
    begin
      TRCell(TRCellsVector(FRows[k]).FCellsList[i]).FMarked := False;
    end;
  end;

  //    ?!...

  FMarkList.Clear();
  FOwner.FMarkList.Clear();
  FNeedReGenerateMarks := False;
  FMarkCount := 0;
  FOwner.FMarkCount := 0;

  FOwner.InvalidateGrid();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.GenerateMarkList();
var
  k, i: Longint;
begin
  FMarkList.Clear();
  FOwner.FMarkList.Clear();

  if (rgoRowsMarking in FOwner.FOptions) then
  begin
    FMarkList.Capacity := FRows.Count;
    FOwner.FMarkList.Capacity := FOwner.FRowCount;

    for k := FFixedRows to FRows.Count - 1 do
    begin
      if (TRCellsVector(FRows[k]).FMarked) then
      begin
        FMarkList.Add(FRows[k]);

        if (TRCellsVector(FRows[k]).FVisible) then
        begin
          FOwner.FMarkList.Add(FRows[k]);
        end;
      end;
    end;
  end
  else if (rgoColsMarking in FOwner.FOptions) then
  begin
    FMarkList.Capacity := FCols.Count;
    FOwner.FMarkList.Capacity := FOwner.FColCount;

    for k := FFixedCols to FCols.Count - 1 do
    begin
      if (TRCellsVector(FCols[k]).FMarked) then
      begin
        FMarkList.Add(FCols[k]);

        if (TRCellsVector(FCols[k]).FVisible) then
        begin
          FOwner.FMarkList.Add(FCols[k]);
        end;
      end;
    end;
  end
  else if (rgoCellsMarking in FOwner.FOptions) then
  begin
    FMarkList.Capacity := FRows.Count * FCols.Count;
    FOwner.FMarkList.Capacity := FOwner.FRowCount * FOwner.FColCount;

    for k := FFixedRows to FRows.Count - 1 do
    begin
      for i := FFixedCols to FCols.Count - 1 do
      begin
        if (TRCell(TRCellsVector(FRows[k]).FCellsList[i]).FMarked) then
        begin
          FMarkList.Add(TRCellsVector(FRows[k]).FCellsList[i]);

          if (TRCellsVector(FRows[k]).FVisible) and (TRCellsVector(FCols[i]).FVisible) then
          begin
            FOwner.FMarkList.Add(TRCellsVector(FRows[k]).FCellsList[i]);
          end;
        end;
      end;
    end;
  end;

  FMarkCount := FMarkList.Count;
  FOwner.FMarkCount := FOwner.FMarkList.Count;

  FNeedReGenerateMarks := False;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.Sort(Compare: TListSortCompare; WithoutFixed: Boolean);
var
  TmpList: TList;
  k: Longint;
begin
  //    
  FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];

  FOwner.PrepareChangeSize;

  if (not WithoutFixed) then
    FRows.Sort(Compare)
  else
  begin
    //׸      ,    ...
    TmpList := TList.Create();
    TmpList.Assign(FRows);

    for k := 0 to FFixedRows - 1 do
      TmpList[k] := NIL;

    TmpList.Pack();  

    TmpList.Sort(Compare);

    for k := FFixedRows to FRows.Count - 1 do
    begin
      FRows[k] := TmpList[k - FFixedRows];
    end;  

    TmpList.Free();  
  end;  

  EnumerateRows;

  //   
  FCellsUnions.Refresh();

  FOwner.DoChangeSize;

  //     FMarkList       FRows
  FNeedReGenerateMarks := True; 

  //FOwner.InvalidateGrid();

  {
  if (not FOwner.FCurrentCell.FRowOwner.FFixed) then
  begin
    if (FOwner.FCurrentCell.GridRow > -1) then
    begin
      FOwner.Row := FOwner.FCurrentCell.GridRow;
    end;
  end;
  }
  
  FOwner.InvalidateGrid();
  
  //FOwner.FCurrentCell := NIL;
end;  
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetCols(ACol: Longint) :TRCellsVector;
begin
  if ((ACol < 0) or (ACol >= FCols.Count)) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  Result := TRCellsVector(FCols[ACol]);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetRows(ARow: Longint) :TRCellsVector;
begin
  if ((ARow < 0) or (ARow >= FRows.Count)) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  Result := TRCellsVector(FRows[ARow]);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCellsHolder.GetCells(ACol, ARow: Longint) :TRCell;
begin
  if (ACol < 0) or (ACol >= FCols.Count) or (ARow < 0) or (ARow >= FRows.Count) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  Result := TRCell(TRCellsVector(FRows[ARow]).FCellsList[ACol]);
end;
//----------------------------------------------------------------------------------------------------------------------
{
function TRCellsHolder.GetColsText(ACol: Longint) :string;
var
  CellText: string;
  k: Longint;
begin
  Result := '';

  if ((ACol < 0) or (ACol >= FCols.Count)) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  for k := 0 to FRows.Count - 1 do
  begin
    FOwner.DoGetCellText(Cells[ACol, k], CellText);
    Result := Result + CellText;

    if k < FRows.Count - 1 then
    begin
      Result := Result + '\n';
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCellsHolder.GetRowsText(ARow: Longint) :string;
var
  CellText: string;
  k: Longint;
begin
  Result := '';

  if ((ARow < 0) or (ARow >= FRows.Count)) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  for k := 0 to FCols.Count - 1 do
  begin
    FOwner.DoGetCellText(Cells[k, ARow], CellText);
    Result := Result + CellText;

    if k < FCols.Count - 1 then
    begin
      Result := Result + '\n';
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DoMoveColumn(FromIndex, ToIndex: Longint);
var
  k: Longint;
begin
  if TRCellsVector(FCols[FromIndex]).FVisible and TRCellsVector(FCols[ToIndex]).FVisible and (FromIndex >= FFixedCols) and (ToIndex >= FFixedCols) then
  begin
    FCols.Move(FromIndex, ToIndex);
    for k := 0 to FRows.Count - 1 do
    begin
      TRCellsVector(FRows[k]).FCellsList.Move(FromIndex, ToIndex);
    end;
    EnumerateCols();
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DoMoveRow(FromIndex, ToIndex: Longint);
begin
  if TRCellsVector(FRows[FromIndex]).FVisible and TRCellsVector(FRows[ToIndex]).FVisible and (FromIndex >= FFixedRows) and (ToIndex >= FFixedRows) then
  begin
    FRows.Move(FromIndex, ToIndex);
    EnumerateRows();
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.ReadColWidths(Reader: TReader);
var
  I: Integer;
begin
  with Reader do
  begin
    ReadListBegin;
    for I := 0 to ColCount - 1 do ColWidths[I] := ReadInteger;
    ReadListEnd;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.ReadRowHeights(Reader: TReader);
var
  I: Integer;
begin
  with Reader do
  begin
    ReadListBegin;
    for I := 0 to RowCount - 1 do RowHeights[I] := ReadInteger;
    ReadListEnd;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.WriteColWidths(Writer: TWriter);
var
  I: Integer;
begin
  with Writer do
  begin
    WriteListBegin;
    for I := 0 to ColCount - 1 do WriteInteger(ColWidths[I]);
    WriteListEnd;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.WriteRowHeights(Writer: TWriter);
var
  I: Integer;
begin
  with Writer do
  begin
    WriteListBegin;
    for I := 0 to RowCount - 1 do WriteInteger(RowHeights[I]);
    WriteListEnd;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  with Filer do
  begin
    DefineProperty('ColWidths', ReadColWidths, WriteColWidths, True);
    DefineProperty('RowHeights', ReadRowHeights, WriteRowHeights, True);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetVisibleColsRange(AColsList: TList; Reverse: Boolean);
var
  k: Longint;
  VisibleCount: Longint;
  ColsList: TList;
  RverseList: TList;
  
begin
  ColsList   := NIL;
  RverseList := NIL;

  if (AColsList <> NIL)  then
  begin
    // AColsList   ,     , 
    //   :
    ColsList := TList.Create;
    ColsList.Assign(AColsList);
  
    //,     .  ...
    for k := 0 to ColsList.Count - 1 do
    begin
      if (FCols.IndexOf(ColsList[k]) < 0)  then
        ColsList[k] := NIL;
    end;    
    ColsList.Pack();

    // ColsList.Count < 1,    ...
    if (ColsList.Count > 0) then
    begin
      //    
      FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
    
      FOwner.PrepareChangeSize;

      VisibleCount := FVisibleColCount;

      RverseList := TList.Create();
      RverseList.Clear();
      
      if (ColsList.Count < FCols.Count) then
      begin
        RverseList.Capacity := FCols.Count;
        for k := 0 to FCols.Count - 1 do
        begin
          if (ColsList.IndexOf(FCols[k]) < 0)  then
            RverseList.Add(FCols[k]);
        end;    
        RverseList.Capacity := RverseList.Count;
      end;

      //      !
      if Reverse then
      begin
        for k := 0 to ColsList.Count - 1 do
        begin
          if (TRCellsVector(RverseList[k]).FVisible) then
          begin
            if ((VisibleCount + RverseList.Count) > 1) then
            begin
              TRCellsVector(ColsList[k]).FVisible := False;
              Dec(VisibleCount);
            end
            else
              Break;
          end;    
        end;

        for k := 0 to RverseList.Count - 1 do
        begin
          TRCellsVector(RverseList[k]).FVisible := True;
        end;
      end
      else
      begin
        for k := 0 to RverseList.Count - 1 do
        begin
          if (TRCellsVector(RverseList[k]).FVisible) then
          begin
            if ((VisibleCount + ColsList.Count) > 1) then
            begin
              TRCellsVector(RverseList[k]).FVisible := False;
              Dec(VisibleCount);
            end
            else
              Break;
          end;    
        end;

        for k := 0 to ColsList.Count - 1 do
        begin
          TRCellsVector(ColsList[k]).FVisible := True;
        end;
      end;

      FOwner.VirtualView := True; //???

      EnumerateCols;

      {     FOwner.DoChangeSize;
      if (FOwner.FCurrent.X < FOwner.FFixedCols) then
        FOwner.FCurrent.X := FOwner.FFixedCols;

      if (FOwner.FCurrent.X >= FOwner.FColCount) then
        FOwner.FCurrent.X := FOwner.FColCount - 1;  
      }  
    
      FOwner.DoChangeSize;
      
    end;
  end;
  
  if (ColsList <> NIL) then
    ColsList.Free();

  if (RverseList <> NIL) then
    RverseList.Free(); 
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetVisibleRowsRange(ARowsList: TList; Reverse: Boolean);
var
  k: Longint;
  VisibleCount: Longint;
  RowsList: TList;
  RverseList: TList;
  
begin
  RowsList   := NIL;
  RverseList := NIL;

  if (ARowsList <> NIL)  then
  begin
    // ARowsList   ,     , 
    //   :
    RowsList := TList.Create;
    RowsList.Assign(ARowsList);
  
    //,     .  ...
    for k := 0 to RowsList.Count - 1 do
    begin
      if (FRows.IndexOf(RowsList[k]) < 0)  then
        RowsList[k] := NIL;
    end;    
    RowsList.Pack();

    // RowsList.Count < 1,    ...
    if (RowsList.Count > 0) then
    begin
      //    
      FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
    
      FOwner.PrepareChangeSize;

      VisibleCount := FVisibleRowCount;

      RverseList := TList.Create();
      RverseList.Clear();
      
      if (RowsList.Count < FRows.Count) then
      begin
        RverseList.Capacity := FRows.Count;
        for k := 0 to FRows.Count - 1 do
        begin
          if (RowsList.IndexOf(FRows[k]) < 0)  then
            RverseList.Add(FRows[k]);
        end;    
        RverseList.Capacity := RverseList.Count;
      end;

      //      !
      if Reverse then
      begin
        for k := 0 to RowsList.Count - 1 do
        begin
          if (TRCellsVector(RowsList[k]).FVisible) then
          begin
            if ((VisibleCount + RverseList.Count) > 1) then
            begin
              TRCellsVector(RowsList[k]).FVisible := False;
              Dec(VisibleCount);
            end
            else
              Break;
          end;    
        end;

        for k := 0 to RverseList.Count - 1 do
        begin
          TRCellsVector(RverseList[k]).FVisible := True;
        end;
      end
      else
      begin
        for k := 0 to RverseList.Count - 1 do
        begin
          if (TRCellsVector(RverseList[k]).FVisible) then
          begin
            if ((VisibleCount + RowsList.Count) > 1) then
            begin
              TRCellsVector(RverseList[k]).FVisible := False;
              Dec(VisibleCount);
            end
            else
              Break;
          end;    
        end;

        for k := 0 to RowsList.Count - 1 do
        begin
          TRCellsVector(RowsList[k]).FVisible := True;
        end;
      end;

      FOwner.VirtualView := True; //???

      EnumerateRows;

      {     FOwner.DoChangeSize;
      if (FOwner.FCurrent.Y < FOwner.FFixedRows) then
        FOwner.FCurrent.Y := FOwner.FFixedRows;

      if (FOwner.FCurrent.Y >= FOwner.FRowCount) then
        FOwner.FCurrent.Y := FOwner.FRowCount - 1;
      }    
    
      FOwner.DoChangeSize;
    end;
  end;

  if (RowsList <> NIL) then
    RowsList.Free();

  if (RverseList <> NIL) then
    RverseList.Free(); 
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetVisibleAllCols();
var
  k: Longint;

begin
  if (FVisibleColCount < FCols.Count) then
  begin
    //    
    FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
  
    FOwner.PrepareChangeSize;

    for k := 0 to FCols.Count - 1 do
    begin
      TRCellsVector(FCols[k]).FVisible := True;
    end;

    FOwner.VirtualView := True; //???

    EnumerateCols;

    FOwner.DoChangeSize;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.SetVisibleAllRows();
var
  k: Longint;

begin
  if (FVisibleRowCount < FRows.Count) then
  begin
    //    
    FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
  
    FOwner.PrepareChangeSize;

    for k := 0 to FRows.Count - 1 do
    begin
      TRCellsVector(FRows[k]).FVisible := True;
    end;

    FOwner.VirtualView := True; //???

    EnumerateRows;

    FOwner.DoChangeSize;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DeleteColsRange(AColsList: TList);
var
  k, i, m: Longint;
  ColsCount: Longint;
  ColsList: TList;
begin
  ColsList := NIL;

  if (AColsList <> NIL)  then
  begin
    // AColsList   ,     , 
    //   :
    ColsList := TList.Create;
    ColsList.Assign(AColsList);
  
    //,     .  ...
    for k := 0 to ColsList.Count - 1 do
    begin
      if (FCols.IndexOf(ColsList[k]) < 0)  then
        ColsList[k] := NIL;
    end;    
    ColsList.Pack();

    // ColsList.Count < 1,    ...
    if (ColsList.Count > 0) then
    begin
      //    
      FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
    
      FOwner.PrepareChangeSize;
    
      ColsCount := FCols.Count;

      for k := 0 to FCols.Count - 1 do
      begin
        if (ColsList.IndexOf(FCols[k]) > -1) then
        begin
          if (ColsCount > 1) then
          begin    
            //,    ,   
            // ,      ...

            FDeleting := True;  //  ...

            for i := 0 to FCellsUnions.UnionsCount - 1 do
            begin
              for m := 0 to FCellsUnions.Unions[i].CellsCount - 1 do
              begin
                if (FCellsUnions.Unions[i].Cells[m].FColOwner = FCols[k]) then
                  FCellsUnions.Unions[i].FCellsList[m] := NIL;
              end;
              FCellsUnions.Unions[i].FCellsList.Pack();

              if (FCellsUnions.Unions[i].CellsCount < 2) then
              begin
                TRCellsUnion(FCellsUnions.FUnionsList[i]).Free;
                FCellsUnions.FUnionsList[i] := NIL;
              end;
            end;
            FCellsUnions.FUnionsList.Pack();
            
            FDeleting := False;

            // ...
            for i := 0 to FRows.Count - 1 do
            begin
              TRCell(TRCellsVector(FRows[i]).FCellsList[k]).Free();
              TRCellsVector(FRows[i]).FCellsList[k] := NIL;
            end;   

            TRCellsVector(FCols[k]).Free;
            FCols[k] := NIL;
            Dec(ColsCount);
          end;
        end;
      end;
      
      for i := 0 to FRows.Count - 1 do
      begin
        TRCellsVector(FRows[i]).FCellsList.Pack();
        TRCellsVector(FRows[i]).FCellsList.Capacity := TRCellsVector(FRows[i]).FCellsList.Count;
      end; 
      
      FCols.Pack();
      FCols.Capacity := FCols.Count;

      FOwner.VirtualView := True; //???

      EnumerateCols;

      {     FOwner.DoChangeSize;
      if (FOwner.FCurrent.X < FOwner.FFixedCols) then
        FOwner.FCurrent.X := FOwner.FFixedCols;

      if (FOwner.FCurrent.X >= FOwner.FColCount) then
        FOwner.FCurrent.X := FOwner.FColCount - 1;
      }    
    
      FOwner.DoChangeSize;
    end;
  end;

  if (ColsList <> NIL) then
    ColsList.Free();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DeleteRowsRange(ARowsList: TList);
var
  k, i, m: Longint;
  RowsCount: Longint;
  RowsList: TList;
begin
  RowsList := NIL;

  if (ARowsList <> NIL)  then
  begin
    // ARowsList   ,     , 
    //   :
    RowsList := TList.Create;
    RowsList.Assign(ARowsList);
  
    //,     .  ...
    for k := 0 to RowsList.Count - 1 do
    begin
      if (FRows.IndexOf(RowsList[k]) < 0)  then
        RowsList[k] := NIL;
    end;    
    RowsList.Pack();

    // RowsList.Count < 1,    ...
    if (RowsList.Count > 0) then
    begin
      //    
      FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
    
      FOwner.PrepareChangeSize;
    
      RowsCount := FRows.Count;

      for k := 0 to FRows.Count - 1 do
      begin
        if (RowsList.IndexOf(FRows[k]) > -1) then
        begin  
          if (RowsCount > 1) then
          begin
            //,    ,   
            // ,      ...
            
            FDeleting := True;
            for i := 0 to FCellsUnions.UnionsCount - 1 do
            begin
              for m := 0 to FCellsUnions.Unions[i].CellsCount - 1 do
              begin
                if (FCellsUnions.Unions[i].Cells[m].FRowOwner = FRows[k]) then
                  FCellsUnions.Unions[i].FCellsList[m] := NIL;
              end;
              FCellsUnions.Unions[i].FCellsList.Pack();

              if (FCellsUnions.Unions[i].CellsCount < 2) then
              begin
                TRCellsUnion(FCellsUnions.FUnionsList[i]).Free;
                FCellsUnions.FUnionsList[i] := NIL;
              end;
            end;
            FCellsUnions.FUnionsList.Pack();
            FDeleting := False;

            TRCellsVector(FRows[k]).Free;
            FRows[k] := NIL;
            Dec(RowsCount);
          end;  
        end;
      end;
      FRows.Pack();
      FRows.Capacity := FRows.Count;

      FOwner.VirtualView := True; //???

      EnumerateRows;

      {     FOwner.DoChangeSize;
      if (FOwner.FCurrent.X < FOwner.FFixedRows) then
        FOwner.FCurrent.X := FOwner.FFixedRows;

      if (FOwner.FCurrent.X >= FOwner.FRowCount) then
        FOwner.FCurrent.X := FOwner.FRowCount - 1;  
      }  
    
      FOwner.DoChangeSize;
    end;
  end;

  if (RowsList <> NIL) then
    RowsList.Free();
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DeleteCol(ACol: Longint);
var
  i, m: Longint;
begin
  if (ACol < 0) or (ACol >= FCols.Count) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if (FCols.Count > 1) then
  begin
    //    
    FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
  
    FOwner.PrepareChangeSize;

    //,    ,   
    // ,      ...
    FDeleting := True;
    for i := 0 to FCellsUnions.UnionsCount - 1 do
    begin
      for m := 0 to FCellsUnions.Unions[i].CellsCount - 1 do
      begin
        if (FCellsUnions.Unions[i].Cells[m].FColOwner = FCols[ACol]) then
          FCellsUnions.Unions[i].FCellsList[m] := NIL;
      end;
      FCellsUnions.Unions[i].FCellsList.Pack();

      if (FCellsUnions.Unions[i].CellsCount < 2) then
      begin
        TRCellsUnion(FCellsUnions.FUnionsList[i]).Free;
        FCellsUnions.FUnionsList[i] := NIL;
      end;
    end;
    FCellsUnions.FUnionsList.Pack();
    FDeleting := False;

    // ...
    for i := 0 to FRows.Count - 1 do
    begin
      TRCell(TRCellsVector(FRows[i]).FCellsList[ACol]).Free();
      TRCellsVector(FRows[i]).FCellsList[ACol] := NIL;
      TRCellsVector(FRows[i]).FCellsList.Pack();
      TRCellsVector(FRows[i]).FCellsList.Capacity := TRCellsVector(FRows[i]).FCellsList.Count;
    end;   

    TRCellsVector(FCols[ACol]).Free;
    FCols[ACol] := NIL;
    FCols.Pack();

    FOwner.VirtualView := True; //???

    EnumerateCols;

    {     FOwner.DoChangeSize;
    if (FOwner.FCurrent.X < FOwner.FFixedCols) then
      FOwner.FCurrent.X := FOwner.FFixedCols;

    if (FOwner.FCurrent.X >= FOwner.FColCount) then
      FOwner.FCurrent.X := FOwner.FColCount - 1;
    }    
    
    FOwner.DoChangeSize;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.DeleteRow(ARow: Longint);
var
  i, m: Longint;
begin
  if (ARow < 0) or (ARow >= FRows.Count) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
    //Exit;
  end;

  if (FRows.Count > 1) then
  begin
    //    
    FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
  
    FOwner.PrepareChangeSize;

    //,    ,   
    // ,      ...
    FDeleting := True;
    for i := 0 to FCellsUnions.UnionsCount - 1 do
    begin
      for m := 0 to FCellsUnions.Unions[i].CellsCount - 1 do
      begin
        if (FCellsUnions.Unions[i].Cells[m].FRowOwner = FRows[ARow]) then
          FCellsUnions.Unions[i].FCellsList[m] := NIL;
      end;
      FCellsUnions.Unions[i].FCellsList.Pack();

      if (FCellsUnions.Unions[i].CellsCount < 2) then
      begin
        TRCellsUnion(FCellsUnions.FUnionsList[i]).Free;
        FCellsUnions.FUnionsList[i] := NIL;
      end;
    end;
    FCellsUnions.FUnionsList.Pack();
    FDeleting := False;

    TRCellsVector(FRows[ARow]).Free;
    FRows[ARow] := NIL;
    FRows.Pack();
    FRows.Capacity := FRows.Count;

    FOwner.VirtualView := True; //???

    EnumerateRows;

    {     FOwner.DoChangeSize;
    if (FOwner.FCurrent.X < FOwner.FFixedRows) then
      FOwner.FCurrent.X := FOwner.FFixedRows;

    if (FOwner.FCurrent.X >= FOwner.FRowCount) then
      FOwner.FCurrent.X := FOwner.FRowCount - 1;
    }    
    
    FOwner.DoChangeSize;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCellsHolder.AddCol(AVisible: Boolean): TRCellsVector;
var
  k, i, ResultIndex, NewColCount: Longint;
begin
  NewColCount := FCols.Count + 1;

  if (AVisible) then
  begin
    //    
    FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
  
    FOwner.PrepareChangeSize;
  end;  

  if FCols.Count < FFixedCols then
    ResultIndex := FCols.Add(TRCellsVector.Create(Self, True, True, AVisible, FOwner.FDefaultColWidth, NIL))
  else
    ResultIndex := FCols.Add(TRCellsVector.Create(Self, True, False, AVisible, FOwner.FDefaultColWidth, NIL));

  EnumerateCols;
  FOwner.DoInitCellsVector(TRCellsVector(FCols[ResultIndex]));

  for k := 0 to FRows.Count - 1 do
  begin
    i := TRCellsVector(FRows[k]).FCellsList.Count;
    while TRCellsVector(FRows[k]).FCellsList.Count < NewColCount do
    begin
      //TRCellsVector(FRows[k]).FCellsList.Capacity := NewColCount;
      TRCellsVector(FRows[k]).FCellsList.Add(TRCell.Create(TRCellsVector(FCols[i]), TRCellsVector(FRows[k]){, True}));
      FOwner.DoInitCell(TRCell(TRCellsVector(FRows[k]).FCellsList.Last()));
      Inc(i);
    end;
  end;

  if AVisible then
  begin

    FOwner.DoChangeSize;
  end;

  Result := TRCellsVector(FCols[ResultIndex]);
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCellsHolder.AddRow(AVisible: Boolean): TRCellsVector;
var
  i, ResultIndex: Longint;
begin
  if (AVisible) then
  begin
    //    
    FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
  
    FOwner.PrepareChangeSize;
  end;  

  //FRows.Capacity := FRows.Capacity + 1;
  if FRows.Count < FFixedRows then
    ResultIndex := FRows.Add(TRCellsVector.Create(Self, False, True, AVisible, FOwner.FDefaultRowHeight, TList.Create()))
  else
    ResultIndex := FRows.Add(TRCellsVector.Create(Self, False, False, AVisible, FOwner.FDefaultRowHeight, TList.Create()));

  EnumerateRows;
  FOwner.DoInitCellsVector(TRCellsVector(FRows[ResultIndex]));

  TRCellsVector(FRows[ResultIndex]).FCellsList.Capacity := FCols.Count;
  i := TRCellsVector(FRows[ResultIndex]).FCellsList.Count;
  while TRCellsVector(FRows[ResultIndex]).FCellsList.Count < FCols.Count do
  begin
    TRCellsVector(FRows[ResultIndex]).FCellsList.Add(TRCell.Create(TRCellsVector(FCols[i]), TRCellsVector(FRows[ResultIndex]){, True}));
    FOwner.DoInitCell(TRCell(TRCellsVector(FRows[ResultIndex]).FCellsList.Last()));
    Inc(i);
  end;

  if AVisible then
  begin
    
    FOwner.DoChangeSize;
  end;

  Result := TRCellsVector(FRows[ResultIndex]);
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCellsHolder.InsertCol(APosition: Longint; AVisible: Boolean): TRCellsVector;
var
  k: Longint;
begin
  if (APosition >= FCols.Count) then
    Result := AddCol(AVisible)
  else
  begin
    if (APosition < 0) then
      APosition := 0;

    if (AVisible) then
    begin
      //    
      FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
    
      FOwner.PrepareChangeSize;
    end;  

    if (APosition < FFixedCols) then
      FCols.Insert(APosition, TRCellsVector.Create(Self, True, True, AVisible, FOwner.FDefaultColWidth, NIL))
    else
      FCols.Insert(APosition, TRCellsVector.Create(Self, True, False, AVisible, FOwner.FDefaultColWidth, NIL));

    EnumerateCols;
    FOwner.DoInitCellsVector(TRCellsVector(FCols[APosition]));

    // 
    for k := 0 to FRows.Count - 1 do
    begin
      TRCellsVector(FRows[k]).FCellsList.Insert(APosition, TRCell.Create(TRCellsVector(FCols[APosition]), TRCellsVector(FRows[k]){, True}));
      FOwner.DoInitCell(TRCell(TRCellsVector(FRows[k]).FCellsList[APosition]));
    end;  

    if AVisible then
    begin
      FOwner.VirtualView := True; //???

      if (FOwner.FCurrent.X < FOwner.FFixedCols) then
        FOwner.FCurrent.X := FOwner.FFixedCols;

      if (FOwner.FCurrent.X >= FOwner.FColCount) then
        FOwner.FCurrent.X := FOwner.FColCount - 1;  

      FOwner.DoChangeSize;
    end;

    Result := TRCellsVector(FCols[APosition]);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCellsHolder.InsertRow(APosition: Longint; AVisible: Boolean): TRCellsVector;
var
  i: Longint;
begin
  if (APosition >= FRows.Count) then
    Result := AddRow(AVisible)
  else
  begin
    if (APosition < 0) then
      APosition := 0;

    if (AVisible) then
    begin
      //    
      FOwner.FCurrentCell := FOwner.Cells[FOwner.Col, FOwner.Row];
    
      FOwner.PrepareChangeSize;
    end;  

    if (APosition < FFixedRows) then
      FRows.Insert(APosition, TRCellsVector.Create(Self, False, True, AVisible, FOwner.FDefaultRowHeight, TList.Create()))
    else
      FRows.Insert(APosition, TRCellsVector.Create(Self, False, False, AVisible, FOwner.FDefaultRowHeight, TList.Create()));

    EnumerateRows;

    FOwner.DoInitCellsVector(TRCellsVector(FRows[APosition]));

    TRCellsVector(FRows[APosition]).FCellsList.Capacity := FCols.Count;
    i := TRCellsVector(FRows[APosition]).FCellsList.Count;
    while TRCellsVector(FRows[APosition]).FCellsList.Count < FCols.Count do
    begin
      TRCellsVector(FRows[APosition]).FCellsList.Add(TRCell.Create(TRCellsVector(FCols[i]), TRCellsVector(FRows[APosition]){, True}));
      FOwner.DoInitCell(TRCell(TRCellsVector(FRows[APosition]).FCellsList.Last()));
      Inc(i);
    end;

    if AVisible then
    begin
      FOwner.VirtualView := True; //???

      if (FOwner.FCurrent.X < FOwner.FFixedCols) then
        FOwner.FCurrent.X := FOwner.FFixedCols;

      if (FOwner.FCurrent.X >= FOwner.FColCount) then
        FOwner.FCurrent.X := FOwner.FColCount - 1;  

      FOwner.DoChangeSize;
    end;  

    Result := TRCellsVector(FRows[APosition]);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.FreeCellsRangeData(AStart, AEnd: TRGridCoord);
var
  k, i: Longint;
begin
  if (AStart.X < 0) or (AStart.X >= FCols.Count) or (AStart.Y < 0) or (AStart.Y >= FRows.Count) 
    or (AEnd.X < 0) or (AEnd.X >= FCols.Count) or (AEnd.Y < 0) or (AEnd.Y >= FRows.Count) 
  then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (AStart.X > AEnd.X) then
  begin
    k := AStart.X;
    AStart.X := AEnd.X;
    AEnd.X := k;
  end;

  if (AStart.Y > AEnd.Y) then
  begin
    k := AStart.Y;
    AStart.Y := AEnd.Y;
    AEnd.Y := k;
  end;

  for k := AStart.Y to AEnd.Y do
  begin
    for i := AStart.X to AEnd.X do
    begin
      FOwner.DoFreeCell(TRCell(TRCellsVector(FRows[k]).FCellsList[i]));
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.InitCellsRangeData(AStart, AEnd: TRGridCoord);
var
  k, i: Longint;
begin
  if (AStart.X < 0) or (AStart.X >= FCols.Count) or (AStart.Y < 0) or (AStart.Y >= FRows.Count)
    or (AEnd.X < 0) or (AEnd.X >= FCols.Count) or (AEnd.Y < 0) or (AEnd.Y >= FRows.Count)
  then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (AStart.X > AEnd.X) then
  begin
    k := AStart.X;
    AStart.X := AEnd.X;
    AEnd.X := k;
  end;

  if (AStart.Y > AEnd.Y) then
  begin
    k := AStart.Y;
    AStart.Y := AEnd.Y;
    AEnd.Y := k;
  end;

  for k := AStart.Y to AEnd.Y do
  begin
    for i := AStart.X to AEnd.X do
    begin
      FOwner.DoInitCell(TRCell(TRCellsVector(FRows[k]).FCellsList[i]));
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.FreeVectorsRangeData(AIsColumn: Boolean; AStart, AEnd: Longint);
var
  k: Longint;
  TempList: TList;
begin
  if AIsColumn  then
    TempList := FCols
  else
    TempList := FRows;

  if (AStart < 0) or (AStart >= TempList.Count) or (AEnd < 0) or (AEnd >= TempList.Count)
  then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  for k := AStart to AEnd do
  begin
    FOwner.DoFreeCellsVector(TRCellsVector(TempList[k]));
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCellsHolder.InitVectorsRangeData(AIsColumn: Boolean; AStart, AEnd: Longint);
var
  k: Longint;
  TempList: TList;

begin
  if AIsColumn  then
    TempList := FCols
  else
    TempList := FRows;

  if (AStart < 0) or (AStart >= TempList.Count) or (AEnd < 0) or (AEnd >= TempList.Count)
  then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  for k := AStart to AEnd do
  begin
    FOwner.DoInitCellsVector(TRCellsVector(TempList[k]));
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
//  uses Math, Consts, RTLConsts;
//----------------------------------------------------------------------------------------------------------------------
{ Private. LongMulDiv multiplys the first two arguments and then
  divides by the third.  This is used so that real number
  (floating point) arithmetic is not necessary.  This routine saves
  the possible 64-bit value in a temp before doing the divide.  Does
  not do error checking like divide by zero.  Also assumes that the
  result is in the 32-bit range (Actually 31-bit, since this algorithm
  is for unsigned). }

function LongMulDiv(Mult1, Mult2, Div1: Longint): Longint; stdcall;
{$IFDEF LINUX}
{$IFDEF WINE}
  external 'libwine.so' name 'MulDiv';
{$ELSE}
  external 'libtwin32.so' name 'MulDiv';
{$ENDIF}
{$ENDIF}
{$IFDEF WIN32}
  external 'kernel32.dll' name 'MulDiv';
{$ENDIF}
//----------------------------------------------------------------------------------------------------------------------
procedure KillMessage(Wnd: HWnd; Msg: Integer);
// Delete the requested message from the queue, but throw back
// any WM_QUIT msgs that PeekMessage may also return
var
  M: TMsg;
begin
  M.Message := 0;
  if PeekMessage(M, Wnd, Msg, Msg, pm_Remove) and (M.Message = WM_QUIT) then
    PostQuitMessage(M.wparam);
end;
//----------------------------------------------------------------------------------------------------------------------
//  TRCustomGrid 
//----------------------------------------------------------------------------------------------------------------------
constructor TRCustomGrid.Create(AOwner: TComponent);
const
  GridStyle = [csCaptureMouse, csOpaque, csDoubleClicks];
begin
  inherited Create(AOwner);
  if NewStyleControls then
    ControlStyle := GridStyle
  else
    ControlStyle := GridStyle + [csFramed];

  FDrawBitmap := TBitmap.Create;
  //FCellImage := TBitmap.Create;

  FRecursionTrap := False;

  FCurrentCell := NIL;
  
  FColsEnumerator := NIL;
  FRowsEnumerator := NIL;

  // 
  FMarkList := TList.Create();
  FMarkList.Clear();
  FMarkCount := 0;

  FKeyboardMarkRange := False;

  FPressedCell.X := -1;
  FPressedCell.Y := -1;

  VirtualView := False;

  FGridLineWidth := 1;

  FDefaultColWidth := 64;
  FDefaultRowHeight := 24;

  FOptions := [rgoFixedVertLine, rgoFixedHorzLine, rgoVertLine, rgoHorzLine, rgoShowFocusCell];
  DesignOptionsBoost := [rgoColSizing, rgoRowSizing];
  FFocusFrameStyle := rffDotRect;

  FScrollBars := ssBoth;
  FBorderStyle := bsSingle;
  
  ParentColor := False;


  FImageChangeLink := TChangeLink.Create;
  FImageChangeLink.OnChange := ImageListChange;

  FColors := TRGridColors.Create(Self);
  FFonts := TRGridFonts.Create(Self);
  FHolder := TRCellsHolder.Create(Self);

  TabStop := True;
  SetBounds(Left, Top, ColCount * FDefaultColWidth, RowCount * FDefaultRowHeight);
  Initialize;
end;
//----------------------------------------------------------------------------------------------------------------------
destructor TRCustomGrid.Destroy;
begin
  FOnChangeFocus := nil;

  inherited Destroy;

  FColors.Free;
  FFonts.Free;
  FHolder.Free;

  if FColsEnumerator <> NIL then
  begin
    FreeMem(FColsEnumerator, SizeOf(FColsEnumerator));
  end;

  if FRowsEnumerator <> NIL then
  begin
    FreeMem(FRowsEnumerator, SizeOf(FRowsEnumerator));
  end;

  FDrawBitmap.Free;
  FDrawBitmap := nil;
  {
  FCellImage.Free;
  FCellImage := nil;
  }
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GridToHolderCol(ACol: Longint): Longint;
begin
  Result := -1;

  if (ACol > -1) and (ACol < ColCount) then
    Result := PLongintArray(FColsEnumerator)^[ACol]
  else
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GridToHolderRow(ARow: Longint): Longint;
begin
  Result := -1;

  if (ARow > -1) and (ARow < RowCount) then
    Result := PLongintArray(FRowsEnumerator)^[ARow]
  else
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GridToHolderCell(ACoord: TRGridCoord): TRGridCoord;
begin
  Result.X := GridToHolderCol(ACoord.X);
  Result.Y := GridToHolderRow(ACoord.Y);
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.BoxRect(ALeft, ATop, ARight, ABottom: Longint): TRect;
var
  GridRect: TRGridRect;
begin
  GridRect.Left := ALeft;
  GridRect.Right := ARight;
  GridRect.Top := ATop;
  GridRect.Bottom := ABottom;
  GridRectToScreenRect(GridRect, Result, False);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoExit;
begin
  inherited DoExit;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.CellRect(ACol, ARow: Longint): TRect;
begin
  if (ACol > -1) and (ACol < ColCount) and (ARow > -1) and (ARow < RowCount) then
  begin
    Result := BoxRect(ACol, ARow, ACol, ARow);
  end
  else
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.UnionRect(ACol, ARow: Longint): TRect;
begin
  if (ACol > -1) and (ACol < ColCount) and (ARow > -1) and (ARow < RowCount) then
  begin
    if (Cells[ACol, ARow].BelongsToUnion) then
    begin
      Result := BoxRect(Cells[ACol, ARow].GridUnion.FUnionRect.Left,
                        Cells[ACol, ARow].GridUnion.FUnionRect.Top,
                        Cells[ACol, ARow].GridUnion.FUnionRect.Right,
                        Cells[ACol, ARow].GridUnion.FUnionRect.Bottom);
    end
    else
    begin
      Result := BoxRect(ACol, ARow, ACol, ARow);
    end;
  end
  else
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.CanGridAcceptKey(Key: Word; Shift: TShiftState): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.IsActiveControl: Boolean;
var
  H: Hwnd;
  ParentForm: TCustomForm;
begin
  Result := False;
  ParentForm := GetParentForm(Self);
  if Assigned(ParentForm) then
  begin
    if (ParentForm.ActiveControl = Self) then
      Result := True
  end
  else
  begin
    H := GetFocus;
    while IsWindow(H) and (Result = False) do
    begin
      if H = WindowHandle then
        Result := True
      else
        H := GetParent(H);
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.HasFocus: Boolean;
var
  ParentForm: TCustomForm;
begin
  Result := False;
  ParentForm := GetParentForm(Self);
  if Assigned(ParentForm) then
  begin
    if ParentForm.Active then Result := True;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveColumn(FromIndex, ToIndex: Longint);
var
  Rect: TRGridRect;
  k{, i}: Longint;
begin
  if FromIndex = ToIndex then Exit;

  //       ?
  //    ...


  //     FHolder
  //   ,
  //     
  FHolder.DoMoveColumn(GridToHolderCol(FromIndex), GridToHolderCol(ToIndex));

  MoveAdjust(FCurrent.X, FromIndex, ToIndex);
  RefreshCurrentRect;

  Rect.Top := 0;
  Rect.Bottom := FTopLeft.Y + VisibleRowCount;
  if FromIndex < ToIndex then
  begin
    Rect.Left := FromIndex;
    Rect.Right := ToIndex;
  end
  else
  begin
    Rect.Left := ToIndex;
    Rect.Right := FromIndex;
  end;

  

  InvalidateRect(Rect);
  //     !!!
  
  //   ...
  for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
  begin
    Holder.CellsUnions.Unions[k].Invalidate();
  end;  

  {  
  Dec(Rect.Left);
  Inc(Rect.Right);
  for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
  begin
    for i := 0 to Holder.CellsUnions.Unions[k].GridUnionsCount - 1 do
    begin
      if       //     FromIndex...ToIndex
        (((Rect.Left >= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left)
        and (Rect.Left <= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Right))
        or ((Rect.Right >= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left)
        and (Rect.Right <= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Right)))

        and    //     FixedRows, TopLeft.Y...TopLeft.Y+VisibleRowCount
        (((Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top <= FFixedRows)
        and (Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Bottom <= FFixedRows))
        or ((Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top >= FTopLeft.Y)
        and (Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top <= (FTopLeft.Y +VisibleRowCount)))
        or ((Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Bottom >= FTopLeft.Y)
        and (Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Bottom <= (FTopLeft.Y +VisibleRowCount))))
      then
        InvalidateCell(Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left, Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top);
    end;
  end;
  }

  
  //       ,
  //..   ...
  DoColumnMoved(FromIndex, ToIndex);
  ColWidthsChanged;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveRow(FromIndex, ToIndex: Longint);
var
  Rect: TRGridRect;
  k{, i}: Longint;
begin
  if FromIndex = ToIndex then Exit;

  //       ?
  //    ...

  //     FHolder
  //   ,
  //     
  FHolder.DoMoveRow(GridToHolderRow(FromIndex), GridToHolderRow(ToIndex));

  MoveAdjust(FCurrent.Y, FromIndex, ToIndex);
  RefreshCurrentRect;

  Rect.Left := 0;
  Rect.Right := FTopLeft.X + VisibleColCount;

  if FromIndex < ToIndex then
  begin
    Rect.Top := FromIndex;
    Rect.Bottom := ToIndex;
  end
  else
  begin
    Rect.Top := ToIndex;
    Rect.Bottom := FromIndex;
  end;

  InvalidateRect(Rect);
  //     !!!
  //   ...
  for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
  begin
    Holder.CellsUnions.Unions[k].Invalidate();
  end;  

  {  
  Dec(Rect.Top);
  Inc(Rect.Bottom);
  for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
  begin
    for i := 0 to Holder.CellsUnions.Unions[k].GridUnionsCount - 1 do
    begin
      if       //     FromIndex...ToIndex
        (((Rect.Top >= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top)
        and (Rect.Top <= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Bottom))
        or ((Rect.Bottom >= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top)
        and (Rect.Bottom <= Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Bottom)))

        and    //     FixedCols, TopLeft.X...TopLeft.X+VisibleColCount
        (((Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left <= FFixedCols)
        and (Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Right <= FFixedCols))
        or ((Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left >= FTopLeft.X)
        and (Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left <= (FTopLeft.X +VisibleColCount)))
        or ((Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Right >= FTopLeft.X)
        and (Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Right <= (FTopLeft.X +VisibleColCount))))
      then
        InvalidateCell(Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Left, Holder.CellsUnions.Unions[k].GridUnions[i].UnionRect.Top);
    end;
  end;
  }
  
  //       ,
  //..   ...
  DoRowMoved(FromIndex, ToIndex);
  RowHeightsChanged;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.MouseCoord(X, Y: Integer): TRGridCoord;
var
  DrawInfo: TRGridDrawInfo;
begin
  CalcDrawInfo(DrawInfo);
  Result := CalcCoordFromPoint(X, Y, DrawInfo);
  if Result.X < 0 then
    Result.Y := -1
  else if Result.Y < 0 then
    Result.X := -1;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveColRow(ACol, ARow: Longint; MoveAnchor,
  Show: Boolean);
begin
  MoveCurrent(ACol, ARow, Show);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SizeChanged(OldColCount, OldRowCount: Longint);
begin
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.Sizing(X, Y: Integer): Boolean;
var
  DrawInfo: TRGridDrawInfo;
  State: TRGridState;
  Index: Longint;
  Pos, Ofs: Integer;
begin
  State := FGridState;
  if State = rgsNormal then
  begin
    CalcDrawInfo(DrawInfo);
    CalcSizingState(X, Y, State, Index, Pos, Ofs, DrawInfo);
  end;
  Result := State <> rgsNormal;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.TopLeftChanged;
begin
  if Assigned(FOnTopLeftChanged) then
    FOnTopLeftChanged(Self);

  if FTracking then
    StopTracking;  
end;
//----------------------------------------------------------------------------------------------------------------------
procedure FillDWord(var Dest; Count, Value: Integer); register;
asm
  XCHG  EDX, ECX
  PUSH  EDI
  MOV   EDI, EAX
  MOV   EAX, EDX
  REP   STOSD
  POP   EDI
end;
//----------------------------------------------------------------------------------------------------------------------
{ StackAlloc allocates a 'small' block of memory from the stack by
  decrementing SP.  This provides the allocation speed of a local variable,
  but the runtime size flexibility of heap allocated memory.  }
function StackAlloc(Size: Integer): Pointer; register;
asm
  POP   ECX          { return address }
  MOV   EDX, ESP
  ADD   EAX, 3
  AND   EAX, not 3   // round up to keep ESP dword aligned
  CMP   EAX, 4092
  JLE   @@2
@@1:
  SUB   ESP, 4092
  PUSH  EAX          { make sure we touch guard page, to grow stack }
  SUB   EAX, 4096
  JNS   @@1
  ADD   EAX, 4096
@@2:
  SUB   ESP, EAX
  MOV   EAX, ESP     { function result = low memory address of block }
  PUSH  EDX          { save original SP, for cleanup }
  MOV   EDX, ESP
  SUB   EDX, 4
  PUSH  EDX          { save current SP, for sanity check  (sp = [sp]) }
  PUSH  ECX          { return to caller }
end;
//----------------------------------------------------------------------------------------------------------------------
{ StackFree pops the memory allocated by StackAlloc off the stack.
- Calling StackFree is optional - SP will be restored when the calling routine
  exits, but it's a good idea to free the stack allocated memory ASAP anyway.
- StackFree must be called in the same stack context as StackAlloc - not in
  a subroutine or finally block.
- Multiple StackFree calls must occur in reverse order of their corresponding
  StackAlloc calls.
- Built-in sanity checks guarantee that an improper call to StackFree will not
  corrupt the stack. Worst case is that the stack block is not released until
  the calling routine exits. }
procedure StackFree(P: Pointer); register;
asm
  POP   ECX                     { return address }
  MOV   EDX, DWORD PTR [ESP]
  SUB   EAX, 8
  CMP   EDX, ESP                { sanity check #1 (SP = [SP]) }
  JNE   @@1
  CMP   EDX, EAX                { sanity check #2 (P = this stack block) }
  JNE   @@1
  MOV   ESP, DWORD PTR [ESP+4]  { restore previous SP  }
@@1:
  PUSH  ECX                     { return to caller }
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.Paint;
var
  DrawInfo: TRGridDrawInfo;
  UpdateRect: TRect;
  FrameFlags1, FrameFlags2: DWORD;

  procedure DrawCells(ACol, ARow: Longint; StartX, StartY, StopX, StopY: Integer; IncludeDrawState: TRGridDrawStates);
  var
    CurCol, CurRow: Longint;
    Where: TRect;
    TempRect: TRect;
    CellRect: TRect;
    UnionRect: TRect;
    GridUnionRect: TRGridRect;
    DrawState: TRGridDrawStates;
    GridIsActiveCintrol: Boolean;
    GridHasFocus: Boolean;
    //FixedDown: Boolean;
    CellIsUnioned: Boolean;
    GridRectIsUsed: Boolean;
    CurColInCurrentRect: Boolean;
    CurRowInCurrentRect: Boolean;
    Multiline: Boolean;
    NotDrawField: Boolean;
    CellText: string;
    HorAlignment: TAlignment;
    VertAlignment: TRVertAlignment;

    ImageIndex: Longint;
    X, Y: Integer;
    CurCell: TRCell;

    function GetDefaultCellColor(): TColor;
    begin
      if ([rgoZebraCols, rgoZebraRows] * FOptions = []) then
        Result := FColors._DefaultCellColor1NotMark
      else
      begin
        if ([rgoZebraCols, rgoZebraRows] * FOptions = [rgoZebraCols]) then
        begin
          if ((CurCol mod 2)  > 0) then
            Result := FColors._DefaultCellColor2NotMark
          else
            Result := FColors._DefaultCellColor1NotMark;
        end
        else if ([rgoZebraCols, rgoZebraRows] * FOptions = [rgoZebraRows]) then
        begin
          if ((CurRow mod 2)  > 0) then
            Result := FColors._DefaultCellColor2NotMark
          else
            Result := FColors._DefaultCellColor1NotMark;
        end
        else
        begin
          if ((((CurCol mod 2) > 0)  and (rgoZebraCols in FOptions)) and (((CurRow mod 2) = 0) and (rgoZebraRows in FOptions)))
            or ((((CurCol mod 2) = 0)  and (rgoZebraCols in FOptions)) and (((CurRow mod 2) > 0) and (rgoZebraRows in FOptions))) then
            Result := FColors._DefaultCellColor2NotMark
          else
            Result := FColors._DefaultCellColor1NotMark;
        end;
      end;
    end;

    function UnionRectIsAlreadyUsed(ACol, ARow: Longint): Boolean;
    begin
      if (Cells[CurCol, CurRow].Unioned) then
      begin
        if (Cells[CurCol, CurRow].GridUnion.FPaintCount > 0) then
          Result := True
        else
        begin
          Cells[CurCol, CurRow].GridUnion.FPaintCount := 1;
          Result := False;
        end;
      end
      else
        Result := False;
    end;

    //GridRectToScreenRect   Rect    
    //  :
    procedure GridRectToFullScreenRect(AGridRect: TRGridRect; var ScreenRect: TRect);
      procedure GetHomeAndEnd(const AxisInfo: TRGridAxisDrawInfo; HomeGridPos, EndGridPos: Integer; var HomeRectPos, EndRectPos: Integer);
      var
        i: Integer;
        //BorderEnabled: Boolean;
      begin
        //BorderEnabled := True;

        with AxisInfo do
        begin
          for i := 0 to EndGridPos do
          begin
            if (i < FixedCellCount) or (i >= FirstGridCell) then
            begin
              if i < HomeGridPos then
              begin
                Inc(HomeRectPos, GetExtent(i) + EffectiveLineWidth);
                EndRectPos := HomeRectPos;
              end
              else
              begin
                Inc(EndRectPos, GetExtent(i) + EffectiveLineWidth);
              end;
            end;
            //      
            //    ,   ...
            {
            //  ,           () 
            //     , ..    
            //  . ,    ,  , , ...
            if (i > LastFullVisibleCell) then
            begin
              EndRectPos := GridExtent + 2; // +2      ()    
              BorderEnabled := False;
              Break;
            end;
            }
          end;

          //if BorderEnabled then
            Dec(EndRectPos, EffectiveLineWidth);
        end;
      end;

    begin
      FillChar(ScreenRect, SizeOf(ScreenRect), 0); { erase partial results }

      {
      if (AGridRect.Left > AGridRect.Right) or (AGridRect.Top > AGridRect.Bottom) then
        Exit;
      }

      //Left, Right
      GetHomeAndEnd(DrawInfo.Horz, AGridRect.Left, AGridRect.Right, ScreenRect.Left, ScreenRect.Right);
      //Top, Bottom
      GetHomeAndEnd(DrawInfo.Vert, AGridRect.Top, AGridRect.Bottom, ScreenRect.Top, ScreenRect.Bottom);
    end;

  begin
    CurRow := ARow;
    CellRect.Top := StartY;
    while (CellRect.Top < StopY) and (CurRow < RowCount) do
    begin
      CurCol := ACol;
      CellRect.Left := StartX;
      CellRect.Bottom := CellRect.Top + RowHeights[CurRow];
      while (CellRect.Left < StopX) and (CurCol < ColCount) do
      begin
        CellRect.Right := CellRect.Left + ColWidths[CurCol];

        GridRectIsUsed := UnionRectIsAlreadyUsed(CurCol, CurRow);

        if (not GridRectIsUsed) then
        begin
          CellIsUnioned := Cells[CurCol, CurRow].Unioned;

          if CellIsUnioned then
          begin
            GridUnionRect := Cells[CurCol, CurRow].GridUnion.UnionRect;

            if GridUnionRect.Left >= FFixedCols then
              if GridUnionRect.Left < FTopLeft.X then
                GridUnionRect.Left := FTopLeft.X;

            if GridUnionRect.Top >= FFixedRows then
              if GridUnionRect.Top < FTopLeft.Y then
                GridUnionRect.Top := FTopLeft.Y;

            //GridRectToScreenRect(GridUnionRect, UnionRect, False);
            GridRectToFullScreenRect(GridUnionRect, UnionRect);
            Where := UnionRect;
          end
          else
            Where := CellRect;

          TempRect := Where;
          Inc(TempRect.Right, DrawInfo.Horz.EffectiveLineWidth);
          Inc(TempRect.Bottom, DrawInfo.Vert.EffectiveLineWidth);

          if (TempRect.Right > TempRect.Left) and RectVisible(Canvas.Handle, TempRect) then
          begin
            if (Cells[CurCol, CurRow].BelongsToUnion) then
              CurCell := Cells[CurCol, CurRow].CellsUnion.MainCell
            else
              CurCell := Cells[CurCol, CurRow];

            DrawState := IncludeDrawState;

            GridIsActiveCintrol := IsActiveControl;
            GridHasFocus := HasFocus();

            if CellIsUnioned then
            begin
              CurColInCurrentRect := ((FCurrentRect.Left >= GridUnionRect.Left) and (FCurrentRect.Left <= GridUnionRect.Right))
                or ((FCurrentRect.Right >= GridUnionRect.Left) and (FCurrentRect.Right <= GridUnionRect.Right));

              CurRowInCurrentRect := ((FCurrentRect.Top >= GridUnionRect.Top) and (FCurrentRect.Top <= GridUnionRect.Bottom))
                or ((FCurrentRect.Bottom >= GridUnionRect.Top) and (FCurrentRect.Bottom <= GridUnionRect.Bottom));
            end
            else
            begin
              CurColInCurrentRect := (CurCol >= FCurrentRect.Left) and (CurCol <= FCurrentRect.Right);
              CurRowInCurrentRect := (CurRow >= FCurrentRect.Top) and (CurRow <= FCurrentRect.Bottom);
            end;

            //   
            if (not (rgdFixed in DrawState)) then
            begin
              if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
              begin
                Include(DrawState, rgdMarked);
              end;

              if (CurColInCurrentRect and CurRowInCurrentRect) then
              begin
                Include(DrawState, rgdFocused);
                Include(DrawState, rgdCurrent); //??? ?   ...
              end
              else if (CurColInCurrentRect) or (CurRowInCurrentRect) then
              begin
                Include(DrawState, rgdCurrent);
              end;
            end
            else
            begin
              if CellIsUnioned then
              begin
                if (rgoSupportFixedButtons in Options) and  (not (csLoading in ComponentState))
                   and FPressed and PointInGridRect(FPressedCell.X, FPressedCell.Y, GridUnionRect) then
                begin
                  Include(DrawState, rgdDown);
                end;
              end
              else
              begin
                if (rgoSupportFixedButtons in Options) and  (not (csLoading in ComponentState))
                  and FPressed and (FPressedCell.X = CurCol) and (FPressedCell.Y = CurRow) then
                begin
                  Include(DrawState, rgdDown);
                end;
              end;

              if (CurCol >= FFixedCols) then
              begin
                if (CurColInCurrentRect) then
                begin
                  Include(DrawState, rgdCurrent);
                end;
              end
              else if (CurRow >= FFixedRows) then
              begin
                if (CurRowInCurrentRect) then
                begin
                  Include(DrawState, rgdCurrent);
                end;
              end;
            end;






            ////////////////////////////////////////////////////////////////////////////////////////////////
            {
            if (not (rgdFixed in DrawState)) then
            begin
              if (CurColInCurrentRect or CurRowInCurrentRect) then
              begin
                if (CurColInCurrentRect and CurRowInCurrentRect) then
                begin
                  if (rgoShowFocusCell in Options) then
                  begin
                    if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
                      Include(DrawState, rgdFocusedCellMark)
                    else
                      Include(DrawState, rgdFocusedCellNotMark);
                  end
                  else  if ([rgoShowCurCol, rgoShowCurRow] * FOptions <> []) then
                  begin
                    if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
                      Include(DrawState, rgdCurrentColRowMark)
                    else
                      Include(DrawState, rgdCurrentColRowNotMark);
                  end;
                end
                else if (CurColInCurrentRect) then
                begin
                  if (rgoShowCurCol in Options) then
                  begin
                    if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
                      Include(DrawState, rgdCurrentColRowMark)
                    else
                      Include(DrawState, rgdCurrentColRowNotMark);
                  end
                  else
                  begin
                    if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
                      Include(DrawState, rgdMarkedCell);
                  end;
                end
                else if (CurRowInCurrentRect) then
                begin
                  if (rgoShowCurRow in Options) then
                  begin
                    if (Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
                      Include(DrawState, rgdCurrentColRowMark)
                    else
                      Include(DrawState, rgdCurrentColRowNotMark);
                  end
                  else
                  begin
                    if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
                      Include(DrawState, rgdMarkedCell);
                  end;
                end;
              end
              else if (Cols[CurCol].Marked or Rows[CurRow].Marked or Cells[CurCol, CurRow].Marked) then
              begin
                Include(DrawState, rgdMarkedCell);
              end;
            end
            else
            begin
              if CellIsUnioned then
              begin
                if (rgoSupportFixedButtons in Options) and  (not (csLoading in ComponentState))
                   and FPressed and PointInGridRect(FPressedCell.X, FPressedCell.Y, GridUnionRect) then
                begin
                  Include(DrawState, rgdDown);
                end;
              end
              else
              begin
                if (rgoSupportFixedButtons in Options) and  (not (csLoading in ComponentState))
                  and FPressed and (FPressedCell.X = CurCol) and (FPressedCell.Y = CurRow) then
                begin
                  Include(DrawState, rgdDown);
                end;
              end;
            end;
            }
            ////////////////////////////////////////////////////////////////////////////////////////////////


            //  
            if (DrawInfo.Horz.EffectiveLineWidth > 0) or (DrawInfo.Vert.EffectiveLineWidth > 0) then
            begin
              Canvas.Pen.Style := psSolid;

              //Right, Bottom
              if (rgdFixed in DrawState) then
                Canvas.Pen.Color := clWindowFrame
              else
                Canvas.Pen.Color := FColors._GridLineColor;

              if (DrawInfo.Vert.EffectiveLineWidth > 0) then
              begin
                Canvas.Pen.Width := DrawInfo.Vert.EffectiveLineWidth;
                Canvas.MoveTo(Where.Right + (DrawInfo.Vert.EffectiveLineWidth Div 2), Where.Top);
                Canvas.LineTo(Where.Right + (DrawInfo.Vert.EffectiveLineWidth Div 2), Where.Bottom);
              end;

              if (DrawInfo.Horz.EffectiveLineWidth > 0) then
              begin
                Canvas.Pen.Width := DrawInfo.Horz.EffectiveLineWidth;
                Canvas.MoveTo(Where.Right, Where.Bottom + (DrawInfo.Horz.EffectiveLineWidth Div 2));
                Canvas.LineTo(Where.Left - 1, Where.Bottom + (DrawInfo.Horz.EffectiveLineWidth Div 2));
              end;
            end;

            // Canvas:      .
            //     OnBeforeDrawCell  () OnDrawCellField
            with Canvas do
            begin
              Pen.Style   := psSolid;
              Pen.Mode    := pmCopy;
              Brush.Style := bsSolid;
              //Brush.Color := clBtnFace;

              if (rgdFixed in DrawState) then
              begin
                Brush.Color := FColors._FixedButtonsColor;
                Font := FFonts.FixedButtonsFont;
              end
              else if (rgdFocused in DrawState) then
              begin
                if (rgoShowFocusCell in Options) then
                begin
                  if (rgdMarked in DrawState) then
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._FocusCellColorMark;
                      Font := FFonts.FocusCellFontMark;
                    end
                    else
                    begin
                      if rgoHideFocusCellOnExit in Options then
                      begin
                        if (rgoHideCurColRowOnExit in FOptions) then
                        begin
                          Brush.Color := FColors._DefaultCellColorMarkUnActive;
                          Font := FFonts.DefaultCellFontMarkUnActive;
                        end
                        else
                        begin
                          Brush.Color := FColors._CurColRowColorMarkUnActive;
                          Font := FFonts.CurColRowFontMarkUnActive;
                        end;
                      end
                      else
                      begin
                        Brush.Color := FColors._FocusCellColorMarkUnActive;
                        Font := FFonts.FocusCellFontMarkUnActive;
                      end;
                    end;
                  end
                  else
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._FocusCellColorNotMark;
                      Font := FFonts.FocusCellFontNotMark;
                    end
                    else
                    begin
                      if (rgoHideFocusCellOnExit in FOptions) then
                      begin
                        if (rgoHideCurColRowOnExit in FOptions) then
                        begin
                          Brush.Color := GetDefaultCellColor();
                          if Brush.Color = FColors._DefaultCellColor1NotMark then
                            Font := FFonts.DefaultCellFont1NotMark
                          else
                            Font := FFonts.DefaultCellFont2NotMark;
                        end
                        else
                        begin
                          Brush.Color := FColors._CurColRowColorMarkUnActive;
                          Font := FFonts.CurColRowFontMarkUnActive;
                        end;
                      end
                      else
                      begin
                        Brush.Color := FColors._FocusCellColorNotMarkUnActive;
                        Font := FFonts.FocusCellFontNotMarkUnActive;
                      end;
                    end;
                  end;
                end
                else if [rgoShowCurCol, rgoShowCurRow] * FOptions <> [] then
                begin
                  if (rgdMarked in DrawState) then
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._CurColRowColorMark;
                      Font := FFonts.CurColRowFontMark;
                    end
                    else
                    begin
                      if (rgoHideCurColRowOnExit in FOptions) then
                      begin
                        Brush.Color := FColors._DefaultCellColorMarkUnActive;
                        Font := FFonts.DefaultCellFontMarkUnActive;
                      end
                      else
                      begin
                        Brush.Color := FColors._CurColRowColorMarkUnActive;
                        Font := FFonts.CurColRowFontMarkUnActive;
                      end;
                    end;
                  end
                  else
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._CurColRowColorNotMark;
                      Font := FFonts.CurColRowFontNotMark;
                    end
                    else
                    begin
                      if (rgoHideCurColRowOnExit in FOptions) then
                      begin
                        Brush.Color := GetDefaultCellColor();
                        if (Brush.Color = FColors._DefaultCellColor1NotMark) then
                          Font := FFonts.DefaultCellFont1NotMark
                        else
                          Font := FFonts.DefaultCellFont2NotMark;
                      end
                      else
                      begin
                        Brush.Color := FColors._CurColRowColorNotMarkUnActive;
                        Font := FFonts.CurColRowFontNotMarkUnActive;
                      end;
                    end;
                  end;
                end
                else
                begin
                  if (rgdMarked in DrawState) then
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._DefaultCellColorMark;
                      Font := FFonts.DefaultCellFontMark;
                    end
                    else
                    begin
                      Brush.Color := FColors._DefaultCellColorMarkUnActive;
                      Font := FFonts.DefaultCellFontMarkUnActive;
                    end;
                  end
                  else
                  begin
                    Brush.Color := GetDefaultCellColor();
                    if (Brush.Color = FColors._DefaultCellColor1NotMark) then
                      Font := FFonts.DefaultCellFont1NotMark
                    else
                      Font := FFonts.DefaultCellFont2NotMark;
                  end;
                end;
              end
              else if (rgdCurrent in DrawState) {and (not (rgdFocused in DrawState)) and (not (rgdFixed in DrawState))   } then
              begin
                if [rgoShowCurCol, rgoShowCurRow] * FOptions <> [] then
                begin
                  if (rgdMarked in DrawState) then
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._CurColRowColorMark;
                      Font := FFonts.CurColRowFontMark;
                    end
                    else
                    begin
                      if (rgoHideCurColRowOnExit in FOptions) then
                      begin
                        Brush.Color := FColors._DefaultCellColorMarkUnActive;
                        Font := FFonts.DefaultCellFontMarkUnActive;
                      end
                      else
                      begin
                        Brush.Color := FColors._CurColRowColorMarkUnActive;
                        Font := FFonts.CurColRowFontMarkUnActive;
                      end;
                    end;
                  end
                  else
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      if ((Col = CurCol) and (rgoShowCurCol in FOptions)) or ((Row = CurRow) and (rgoShowCurRow in FOptions)) then
                      begin
                        Brush.Color := FColors._CurColRowColorNotMark;
                        Font := FFonts.CurColRowFontNotMark;
                      end
                      else
                      begin
                        Brush.Color := GetDefaultCellColor();
                        if (Brush.Color = FColors._DefaultCellColor1NotMark) then
                          Font := FFonts.DefaultCellFont1NotMark
                        else
                          Font := FFonts.DefaultCellFont2NotMark;
                      end;  
                    end
                    else
                    begin
                      if (rgoHideCurColRowOnExit in FOptions) then
                      begin
                        Brush.Color := GetDefaultCellColor();
                        if Brush.Color = FColors._DefaultCellColor1NotMark then
                          Font := FFonts.DefaultCellFont1NotMark
                        else
                          Font := FFonts.DefaultCellFont2NotMark;
                      end
                      else
                      begin
                        Brush.Color := FColors._CurColRowColorNotMarkUnActive;
                        Font := FFonts.CurColRowFontNotMarkUnActive;
                      end;
                    end;
                  end;
                end
                else
                begin
                  if (rgdMarked in DrawState) then
                  begin
                    if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                    begin
                      Brush.Color := FColors._DefaultCellColorMark;
                      Font := FFonts.DefaultCellFontMark;
                    end
                    else
                    begin
                      Brush.Color := FColors._DefaultCellColorMarkUnActive;
                      Font := FFonts.DefaultCellFontMarkUnActive;
                    end;
                  end
                  else
                  begin
                    Brush.Color := GetDefaultCellColor();
                    if (Brush.Color = FColors._DefaultCellColor1NotMark) then
                      Font := FFonts.DefaultCellFont1NotMark
                    else
                      Font := FFonts.DefaultCellFont2NotMark;
                  end;
                end;
              end
              else
              begin
                if (rgdMarked in DrawState) then
                begin
                  if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                  begin
                    Brush.Color := FColors._DefaultCellColorMark;
                    Font := FFonts.DefaultCellFontMark;
                  end
                  else
                  begin
                    Brush.Color := FColors._DefaultCellColorMarkUnActive;
                    Font := FFonts.DefaultCellFontMarkUnActive;
                  end;
                end
                else
                begin
                  Brush.Color := GetDefaultCellColor();
                  if (Brush.Color = FColors._DefaultCellColor1NotMark) then
                    Font := FFonts.DefaultCellFont1NotMark
                  else
                    Font := FFonts.DefaultCellFont2NotMark;
                end;
              end;






              ///////////////////////////////////////////////////////
              {
              if (rgdFixed in DrawState) then
              begin
                Brush.Color := FColors._FixedButtonsColor;
                //Font.Assign(FFonts.FixedButtonsFont);
                Font := FFonts.FixedButtonsFont;
              end
              else if (rgdFocusedCellNotMark in DrawState) then
              begin
                if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                begin
                  Brush.Color := FColors._FocusCellColorNotMark;
                  //Font.Assign(FFonts.FocusCellFontNotMark);
                  Font := FFonts.FocusCellFontNotMark;
                end
                else
                begin
                  if rgoHideFocusCellOnExit in Options then
                  begin
                    Brush.Color := GetDefaultCellColor();
                    if Brush.Color = FColors._DefaultCellColor1NotMark then
                      //Font.Assign(FFonts.DefaultCellFont1NotMark)
                      Font := FFonts.DefaultCellFont1NotMark
                    else
                      //Font.Assign(FFonts.DefaultCellFont2NotMark);
                      Font := FFonts.DefaultCellFont2NotMark;
                  end
                  else
                  begin
                    Brush.Color := FColors._FocusCellColorNotMarkUnActive;
                    //Font.Assign(FFonts.FocusCellFontNotMarkUnActive);
                    Font := FFonts.FocusCellFontNotMarkUnActive;
                  end
                end;
              end
              else if (rgdFocusedCellMark in DrawState) then
              begin
                if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                begin
                  Brush.Color := FColors._FocusCellColorMark;
                  //Font.Assign(FFonts.FocusCellFontMark);
                  Font := FFonts.FocusCellFontMark;
                end
                else
                begin
                  if rgoHideFocusCellOnExit in Options then
                  begin
                    Brush.Color := GetDefaultCellColor();
                    if Brush.Color = FColors._DefaultCellColor1NotMark then
                      //Font.Assign(FFonts.DefaultCellFont1NotMark)
                      Font := FFonts.DefaultCellFont1NotMark
                    else
                      //Font.Assign(FFonts.DefaultCellFont2NotMark);
                      Font := FFonts.DefaultCellFont2NotMark;
                  end
                  else
                  begin
                    Brush.Color := FColors._FocusCellColorMarkUnActive;
                    //Font.Assign(FFonts.FocusCellFontMarkUnActive);
                    Font := FFonts.FocusCellFontMarkUnActive;
                  end;
                end;
              end
              else if (rgdCurrentColRowNotMark in DrawState) then
              begin
                if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                begin
                  Brush.Color := FColors._CurColRowColorNotMark;
                  Font := FFonts.CurColRowFontNotMark;
                end
                else
                begin
                  Brush.Color := FColors._CurColRowColorNotMarkUnActive;
                  //Font.Assign(FFonts.CurColRowFontNotMarkUnActive);
                  Font := FFonts.CurColRowFontNotMarkUnActive;
                end;
              end
              else if (rgdCurrentColRowMark in DrawState) then
              begin
                if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                begin
                  Brush.Color := FColors._CurColRowColorMark;
                  //Font.Assign(FFonts.CurColRowFontMark);
                  Font := FFonts.CurColRowFontMark;
                end
                else
                begin
                  Brush.Color := FColors._CurColRowColorMarkUnActive;
                  //Font.Assign(FFonts.CurColRowFontMarkUnActive);
                  Font := FFonts.CurColRowFontMarkUnActive;
                end;
              end
              else if (rgdMarkedCell in DrawState) then
              begin
                if (GridIsActiveCintrol and GridHasFocus) or (csDesigning in ComponentState) then
                begin
                  Brush.Color := FColors._DefaultCellColorMark;
                  //Font.Assign(FFonts.DefaultCellFontMark);
                  Font := FFonts.DefaultCellFontMark;
                end
                else
                begin
                  Brush.Color := FColors._DefaultCellColorMarkUnActive;
                  //Font.Assign(FFonts.DefaultCellFontMarkUnActive);
                  Font := FFonts.DefaultCellFontMarkUnActive;
                end;
              end
              else
              begin
                Brush.Color := GetDefaultCellColor();
                if Brush.Color = FColors._DefaultCellColor1NotMark then
                  //Font.Assign(FFonts.DefaultCellFont1NotMark)
                  Font := FFonts.DefaultCellFont1NotMark
                else
                  //Font.Assign(FFonts.DefaultCellFont2NotMark);
                  Font := FFonts.DefaultCellFont2NotMark;
              end;
              }
              ///////////////////////////////////////////////////////
            end;
            
            {
            if CellIsUnioned then
              FixedDown := (rgoSupportFixedButtons in Options) and  not (csLoading in ComponentState)
                and FPressed and PointInGridRect(FPressedCell.X, FPressedCell.Y, GridUnionRect)
            else
              FixedDown := (rgoSupportFixedButtons in Options) and  not (csLoading in ComponentState)
                and FPressed and (FPressedCell.X = CurCol) and (FPressedCell.Y = CurRow);
            }

            // ,    
            if (not DoBeforeDrawCell(Cells[CurCol, CurRow], CurCol, CurRow, DrawState, Where)) or (csDesigning in ComponentState) then
            begin
              with Canvas do
              begin
                NotDrawField := DoDrawCellField(CurCell, CurCol, CurRow, DrawState, Where);

                if (not NotDrawField) then
                begin
                  FillRect(Where);
                end;

                if Assigned(FImages) then
                begin
                  ImageIndex := -1;
                  HorAlignment := taLeftJustify;
                  VertAlignment := rvaCenter;
                  TempRect := Where;

                  //      
                  {
                  if (rgdFixed in DrawState) and (not NotDrawField) then
                  begin
                    Inc(TempRect.Left);
                    Inc(TempRect.Top);
                    Dec(TempRect.Right);
                    Dec(TempRect.Bottom);
                  end;
                  }
                  {
                  if (rgdDown in DrawState) then
                  begin
                    Inc(TempRect.Left);
                    Inc(TempRect.Top);
                  end;
                  }

                  if (rgdFixed in DrawState) and (not NotDrawField) then
                  begin
                    if (rgdDown in DrawState) then
                    begin
                      Inc(TempRect.Left, 2);
                      Inc(TempRect.Top, 2);
                      Dec(TempRect.Right);
                      Dec(TempRect.Bottom);
                    end
                    else
                    begin
                      Inc(TempRect.Left);
                      Inc(TempRect.Top);
                      Dec(TempRect.Right, 2);
                      Dec(TempRect.Bottom, 2);
                    end;
                  end;

                  DoDrawImage(CurCell, CurCol, CurRow, DrawState, TempRect, ImageIndex, HorAlignment, VertAlignment);

                  if (ImageIndex > -1) and (ImageIndex < FImages.Count) then
                  begin
                    FDrawBitmap.Width := 0;
                    FImages.GetBitmap(ImageIndex, FDrawBitmap);

                    case HorAlignment of
                      taLeftJustify:
                        X := TempRect.Left {+ min(3, (TempRect.Right - TempRect.Left - FDrawBitmap.Width) div 2)};

                      taCenter:
                        X := (TempRect.Right + TempRect.Left - FDrawBitmap.Width) div 2;

                      taRightJustify:
                        X := TempRect.Right - FDrawBitmap.Width{ - min(3, (TempRect.Right - TempRect.Left - FDrawBitmap.Width) div 2)};
                    end;

                    case VertAlignment of
                      rvaTopJustify:
                        Y := TempRect.Top{ + min(3, (TempRect.Bottom - TempRect.Top - FDrawBitmap.Height) div 2)};

                      rvaCenter:
                        Y := (TempRect.Bottom + TempRect.Top - FDrawBitmap.Height) div 2;

                      rvaBottomJustify:
                        Y := TempRect.Bottom - FDrawBitmap.Height{ - min(3, (TempRect.Bottom - TempRect.Top - FDrawBitmap.Height) div 2)};
                    end;
                    {
                    if (rgdDown in DrawState) then
                    begin
                      Inc(X);
                      Inc(Y);
                    end;
                    }

                    if (rgoDrawMaskedImages in Options) then
                      DrawBitmapTransparent(Canvas, X, Y, FDrawBitmap, FDrawBitmap.TransparentColor and (not $02000000))
                    else
                      Canvas.Draw(X, Y, FDrawBitmap);
                  end;
                end;

                CellText := '';
                Multiline := False;
                HorAlignment := taLeftJustify;
                VertAlignment := rvaCenter;
                TempRect := Where;

                //      
                if (rgdFixed in DrawState) and (not NotDrawField) then
                begin
                  if (rgdDown in DrawState) then
                  begin
                    Inc(TempRect.Left, 2);
                    Inc(TempRect.Top, 2);
                    Dec(TempRect.Right);
                    Dec(TempRect.Bottom);
                  end
                  else
                  begin
                    Inc(TempRect.Left);
                    Inc(TempRect.Top);
                    Dec(TempRect.Right, 2);
                    Dec(TempRect.Bottom, 2);
                  end;
                end;

                
                {
                if (rgdDown in DrawState) then
                begin
                  Inc(TempRect.Left);
                  Inc(TempRect.Top);
                end;
                }

                DoDrawCellText(CurCell, CurCol, CurRow, DrawState, TempRect, CellText, Multiline, HorAlignment, VertAlignment);
                {
                if (rgdDown in DrawState) then
                begin
                  if (HorAlignment = taCenter) then
                  begin
                    if (((TempRect.Right - TempRect.Left) mod 2) > 0) then
                      Inc(TempRect.Left, 2)
                    else
                      Inc(TempRect.Left);
                  end
                  else
                    Inc(TempRect.Left);

                  if (VertAlignment = rvaCenter) then
                  begin
                    if (((TempRect.Bottom - TempRect.Top) mod 2) > 0) then
                      Inc(TempRect.Top, 2)
                    else
                      Inc(TempRect.Top);
                  end
                  else
                    Inc(TempRect.Top);
                end;
                }

                if (Length(CellText) > 0) then
                  DrawCellTextEx(CellText, TempRect, HorAlignment, VertAlignment, Multiline);
              end;

              //     ()
              if (not NotDrawField) then
              begin
                if (rgdFixed in DrawState) and Ctl3D and ((FrameFlags1 or FrameFlags2) <> 0) then
                begin
                  TempRect := Where;

                  if (not (rgdDown in DrawState)) then
                  begin
                    if (FrameFlags1 and BF_RIGHT) = 0 then
                      Inc(TempRect.Right, DrawInfo.Horz.EffectiveLineWidth)
                    else if (FrameFlags1 and BF_BOTTOM) = 0 then
                      Inc(TempRect.Bottom, DrawInfo.Vert.EffectiveLineWidth);

                    DrawEdge(Canvas.Handle, TempRect, BDR_RAISEDINNER, FrameFlags1 or BF_ADJUST);
                    DrawEdge(Canvas.Handle, TempRect, BDR_RAISEDINNER, FrameFlags2 or BF_ADJUST);
                  end
                  else
                  begin
                    DrawEdge(Canvas.Handle, TempRect, BDR_SUNKENINNER, BF_BOTTOMRIGHT or BF_MONO or BF_ADJUST);
                    DrawEdge(Canvas.Handle, TempRect, BDR_SUNKENINNER, BF_TOPLEFT or BF_SOFT or BF_ADJUST);
                  end;
                end;
              end;

              //end;

              //    
              if (rgdFocused in DrawState) and (rgoShowFocusFrame in FOptions) then
              begin
                if (GridIsActiveCintrol) and (GridHasFocus) then
                begin
                  if (not UseRightToLeftAlignment) then
                  begin
                    if (FFocusFrameStyle = rffDotRect) then
                    begin
                      DrawFocusRect(Canvas.Handle, Where);
                    end
                    else
                    begin
                      if (rgdMarked in DrawState) then
                        Canvas.Brush.Color := FColors._FocusFrameColorMark
                      else
                        Canvas.Brush.Color := FColors._FocusFrameColorNotMark;

                      Canvas.FrameRect(Where);
                    end;
                  end
                  else
                  begin
                    TempRect := Where;
                    TempRect.Left := Where.Right;
                    TempRect.Right := Where.Left;
                    if FFocusFrameStyle = rffDotRect then
                    begin
                      DrawFocusRect(Canvas.Handle, TempRect);
                    end
                    else //if (FFocusFrameStyle = rffRect) then
                    begin
                      if (rgdMarked in DrawState) then
                        Canvas.Brush.Color := FColors._FocusFrameColorMark
                      else
                        Canvas.Brush.Color := FColors._FocusFrameColorNotMark;

                      Canvas.FrameRect(TempRect);
                    end;
                  end;
                end;
              end;

              DoAfterDrawCell(CurCell, CurCol, CurRow, DrawState, Where);
            end;
          end;
        end;
        CellRect.Left := CellRect.Right + DrawInfo.Horz.EffectiveLineWidth;
        Inc(CurCol);
      end;
      CellRect.Top := CellRect.Bottom + DrawInfo.Vert.EffectiveLineWidth;
      Inc(CurRow);
    end;
  end;

begin
  if UseRightToLeftAlignment then
    ChangeGridOrientation(True);

  UpdateRect := Canvas.ClipRect;
  CalcDrawInfo(DrawInfo);
  with DrawInfo do
  begin
    {
    if (Horz.EffectiveLineWidth > 0) or (Vert.EffectiveLineWidth > 0) then
    begin
      // Draw the grid line in the four areas (fixed, fixed), (variable, fixed),
      // (fixed, variable) and (variable, variable)
      //LineColor := FColors._GridLineColor;
      MaxStroke := Max(Horz.LastFullVisibleCell - LeftCol + FixedCols,
                        Vert.LastFullVisibleCell - TopRow + FixedRows) + 3;
      PointsList := StackAlloc(MaxStroke * sizeof(TPoint) * 2);
      StrokeList := StackAlloc(MaxStroke * sizeof(Integer));
      FillDWord(StrokeList^, MaxStroke, 2);

      DrawLines(rgoFixedHorzLine in Options, rgoFixedVertLine in Options,
        0, 0, [0, 0, Horz.FixedBoundary, Vert.FixedBoundary], clBlack, FColors._FixedButtonsColor);

      DrawLines(rgoFixedHorzLine in Options, rgoFixedVertLine in Options,
        LeftCol, 0, [Horz.FixedBoundary, 0, Horz.GridBoundary,
        Vert.FixedBoundary], clBlack, FColors._FixedButtonsColor);

      DrawLines(rgoFixedHorzLine in Options, rgoFixedVertLine in Options,
          0, TopRow, [0, Vert.FixedBoundary, Horz.FixedBoundary,
          Vert.GridBoundary], clBlack, FColors._FixedButtonsColor);

      DrawLines(rgoHorzLine in Options, rgoVertLine in Options, LeftCol,
          TopRow, [Horz.FixedBoundary, Vert.FixedBoundary, Horz.GridBoundary,
          Vert.GridBoundary], FColors._GridLineColor,FColors._GridLineColor/*LineColor, LineColor*/);

      StackFree(StrokeList);
      StackFree(PointsList);
    end;
    }

    FrameFlags1 := 0;
    FrameFlags2 := 0;

    if rgoFixedVertLine in Options then
    begin
      FrameFlags1 := BF_RIGHT;
      FrameFlags2 := BF_LEFT;
    end;

    if rgoFixedHorzLine in Options then
    begin
      FrameFlags1 := FrameFlags1 or BF_BOTTOM;
      FrameFlags2 := FrameFlags2 or BF_TOP;
    end;

    DrawCells(0, 0, 0, 0, Horz.FixedBoundary, Vert.FixedBoundary, [rgdFixed]);

    DrawCells(LeftCol, 0, Horz.FixedBoundary - FColOffset, 0, Horz.GridBoundary,  //!! clip
        Vert.FixedBoundary, [rgdFixed]);

    DrawCells(0, TopRow, 0, Vert.FixedBoundary, Horz.FixedBoundary, Vert.GridBoundary,  [rgdFixed]);

    DrawCells(LeftCol, TopRow, Horz.FixedBoundary - FColOffset,                   //!! clip
        Vert.FixedBoundary, Horz.GridBoundary, Vert.GridBoundary, []);

    { Fill in area not occupied by cells }
    if Horz.GridBoundary < Horz.GridExtent then
    begin
      Canvas.Brush.Color := FColors._BakgroundFieldColor;
      Canvas.FillRect(Rect(Horz.GridBoundary, 0, Horz.GridExtent, Vert.GridBoundary));
    end;

    if Vert.GridBoundary < Vert.GridExtent then
    begin
      Canvas.Brush.Color := FColors._BakgroundFieldColor;
      Canvas.FillRect(Rect(0, Vert.GridBoundary, Horz.GridExtent, Vert.GridExtent));
    end;
  end;

  if UseRightToLeftAlignment then
    ChangeGridOrientation(False);

  Holder.CellsUnions.ResetPaintCounters();
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.PaletteColor(Color: TColor): Longint;
begin
  // PaletteMask = $02000000;
  Result := ColorToRGB(Color) or $02000000;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.StretchBltTransparent(DstDC: HDC; DstX, DstY, DstW, DstH: Integer;
  SrcDC: HDC; SrcX, SrcY, SrcW, SrcH: Integer; Palette: HPalette;
  TransparentColor: TColorRef);
var
  Color: TColorRef;
  bmAndBack, bmAndObject, bmAndMem, bmSave: HBitmap;
  bmBackOld, bmObjectOld, bmMemOld, bmSaveOld: HBitmap;
  MemDC, BackDC, ObjectDC, SaveDC: HDC;
  palDst, palMem, palSave, palObj: HPalette;
begin
  { Create some DCs to hold temporary data }
  BackDC := CreateCompatibleDC(DstDC);
  ObjectDC := CreateCompatibleDC(DstDC);
  MemDC := CreateCompatibleDC(DstDC);
  SaveDC := CreateCompatibleDC(DstDC);
  { Create a bitmap for each DC }
  bmAndObject := CreateBitmap(SrcW, SrcH, 1, 1, nil);
  bmAndBack := CreateBitmap(SrcW, SrcH, 1, 1, nil);
  bmAndMem := CreateCompatibleBitmap(DstDC, DstW, DstH);
  bmSave := CreateCompatibleBitmap(DstDC, SrcW, SrcH);
  { Each DC must select a bitmap object to store pixel data }
  bmBackOld := SelectObject(BackDC, bmAndBack);
  bmObjectOld := SelectObject(ObjectDC, bmAndObject);
  bmMemOld := SelectObject(MemDC, bmAndMem);
  bmSaveOld := SelectObject(SaveDC, bmSave);
  { Select palette }
  palDst := 0; palMem := 0; palSave := 0; palObj := 0;
  if Palette <> 0 then begin
    palDst := SelectPalette(DstDC, Palette, True);
    RealizePalette(DstDC);
    palSave := SelectPalette(SaveDC, Palette, False);
    RealizePalette(SaveDC);
    palObj := SelectPalette(ObjectDC, Palette, False);
    RealizePalette(ObjectDC);
    palMem := SelectPalette(MemDC, Palette, True);
    RealizePalette(MemDC);
  end;
  { Set proper mapping mode }
  SetMapMode(SrcDC, GetMapMode(DstDC));
  SetMapMode(SaveDC, GetMapMode(DstDC));
  { Save the bitmap sent here }
  BitBlt(SaveDC, 0, 0, SrcW, SrcH, SrcDC, SrcX, SrcY, SRCCOPY);
  { Set the background color of the source DC to the color,         }
  { contained in the parts of the bitmap that should be transparent }
  Color := SetBkColor(SaveDC, PaletteColor(TransparentColor));
  { Create the object mask for the bitmap by performing a BitBlt()  }
  { from the source bitmap to a monochrome bitmap                   }
  BitBlt(ObjectDC, 0, 0, SrcW, SrcH, SaveDC, 0, 0, SRCCOPY);
  { Set the background color of the source DC back to the original  }
  SetBkColor(SaveDC, Color);
  { Create the inverse of the object mask }
  BitBlt(BackDC, 0, 0, SrcW, SrcH, ObjectDC, 0, 0, NOTSRCCOPY);
  { Copy the background of the main DC to the destination }
  BitBlt(MemDC, 0, 0, DstW, DstH, DstDC, DstX, DstY, SRCCOPY);
  { Mask out the places where the bitmap will be placed }
  StretchBlt(MemDC, 0, 0, DstW, DstH, ObjectDC, 0, 0, SrcW, SrcH, SRCAND);
  { Mask out the transparent colored pixels on the bitmap }
  BitBlt(SaveDC, 0, 0, SrcW, SrcH, BackDC, 0, 0, SRCAND);
  { XOR the bitmap with the background on the destination DC }
  StretchBlt(MemDC, 0, 0, DstW, DstH, SaveDC, 0, 0, SrcW, SrcH, SRCPAINT);
  { Copy the destination to the screen }
  BitBlt(DstDC, DstX, DstY, DstW, DstH, MemDC, 0, 0, SRCCOPY);
  { Restore palette }
  if Palette <> 0 then
  begin
    SelectPalette(MemDC, palMem, False);
    SelectPalette(ObjectDC, palObj, False);
    SelectPalette(SaveDC, palSave, False);
    SelectPalette(DstDC, palDst, True);
  end;
  { Delete the memory bitmaps }
  DeleteObject(SelectObject(BackDC, bmBackOld));
  DeleteObject(SelectObject(ObjectDC, bmObjectOld));
  DeleteObject(SelectObject(MemDC, bmMemOld));
  DeleteObject(SelectObject(SaveDC, bmSaveOld));
  { Delete the memory DCs }
  DeleteDC(MemDC);
  DeleteDC(BackDC);
  DeleteDC(ObjectDC);
  DeleteDC(SaveDC);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.StretchBitmapTransparent(Dest: TCanvas; Bitmap: TBitmap;
  TransparentColor: TColor; DstX, DstY, DstW, DstH, SrcX, SrcY,
  SrcW, SrcH: Integer);
var
  CanvasChanging: TNotifyEvent;
begin
  if DstW <= 0 then
    DstW := Bitmap.Width;
  if DstH <= 0 then
    DstH := Bitmap.Height;
  if (SrcW <= 0) or (SrcH <= 0) then
  begin
    SrcX := 0; SrcY := 0;
    SrcW := Bitmap.Width;
    SrcH := Bitmap.Height;
  end;

  if (not Bitmap.Monochrome) then
    SetStretchBltMode(Dest.Handle, STRETCH_DELETESCANS);

  CanvasChanging := Bitmap.Canvas.OnChanging;
  try
    Bitmap.Canvas.OnChanging := nil;
    if (TransparentColor = clNone) then
    begin
      StretchBlt(Dest.Handle, DstX, DstY, DstW, DstH, Bitmap.Canvas.Handle, SrcX, SrcY, SrcW, SrcH, Dest.CopyMode);
    end
    else
    begin
      if Bitmap.Monochrome then
        TransparentColor := clWhite
      else
        TransparentColor := ColorToRGB(TransparentColor);

      StretchBltTransparent(Dest.Handle, DstX, DstY, DstW, DstH,
        Bitmap.Canvas.Handle, SrcX, SrcY, SrcW, SrcH, Bitmap.Palette,
        TransparentColor);
    end;
  finally
    Bitmap.Canvas.OnChanging := CanvasChanging;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DrawBitmapTransparent(Dest: TCanvas; DstX, DstY: Integer;
  Bitmap: TBitmap; TransparentColor: TColor);
begin
  StretchBitmapTransparent(Dest, Bitmap, TransparentColor, DstX, DstY,
    Bitmap.Width, Bitmap.Height, 0, 0, Bitmap.Width, Bitmap.Height);
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.WriteText(ARect: TRect; DX, DY: Integer;
  const Text: string; Alignment: TAlignment; WordWrap: Boolean);
const
  AlignFlags: array [TAlignment] of Integer =
    (DT_LEFT or DT_EXPANDTABS or DT_NOPREFIX,
     DT_RIGHT or DT_EXPANDTABS or DT_NOPREFIX,
     DT_CENTER or DT_EXPANDTABS or DT_NOPREFIX);
  WrapFlags: array[Boolean] of Integer = (0, DT_WORDBREAK);

var
  B, R: TRect;
  I, Left: Integer;
begin
  I := ColorToRGB(Canvas.Brush.Color);

  if not WordWrap and (Integer(GetNearestColor(Canvas.Handle, I)) = I) and
    (Pos(#13, Text) = 0) then
  begin // Use ExtTextOut for solid colors
    case Alignment of
      taLeftJustify: Left := ARect.Left + DX;
      taRightJustify: Left := ARect.Right - Canvas.TextWidth(Text) - 3;
      else // taCenter
        Left := ARect.Left + (ARect.Right - ARect.Left) shr 1
          - (Canvas.TextWidth(Text) shr 1);
    end;

    ExtTextOut(Canvas.Handle, Left, ARect.Top + DY, ETO_OPAQUE or
      ETO_CLIPPED, @ARect, PChar(Text), Length(Text), nil);
  end
  else 
  begin // Use FillRect and DrawText for dithered colors
  
    //  -    flicker,    ... 
    
    with FDrawBitmap, ARect do // Use offscreen bitmap to eliminate flicker and
    begin                     // brush origin tics in painting / scrolling.
      Width := Max(Width, Right - Left);
      Height := Max(Height, Bottom - Top);
      R := Rect(DX, DY, Right - Left - 1, Bottom - Top - 1);
      B := Rect(0, 0, Right - Left, Bottom - Top);
    end;
    with FDrawBitmap.Canvas do begin
      Font := Canvas.Font;
      Font.Color := Canvas.Font.Color;
      Brush := Canvas.Brush;
      Brush.Style := bsSolid;
      FillRect(B);
      SetBkMode(Handle, TRANSPARENT);

      DrawText(Handle, PChar(Text), Length(Text), R, AlignFlags[Alignment] or WrapFlags[WordWrap]);
    end;
    Canvas.CopyRect(ARect, FDrawBitmap.Canvas, B);
    //DrawText(Canvas.Handle, PChar(Text), Length(Text), ARect, AlignFlags[Alignment] or WrapFlags[WordWrap]);
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DrawCellTextEx(const S: string; {const }ARect: TRect; Align: TAlignment;
  VertAlign: TRVertAlignment; WordWrap: Boolean);
{  
const
  MinOffs = 2;
var
  H: Integer;
begin
  case VertAlign of
    vaTopJustify:
      H := MinOffs;

    vaCenter:
        H := Max(1, (ARect.Bottom - ARect.Top - Canvas.TextHeight('W')) div 2);
    else
    begin
        H := Max(MinOffs, ARect.Bottom - ARect.Top - Canvas.TextHeight('W'));
    end;
  end;
  WriteText(ARect, MinOffs, H, S, Align, WordWrap);
}
const
  HAlignFlags: array [TAlignment] of Integer =
    (DT_LEFT,
     DT_RIGHT,
     DT_CENTER);

  VAlignFlags: array [TRVertAlignment] of Integer =
    (DT_TOP,
     //DT_BOTTOM,
     DT_VCENTER,
     DT_BOTTOM);   
     
  ExtFlags: Integer = DT_EXPANDTABS or DT_NOPREFIX or DT_END_ELLIPSIS;
     
  WrapFlags: array[Boolean] of Integer = (DT_SINGLELINE, DT_WORDBREAK);
begin
  if (WordWrap) then
    VertAlign := rvaTopJustify;

  {
  if (Align = taLeftJustify) then
    Inc(ARect.Left, 3);

  if (VertAlign = rvaTopJustify) then
    Inc(ARect.Top, 3);
  }

  DrawText(Canvas.Handle, PChar(S), Length(S), ARect, HAlignFlags[Align] or VAlignFlags[VertAlign] or ExtFlags or WrapFlags[WordWrap]);
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.DrawPicture(ARect: TRect; Graphic: TGraphic);
begin
  ARect.Top := (ARect.Bottom + ARect.Top - Graphic.Height) div 2;
  ARect.Left := (ARect.Right + ARect.Left - Graphic.Width) div 2;
  Canvas.Draw(ARect.Left, ARect.Top, Graphic);
end;
}
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DrawMaskedBitmap(ARect: TRect; X, Y: Integer; Graphic: TBitmap);
begin
  DrawBitmapTransparent(Canvas, X, Y, Graphic, Graphic.TransparentColor and not $02000000);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DrawCellText(const S: string; ARect: TRect; Align: TAlignment;
  VertAlign: TRVertAlignment; WordWrap: Boolean);
begin
  DrawCellTextEx(S, ARect, Align, rvaCenter, False);
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.DrawStr(ARect: TRect; const S: string;
  Align: TAlignment);
begin
  DrawCellTextEx(S, ARect, Align, rvaCenter, False);
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.DrawMultiline(ARect: TRect; const S: string;
  Align: TAlignment);
begin
  DrawCellTextEx(S, ARect, Align, rvaTopJustify, True);
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.DoGetImageIndex(Cell: TRCell; var ImageIndex: Longint);
begin
  if Assigned(FOnGetImageIndex) then
    FOnGetImageIndex(Self, Cell, ImageIndex);
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.DoGetCellText(Cell: TRCell; var CellText: string);
begin
  if FRecursionTrap then
  begin
    //    FOnGetCellText
    Exit;
  end
  else
  begin
    FRecursionTrap := True;

    if Assigned(FOnGetCellText) then
      FOnGetCellText(Self, Cell, CellText);
  end;

  FRecursionTrap := False;
end;
}
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.DoBeforeDrawCell(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; CellRect: TRect): Boolean;
var
  Hold: Integer;
begin
  Result := False;

  if Assigned(FOnBeforeDrawCell) then
  begin
    if UseRightToLeftAlignment then
    begin
      CellRect.Left := ClientWidth - CellRect.Left;
      CellRect.Right := ClientWidth - CellRect.Right;
      Hold := CellRect.Left;
      CellRect.Left := CellRect.Right;
      CellRect.Right := Hold;

      ChangeGridOrientation(False);
    end;

    FOnBeforeDrawCell(Self, Cell, ACol, ARow, State, CellRect, Result);

    if UseRightToLeftAlignment then
      ChangeGridOrientation(True);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.DoDrawCellField(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; Rect: TRect): Boolean;
begin
  Result := False;

  if Assigned(FOnDrawCellField) then
  begin
    FOnDrawCellField(Self, Cell, ACol, ARow, State, Rect, Result);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoDrawImage(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; var Rect: TRect; var ImageIndex: Longint; var HorAlignment: TAlignment; var VertAlignment: TRVertAlignment);
begin
  //DoGetImageIndex(Cell, ImageIndex);

  if Assigned(FOnDrawImage) then
  begin
    FOnDrawImage(Self, Cell, ACol, ARow, State, Rect, ImageIndex, HorAlignment, VertAlignment);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoDrawCellText(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; var Rect: TRect; var CellText: string; var Multiline: Boolean; var HorAlignment: TAlignment; var VertAlignment: TRVertAlignment);
begin
  //DoGetCellText(Cell, CellText);

  if Assigned(FOnDrawCellText) then
  begin
    FOnDrawCellText(Self, Cell, ACol, ARow, State, Rect, CellText, Multiline, HorAlignment, VertAlignment);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoAfterDrawCell(Cell: TRCell; ACol, ARow: Longint; State: TRGridDrawStates; CellRect: TRect);
var
  Hold: Integer;
begin
  if Assigned(FOnAfterDrawCell) then
  begin
    if UseRightToLeftAlignment then
    begin
      CellRect.Left := ClientWidth - CellRect.Left;
      CellRect.Right := ClientWidth - CellRect.Right;
      Hold := CellRect.Left;
      CellRect.Left := CellRect.Right;
      CellRect.Right := Hold;

      ChangeGridOrientation(False);
    end;

    FOnAfterDrawCell(Self, Cell, ACol, ARow, State, CellRect);

    if UseRightToLeftAlignment then
      ChangeGridOrientation(True);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoInitCell(Cell: TRCell);
begin
  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if Assigned(FOnInitCell) then
      FOnInitCell(Self, Cell);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoFreeCell(Cell: TRCell);
begin
  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if Assigned(FOnFreeCell) then
      FOnFreeCell(Self, Cell);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoInitCellsVector(CellsVector: TRCellsVector);
begin
  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if Assigned(FOnInitVector) then
      FOnInitVector(Self, CellsVector);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoFreeCellsVector(CellsVector: TRCellsVector);
begin
  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if Assigned(FOnFreeVector) then
      FOnFreeVector(Self, CellsVector);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCustomGrid.DoMarkCol(CellsVector: TRCellsVector; MarkValue: Boolean): Boolean;
begin
  Result := True;

  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if (rgoColsMarking in FOptions) then
    begin
      if Assigned(FOnMarkCol) then
        FOnMarkCol(Self, CellsVector, MarkValue, Result);
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCustomGrid.DoMarkRow(CellsVector: TRCellsVector; MarkValue: Boolean): Boolean;
begin
  Result := True;

  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if (rgoRowsMarking in FOptions) then
    begin
      if Assigned(FOnMarkRow) then
        FOnMarkRow(Self, CellsVector, MarkValue, Result);
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function  TRCustomGrid.DoMarkCell(Cell: TRCell; MarkValue: Boolean): Boolean;
begin
  Result := True;

  if ([csLoading, csDesigning] * ComponentState = []) then
  begin
    if (rgoCellsMarking in FOptions) then
    begin
      if Assigned(FOnMarkCell) then
        FOnMarkCell(Self, Cell, MarkValue, Result);
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.CalcCoordFromPoint(X, Y: Integer;
  const DrawInfo: TRGridDrawInfo): TRGridCoord;

  function DoCalc(const AxisInfo: TRGridAxisDrawInfo; N: Integer): Integer;
  var
    I, Start, Stop: Longint;
    Line: Integer;
  begin
    with AxisInfo do
    begin
      if N < FixedBoundary then
      begin
        Start := 0;
        Stop :=  FixedCellCount - 1;
        Line := 0;
      end
      else
      begin
        Start := FirstGridCell;
        Stop := GridCellCount - 1;
        Line := FixedBoundary;
      end;
      Result := -1;
      for I := Start to Stop do
      begin
        Inc(Line, GetExtent(I) + EffectiveLineWidth);
        if N < Line then
        begin
          Result := I;
          Exit;
        end;
      end;
    end;
  end;

  function DoCalcRightToLeft(const AxisInfo: TRGridAxisDrawInfo; N: Integer): Integer;
  var
    I, Start, Stop: Longint;
    Line: Integer;
  begin
    N := ClientWidth - N;
    with AxisInfo do
    begin
      if N < FixedBoundary then
      begin
        Start := 0;
        Stop :=  FixedCellCount - 1;
        Line := ClientWidth;
      end
      else
      begin
        Start := FirstGridCell;
        Stop := GridCellCount - 1;
        Line := FixedBoundary;
      end;
      Result := -1;
      for I := Start to Stop do
      begin
        Inc(Line, GetExtent(I) + EffectiveLineWidth);
        if N < Line then
        begin
          Result := I;
          Exit;
        end;
      end;
    end;
  end;

begin
  if not UseRightToLeftAlignment then
    Result.X := DoCalc(DrawInfo.Horz, X)
  else
    Result.X := DoCalcRightToLeft(DrawInfo.Horz, X);

  Result.Y := DoCalc(DrawInfo.Vert, Y);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CalcDrawInfo(var DrawInfo: TRGridDrawInfo);
begin
  CalcDrawInfoXY(DrawInfo, ClientWidth, ClientHeight);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CalcDrawInfoXY(var DrawInfo: TRGridDrawInfo;
  UseWidth, UseHeight: Integer);

  procedure CalcAxis(var AxisInfo: TRGridAxisDrawInfo; UseExtent: Integer);
  var
    I: Integer;
  begin
    with AxisInfo do
    begin
      GridExtent := UseExtent;
      GridBoundary := FixedBoundary;
      FullVisBoundary := FixedBoundary;
      LastFullVisibleCell := FirstGridCell;

      for I := FirstGridCell to GridCellCount - 1 do
      begin
        Inc(GridBoundary, GetExtent(I) + EffectiveLineWidth);
        if GridBoundary > GridExtent + EffectiveLineWidth then
        begin
          GridBoundary := GridExtent;
          Break;
        end;
        LastFullVisibleCell := I;
        FullVisBoundary := GridBoundary;
      end;
    end;
  end;

begin
  CalcFixedInfo(DrawInfo);
  CalcAxis(DrawInfo.Horz, UseWidth);
  CalcAxis(DrawInfo.Vert, UseHeight);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CalcFixedInfo(var DrawInfo: TRGridDrawInfo);

  procedure CalcFixedAxis(var Axis: TRGridAxisDrawInfo; LineOptions: TRGridOptions;
    FixedCount, FirstCell, CellCount: Integer; GetExtentFunc: TRGetExtentsFunc);
  var
    I: Integer;
  begin
    with Axis do
    begin
      if LineOptions * Options = [] then
        EffectiveLineWidth := 0
      else
        EffectiveLineWidth := GridLineWidth;

      FixedBoundary := 0;
      for I := 0 to FixedCount - 1 do
        Inc(FixedBoundary, GetExtentFunc(I) + EffectiveLineWidth);

      FixedCellCount := FixedCount;
      FirstGridCell := FirstCell;
      GridCellCount := CellCount;
      GetExtent := GetExtentFunc;
    end;
  end;

begin
  CalcFixedAxis(DrawInfo.Horz, [rgoFixedVertLine, rgoVertLine], FixedCols,
    LeftCol, ColCount, GetColWidths);
  CalcFixedAxis(DrawInfo.Vert, [rgoFixedHorzLine, rgoHorzLine], FixedRows,
    TopRow, RowCount, GetRowHeights);
end;
//----------------------------------------------------------------------------------------------------------------------
{ Calculates the TopLeft that will put the given Coord in view }
function TRCustomGrid.CalcMaxTopLeft(const Coord: TRGridCoord;
  const DrawInfo: TRGridDrawInfo): TRGridCoord;

  function CalcMaxCell(const Axis: TRGridAxisDrawInfo; Start: Integer): Integer;
  var
    Line: Integer;
    I, Extent: Longint;
  begin
    Result := Start;
    with Axis do
    begin
      Line := GridExtent + EffectiveLineWidth;
      for I := Start downto FixedCellCount do
      begin
        Extent := GetExtent(I);
        if Extent > 0 then
        begin
          Dec(Line, Extent);
          Dec(Line, EffectiveLineWidth);
          if Line < FixedBoundary then
          begin
            if (Result = Start) and (GetExtent(Start) <= 0) then
              Result := I;
            Break;
          end;
          Result := I;
        end;
      end;
    end;
  end;

begin
  Result.X := CalcMaxCell(DrawInfo.Horz, Coord.X);
  Result.Y := CalcMaxCell(DrawInfo.Vert, Coord.Y);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CalcSizingState(X, Y: Integer; var State: TRGridState;
  var Index: Longint; var SizingPos, SizingOfs: Integer;
  var FixedInfo: TRGridDrawInfo);

  procedure CalcAxisState(const AxisInfo: TRGridAxisDrawInfo; Pos: Integer;
    NewState: TRGridState);
  var
    I, Line, Back, Range: Integer;
  begin
    if (NewState = rgsColSizing) and UseRightToLeftAlignment then 
      Pos := ClientWidth - Pos;
    with AxisInfo do
    begin
      Line := FixedBoundary;
      Range := EffectiveLineWidth;
      Back := 0;
      if Range < 7 then
      begin
        Range := 7;
        Back := (Range - EffectiveLineWidth) shr 1;
      end;
      for I := FirstGridCell to GridCellCount - 1 do
      begin
        Inc(Line, GetExtent(I));
        if Line > GridBoundary then Break;
        if (Pos >= Line - Back) and (Pos <= Line - Back + Range) then
        begin
          State := NewState;
          SizingPos := Line;
          SizingOfs := Line - Pos;
          Index := I;
          Exit;
        end;
        Inc(Line, EffectiveLineWidth);
      end;
      if (GridBoundary = GridExtent) and (Pos >= GridExtent - Back)
        and (Pos <= GridExtent) then
      begin
        State := NewState;
        SizingPos := GridExtent;
        SizingOfs := GridExtent - Pos;
        Index := LastFullVisibleCell + 1;
      end;
    end;
  end;

  function XOutsideHorzFixedBoundary: Boolean;
  begin
    with FixedInfo do
      if not UseRightToLeftAlignment then
        Result := X > Horz.FixedBoundary
      else
        Result := X < ClientWidth - Horz.FixedBoundary;
  end;

  function XOutsideOrEqualHorzFixedBoundary: Boolean;
  begin
    with FixedInfo do
      if not UseRightToLeftAlignment then
        Result := X >= Horz.FixedBoundary
      else
        Result := X <= ClientWidth - Horz.FixedBoundary;
  end;


var
  EffectiveOptions: TRGridOptions;
begin
  State := rgsNormal;
  Index := -1;
  EffectiveOptions := Options;
  if csDesigning in ComponentState then
    EffectiveOptions := EffectiveOptions + DesignOptionsBoost;
  if [rgoColSizing, rgoRowSizing] * EffectiveOptions <> [] then
    with FixedInfo do
    begin
      Vert.GridExtent := ClientHeight;
      Horz.GridExtent := ClientWidth;
      if (XOutsideHorzFixedBoundary) and (rgoColSizing in EffectiveOptions) then
      begin
        if Y >= Vert.FixedBoundary then Exit;
        CalcAxisState(Horz, X, rgsColSizing);
      end
      else if (Y > Vert.FixedBoundary) and (rgoRowSizing in EffectiveOptions) then
      begin
        if XOutsideOrEqualHorzFixedBoundary then Exit;
        CalcAxisState(Vert, Y, rgsRowSizing);
      end;
    end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ChangeGridOrientation(RightToLeftOrientation: Boolean);
var
  Org: TPoint;
  Ext: TPoint;
begin
  if RightToLeftOrientation then
  begin
    Org := Point(ClientWidth,0);
    Ext := Point(-1,1);
    SetMapMode(Canvas.Handle, mm_Anisotropic);
    SetWindowOrgEx(Canvas.Handle, Org.X, Org.Y, nil);
    SetViewportExtEx(Canvas.Handle, ClientWidth, ClientHeight, nil);
    SetWindowExtEx(Canvas.Handle, Ext.X*ClientWidth, Ext.Y*ClientHeight, nil);
  end
  else
  begin
    Org := Point(0,0);
    Ext := Point(1,1);
    SetMapMode(Canvas.Handle, mm_Anisotropic);
    SetWindowOrgEx(Canvas.Handle, Org.X, Org.Y, nil);
    SetViewportExtEx(Canvas.Handle, ClientWidth, ClientHeight, nil);
    SetWindowExtEx(Canvas.Handle, Ext.X*ClientWidth, Ext.Y*ClientHeight, nil);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.PrepareChangeSize;
begin
  if HandleAllocated then
    CalcDrawInfo(FOldDrawInfo);

  FOldColCount := ColCount;
  FOldRowCount := RowCount;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoChangeSize;
var
  Coord: TRGridCoord;
  NewDrawInfo: TRGridDrawInfo;
  OldDoubleBuffered: Boolean;
  //NewTopLeft, NewCurrent, MaxTopLeft: TRGridCoord;

  procedure MinRedraw(const OldInfo, NewInfo: TRGridAxisDrawInfo; Axis: Integer);
  var
    R: TRect;
    First: Integer;
  begin
    First := Min(OldInfo.LastFullVisibleCell, NewInfo.LastFullVisibleCell);
    // Get the rectangle around the leftmost or topmost cell in the target range.
    R := CellRect(First and not Axis, First and Axis);
    R.Bottom := Height;
    R.Right := Width;
    Windows.InvalidateRect(Handle, @R, False);
  end;

  {
  procedure Restrict(var Coord: TRGridCoord; MinX, MinY, MaxX, MaxY: Longint);
  begin
    with Coord do
    begin
      if X > MaxX then X := MaxX
      else if X < MinX then X := MinX;
      if Y > MaxY then Y := MaxY
      else if Y < MinY then Y := MinY;
    end;
  end;
  }

begin
  OldDoubleBuffered := DoubleBuffered;
  DoubleBuffered := True;

  {
  //if (FCurrent.X > -1) and (FCurrent.Y > -1) then
  begin
    Coord := FCurrent;

    if Row >= RowCount then
      Coord.Y := RowCount - 1;

    if Col >= ColCount then
      Coord.X := ColCount - 1;

    if Row < FixedRows then
      Coord.Y := FixedRows;

   if Col < FixedCols then
      Coord.X := FixedCols;

    if (FCurrent.X <> Coord.X) or (FCurrent.Y <> Coord.Y) then
      MoveCurrent(Coord.X, Coord.Y, True);
  end;
  }

  {
  CalcDrawInfo(NewDrawInfo);

  MaxTopLeft.X := ColCount - 1;
  MaxTopLeft.Y := RowCount - 1;
  MaxTopLeft := CalcMaxTopLeft(MaxTopLeft, NewDrawInfo);

  Restrict(NewTopLeft, FixedCols, FixedRows, MaxTopLeft.X, MaxTopLeft.Y);

  if (NewTopLeft.X <> LeftCol) or (NewTopLeft.Y <> TopRow) then
  begin
    //MoveTopLeft(NewTopLeft.X, NewTopLeft.Y);
    FTopLeft := NewTopLeft;
    VirtualView := True;
  end;  

  Restrict(NewCurrent, FixedCols, FixedRows, ColCount - 1, RowCount - 1);

  if (NewCurrent.X <> Col) or (NewCurrent.Y <> Row) then
  begin
    //FocusCell(NewCurrent.X, NewCurrent.Y, true);
    FCurrent := NewCurrent;
    RefreshCurrentRect;
    VirtualView := True;
  end;  
  }
  
  { 
  if Row >= RowCount then
    FCurrent.Y := RowCount - 1;

  if Col >= ColCount then
    FCurrent.X := ColCount - 1;

  if Row < FixedRows then
    FCurrent.Y := FixedRows;

  if Col < FixedCols then
    FCurrent.X := FixedCols;
  }

  //      
  if (FCurrentCell <> NIL) then
  begin
    if (FCurrentCell.GridCol > -1) and (FCurrentCell.GridRow > -1) then
    begin
      Coord.X := FCurrentCell.GridCol;
      Coord.Y := FCurrentCell.GridRow;
    end
    else
    begin
      Coord := FCurrent;
    end;
  end
  else
  begin
    Coord := FCurrent;
  end;  

  //    
  if (FCurrentCell <> NIL) then
  begin
    FCurrentCell := NIL;
  end;

  if {Row}Coord.Y >= RowCount then
    Coord.Y := RowCount - 1;

  if {Col}Coord.X >= ColCount then
    Coord.X := ColCount - 1;

  if {Row}Coord.Y < FixedRows then
    Coord.Y := FixedRows;

  if {Col}Coord.X < FixedCols then
    Coord.X := FixedCols;  

  if VirtualView
    or (LeftCol <> FOldDrawInfo.Horz.FirstGridCell)
    or (TopRow <> FOldDrawInfo.Vert.FirstGridCell) then
  begin
    InvalidateGrid;
    VirtualView := False;
  end
  else if HandleAllocated then
  begin
    CalcDrawInfo(NewDrawInfo);
    MinRedraw(FOldDrawInfo.Horz, NewDrawInfo.Horz, 0);
    MinRedraw(FOldDrawInfo.Vert, NewDrawInfo.Vert, -1);
  end;

  MoveCurrent(Coord.X, Coord.Y, True);  //???
  //    FCurrent,
  //  MoveCurrent    
  UpdateScrollRange;

  DoubleBuffered := OldDoubleBuffered;
  
  //MoveCurrent(Coord.X, Coord.Y, True);

  //MoveCurrent(FCurrent.X, FCurrent.Y, True);

  SizeChanged(FOldColCount, FOldRowCount);
end;
//----------------------------------------------------------------------------------------------------------------------
{ Will move TopLeft so that Coord is in view }
procedure TRCustomGrid.ClampInView(const Coord: TRGridCoord);
var
  DrawInfo: TRGridDrawInfo;
  MaxTopLeft: TRGridCoord;
  OldTopLeft: TRGridCoord;
begin
  if not HandleAllocated then
    Exit;

  CalcDrawInfo(DrawInfo);
  with DrawInfo, Coord do
  begin
    if (X > Horz.LastFullVisibleCell)
      or (Y > Vert.LastFullVisibleCell)
      or (X < LeftCol) or (Y < TopRow) then
    begin
      OldTopLeft := FTopLeft;
      MaxTopLeft := CalcMaxTopLeft(Coord, DrawInfo);
      Update;

      if X < LeftCol then
        FTopLeft.X := X
      else if X > Horz.LastFullVisibleCell then
        FTopLeft.X := MaxTopLeft.X;

      if Y < TopRow then
        FTopLeft.Y := Y
      else if Y > Vert.LastFullVisibleCell then
        FTopLeft.Y := MaxTopLeft.Y;

      TopLeftMoved(OldTopLeft);
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DrawSizingLine(const DrawInfo: TRGridDrawInfo);
var
  OldPen: TPen;
begin
  OldPen := TPen.Create;
  try
    with Canvas, DrawInfo do
    begin
      OldPen.Assign(Pen);
      Pen.Style := psDot;
      Pen.Mode := pmXor;
      Pen.Width := 1;
      try
        if FGridState = rgsRowSizing then
        begin
          if UseRightToLeftAlignment then 
          begin
            MoveTo(Horz.GridExtent, FSizingPos); 
            LineTo(Horz.GridExtent - Horz.GridBoundary, FSizingPos); 
          end
          else
          begin
            MoveTo(0, FSizingPos);
            LineTo(Horz.GridBoundary, FSizingPos);
          end;
        end
        else
        begin
          MoveTo(FSizingPos, 0);
          LineTo(FSizingPos, Vert.GridBoundary);
        end;
      finally
        Pen := OldPen;
      end;
    end;
  finally
    OldPen.Free;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DrawMove;
var
  OldPen: TPen;
  Pos: Integer;
  R: TRect;
begin
  OldPen := TPen.Create;
  try
    with Canvas do
    begin
      OldPen.Assign(Pen);
      try
        Pen.Color := clGray; //!!! ,     ...
        Pen.Style := psDot;
        Pen.Mode  := pmXor;
        Pen.Width := 5;
        if FGridState = rgsRowMoving then
        begin
          R := CellRect(0, FMovePos);
          if FMovePos > FMoveIndex then
            Pos := R.Bottom else
            Pos := R.Top;
          MoveTo(0, Pos);
          LineTo(ClientWidth, Pos);
        end
        else
        begin
          R := CellRect(FMovePos, 0);
          if FMovePos > FMoveIndex then
            if not UseRightToLeftAlignment then
              Pos := R.Right
            else
              Pos := R.Left
          else
            if not UseRightToLeftAlignment then
              Pos := R.Left
            else
              Pos := R.Right;
          MoveTo(Pos, 0);
          LineTo(Pos, ClientHeight);
        end;
      finally
        Canvas.Pen := OldPen;
      end;
    end;
  finally
    OldPen.Free;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.FocusCell(ACol, ARow: Longint; MoveAnchor: Boolean);
begin
  MoveCurrent(ACol, ARow, True);

  Click;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.GridRectToScreenRect(GridRect: TRGridRect;
  var ScreenRect: TRect; IncludeLine: Boolean);

  function LinePos(const AxisInfo: TRGridAxisDrawInfo; Line: Integer): Integer;
  var
    Start, I: Longint;
  begin
    with AxisInfo do
    begin
      Result := 0;
      if Line < FixedCellCount then
        Start := 0
      else
      begin
        if Line >= FirstGridCell then
          Result := FixedBoundary;
        Start := FirstGridCell;
      end;
      for I := Start to Line - 1 do
      begin
        Inc(Result, GetExtent(I) + EffectiveLineWidth);
        if Result > GridExtent then
        begin
          Result := 0;
          Exit;
        end;
      end;
    end;
  end;

  function CalcAxis(const AxisInfo: TRGridAxisDrawInfo;
    GridRectMin, GridRectMax: Integer;
    var ScreenRectMin, ScreenRectMax: Integer): Boolean;
  begin
    Result := False;
    with AxisInfo do
    begin
      if (GridRectMin >= FixedCellCount) and (GridRectMin < FirstGridCell) then
        if GridRectMax < FirstGridCell then
        begin
          FillChar(ScreenRect, SizeOf(ScreenRect), 0); { erase partial results }
          Exit;
        end
        else
          GridRectMin := FirstGridCell;
      if GridRectMax > LastFullVisibleCell then
      begin
        GridRectMax := LastFullVisibleCell;
        if GridRectMax < GridCellCount - 1 then Inc(GridRectMax);
        if LinePos(AxisInfo, GridRectMax) = 0 then
          Dec(GridRectMax);
      end;

      ScreenRectMin := LinePos(AxisInfo, GridRectMin);
      ScreenRectMax := LinePos(AxisInfo, GridRectMax);
      if ScreenRectMax = 0 then
        ScreenRectMax := ScreenRectMin + GetExtent(GridRectMin)
      else
        Inc(ScreenRectMax, GetExtent(GridRectMax));
      if ScreenRectMax > GridExtent then
        ScreenRectMax := GridExtent;
      if IncludeLine then Inc(ScreenRectMax, EffectiveLineWidth);
    end;
    Result := True;
  end;

var
  DrawInfo: TRGridDrawInfo;
  Hold: Integer;
begin
  FillChar(ScreenRect, SizeOf(ScreenRect), 0);
  if (GridRect.Left > GridRect.Right) or (GridRect.Top > GridRect.Bottom) then
    Exit;
  CalcDrawInfo(DrawInfo);
  with DrawInfo do
  begin
    if GridRect.Left > Horz.LastFullVisibleCell + 1 then Exit;
    if GridRect.Top > Vert.LastFullVisibleCell + 1 then Exit;

    if CalcAxis(Horz, GridRect.Left, GridRect.Right, ScreenRect.Left,
      ScreenRect.Right) then
    begin
      CalcAxis(Vert, GridRect.Top, GridRect.Bottom, ScreenRect.Top,
        ScreenRect.Bottom);
    end;
  end;
  if UseRightToLeftAlignment and (Canvas.CanvasOrientation = coLeftToRight) then
  begin
    Hold := ScreenRect.Left;
    ScreenRect.Left := ClientWidth - ScreenRect.Right;
    ScreenRect.Right := ClientWidth - Hold;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.Initialize;
begin
  FTopLeft.X := FixedCols;
  FTopLeft.Y := FixedRows;
  FCurrent := FTopLeft;

  RefreshCurrentRect;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.InvalidateCell(ACol, ARow: Longint);
var
  Rect: TRGridRect;
begin
  if (Cells[ACol, ARow].Unioned) then
  begin
    Rect := Cells[ACol, ARow].GridUnion.UnionRect;

    if Rect.Left >= FFixedCols then
      if Rect.Left < FTopLeft.X then
        Rect.Left := FTopLeft.X;

    if Rect.Top >= FFixedRows then
      if Rect.Top < FTopLeft.Y then
        Rect.Top := FTopLeft.Y;

    if (Rect.Left > Rect.Right) or (Rect.Top > Rect.Bottom) then
      Exit;
  end
  else
  begin
    Rect.Top := ARow;
    Rect.Left := ACol;
    Rect.Bottom := ARow;
    Rect.Right := ACol;
  end;

  InvalidateRect(Rect);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.InvalidateCol(ACol: Longint);
var
  Rect: TRGridRect;
  k: LongInt;
  InvalidateByCells: Boolean;
begin
  if (not HandleAllocated) then
    Exit;

  InvalidateByCells := False;

  for k := 0 to FTopLeft.Y + VisibleRowCount do
  begin
    if (k < FFixedRows) or ((k >= FTopLeft.Y) and (k <= FTopLeft.Y + VisibleRowCount)) then
    begin
      if k < FRowCount then
      begin
        if (Cells[ACol, k].Unioned) then
        begin
          InvalidateByCells := True;
          Break;
        end;
      end;
    end;
  end;

  if (not InvalidateByCells) then
  begin
    Rect.Top := 0;
    Rect.Left := ACol;
    Rect.Bottom := FTopLeft.Y + VisibleRowCount;
    Rect.Right := ACol;
    InvalidateRect(Rect);
  end
  else
  begin
    for k := 0 to FTopLeft.Y + VisibleRowCount do
    begin
      if (k < FFixedRows) or ((k >= FTopLeft.Y) and (k <= FTopLeft.Y + VisibleRowCount)) then
      begin
        if k < FRowCount then
          InvalidateCell(ACol, k);
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.InvalidateRow(ARow: Longint);
var
  Rect: TRGridRect;
  k: LongInt;
  InvalidateByCells: Boolean;
begin
  if not HandleAllocated then
    Exit;

  InvalidateByCells := False;

  for k := 0 to FTopLeft.X + VisibleColCount do
  begin
    if (k < FFixedCols) or ((k >= FTopLeft.X) and (k <= FTopLeft.X + VisibleColCount)) then
    begin
      if k < FColCount then
      begin
        if (Cells[k, ARow].Unioned) then
        begin
          InvalidateByCells := True;
          Break;
        end;
      end;
    end;
  end;

  if (not InvalidateByCells) then
  begin
    Rect.Top := ARow;
    Rect.Left := 0;
    Rect.Bottom := ARow;
    Rect.Right := FTopLeft.X + VisibleColCount;
    InvalidateRect(Rect);
  end
  else
  begin
    for k := 0 to FTopLeft.X + VisibleColCount do
    begin
      if (k < FFixedCols) or ((k >= FTopLeft.X) and (k <= FTopLeft.X + VisibleColCount)) then
      begin
        if k < FColCount then
          InvalidateCell(k, ARow);
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.InvalidateGrid;
begin
  Invalidate;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.InvalidateRect(ARect: TRGridRect);
var
  InvalidRect: TRect;
begin
  if (not HandleAllocated) then
    Exit;

  GridRectToScreenRect(ARect, InvalidRect, True);
  Windows.InvalidateRect(Handle, @InvalidRect, False);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ModifyScrollBar(ScrollBar, ScrollCode, Pos: Cardinal;
  UseRightToLeft: Boolean);
var
  NewTopLeft, MaxTopLeft: TRGridCoord;
  DrawInfo: TRGridDrawInfo;
  RTLFactor: Integer;

  function Min: Longint;
  begin
    if ScrollBar = SB_HORZ then Result := FixedCols
    else Result := FixedRows;
  end;

  function Max: Longint;
  begin
    if ScrollBar = SB_HORZ then Result := MaxTopLeft.X
    else Result := MaxTopLeft.Y;
  end;

  function PageUp: Longint;
  var
    MaxTopLeft: TRGridCoord;
  begin
    MaxTopLeft := CalcMaxTopLeft(FTopLeft, DrawInfo);
    if ScrollBar = SB_HORZ then
      Result := FTopLeft.X - MaxTopLeft.X else
      Result := FTopLeft.Y - MaxTopLeft.Y;
    if Result < 1 then Result := 1;
  end;

  function PageDown: Longint;
  var
    DrawInfo: TRGridDrawInfo;
  begin
    CalcDrawInfo(DrawInfo);
    with DrawInfo do
      if ScrollBar = SB_HORZ then
        Result := Horz.LastFullVisibleCell - FTopLeft.X else
        Result := Vert.LastFullVisibleCell - FTopLeft.Y;
    if Result < 1 then Result := 1;
  end;

  function CalcScrollBar(Value, ARTLFactor: Longint): Longint;
  begin
    Result := Value;
    case ScrollCode of
      SB_LINEUP:
        Dec(Result, ARTLFactor);
      SB_LINEDOWN:
        Inc(Result, ARTLFactor);
      SB_PAGEUP:
        Dec(Result, PageUp * ARTLFactor);
      SB_PAGEDOWN:
        Inc(Result, PageDown * ARTLFactor);
      SB_THUMBPOSITION, SB_THUMBTRACK:
        if (rgoThumbTracking in Options) or (ScrollCode = SB_THUMBPOSITION) then
        begin
          if (not UseRightToLeftAlignment) or (ARTLFactor = 1) then
            Result := Min + LongMulDiv(Pos, Max - Min, RMaxShortInt)
          else
            Result := Max - LongMulDiv(Pos, Max - Min, RMaxShortInt);
        end;
      SB_BOTTOM:
        Result := Max;
      SB_TOP:
        Result := Min;
    end;
  end;

  procedure ModifyPixelScrollBar(Code, Pos: Cardinal);
  var
    NewOffset: Integer;
    OldOffset: Integer;
    R: TRGridRect;
    GridSpace, ColWidth: Integer;

  begin
    NewOffset := FColOffset;
    ColWidth := ColWidths[DrawInfo.Horz.FirstGridCell];
    GridSpace := ClientWidth - DrawInfo.Horz.FixedBoundary;
    case Code of
      SB_LINEUP: Dec(NewOffset, Canvas.TextWidth('0') * RTLFactor);
      SB_LINEDOWN: Inc(NewOffset, Canvas.TextWidth('0') * RTLFactor);
      SB_PAGEUP: Dec(NewOffset, GridSpace * RTLFactor);
      SB_PAGEDOWN: Inc(NewOffset, GridSpace * RTLFactor);
      SB_THUMBPOSITION,
      SB_THUMBTRACK:
        if (rgoThumbTracking in Options) or (Code = SB_THUMBPOSITION) then
        begin
          if not UseRightToLeftAlignment then
            NewOffset := Pos
          else
            NewOffset := Max - Integer(Pos);
        end;
      SB_BOTTOM: NewOffset := 0;
      SB_TOP: NewOffset := ColWidth - GridSpace;
    end;
    if NewOffset < 0 then
      NewOffset := 0
    else if NewOffset >= ColWidth - GridSpace then
      NewOffset := ColWidth - GridSpace;
    if NewOffset <> FColOffset then
    begin
      OldOffset := FColOffset;
      FColOffset := NewOffset;
      ScrollData(OldOffset - NewOffset, 0);
      FillChar(R, SizeOf(R), 0);
      R.Bottom := FixedRows;
      InvalidateRect(R);
      Update;
      UpdateScrollPos;
    end;
  end;

var
  Temp: Longint;
begin
  if (not UseRightToLeftAlignment) or (not UseRightToLeft) then
    RTLFactor := 1
  else
    RTLFactor := -1;

  if Visible and CanFocus and TabStop and not (csDesigning in ComponentState) then
    SetFocus;

  CalcDrawInfo(DrawInfo);
  if (ScrollBar = SB_HORZ) and (ColCount = 1) then
  begin
    ModifyPixelScrollBar(ScrollCode, Pos);
    Exit;
  end;
  MaxTopLeft.X := ColCount - 1;
  MaxTopLeft.Y := RowCount - 1;
  MaxTopLeft := CalcMaxTopLeft(MaxTopLeft, DrawInfo);
  NewTopLeft := FTopLeft;
  if ScrollBar = SB_HORZ then
    repeat
      Temp := NewTopLeft.X;
      NewTopLeft.X := CalcScrollBar(NewTopLeft.X, RTLFactor);
    until (NewTopLeft.X <= FixedCols) or (NewTopLeft.X >= MaxTopLeft.X)        
      or (ColWidths[NewTopLeft.X] > 0) or (Temp = NewTopLeft.X)
  else
    repeat
      Temp := NewTopLeft.Y;
      NewTopLeft.Y := CalcScrollBar(NewTopLeft.Y, 1);
    until (NewTopLeft.Y <= FixedRows) or (NewTopLeft.Y >= MaxTopLeft.Y)
      or (RowHeights[NewTopLeft.Y] > 0) or (Temp = NewTopLeft.Y);
  NewTopLeft.X := Math.Max(FixedCols, Math.Min(MaxTopLeft.X, NewTopLeft.X));
  NewTopLeft.Y := Math.Max(FixedRows, Math.Min(MaxTopLeft.Y, NewTopLeft.Y));
  if (NewTopLeft.X <> FTopLeft.X) or (NewTopLeft.Y <> FTopLeft.Y) then
    MoveTopLeft(NewTopLeft.X, NewTopLeft.Y);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveAdjust(var CellPos: Longint; FromIndex, ToIndex: Longint);
var
  Min, Max: Longint;
begin
  if CellPos = FromIndex then CellPos := ToIndex
  else
  begin
    Min := FromIndex;
    Max := ToIndex;
    if FromIndex > ToIndex then
    begin
      Min := ToIndex;
      Max := FromIndex;
    end;
    if (CellPos >= Min) and (CellPos <= Max) then
      if FromIndex > ToIndex then
        Inc(CellPos) else
        Dec(CellPos);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.RefreshCurrentRect;
begin
  if (Cells[FCurrent.X, FCurrent.Y].Unioned) then
    FCurrentRect := Cells[FCurrent.X, FCurrent.Y].GridUnion.UnionRect
  else
  begin
    FCurrentRect.Left   := FCurrent.X;
    FCurrentRect.Top    := FCurrent.Y;
    FCurrentRect.Right  := FCurrent.X;
    FCurrentRect.Bottom := FCurrent.Y;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveCurrent(ACol, ARow: Longint; Show: Boolean);
var
  OldCurrent: TRGridCoord;
  Coord1, Coord2: TRGridCoord;
  GlobalRect, OldCurrentRect, InvalidRange: TRGridRect;
  OldCellIsUnioned, CurCellIsUnioned: Boolean;
  OldCurrentIsTrue, OldCurrentRectIsTrue: Boolean;
begin
  if (ACol < 0) or (ARow < 0) or (ACol >= ColCount) or (ARow >= RowCount) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  //  ,   FCurrent   , 
  //       .  ,   
  //  DoCanFocusCell   ,     
  // FCurrent

  OldCurrent := FCurrent;
  
  if FCurrent.Y >= RowCount then
    FCurrent.Y := RowCount - 1;

  if FCurrent.X >= ColCount then
    FCurrent.X := ColCount - 1;

  if FCurrent.Y < FixedRows then
    FCurrent.Y := FixedRows;

  if FCurrent.X < FixedCols then
    FCurrent.X := FixedCols;
  
  
  DoCanFocusCell(ACol, ARow);  
  //   ???
  if (ACol < 0) or (ARow < 0) or (ACol >= ColCount) or (ARow >= RowCount) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  //    
  FCurrent := OldCurrent;  
    
  //if DoCanFocusCell(ACol, ARow) then
  if (ACol <> FCurrent.X) or (ARow <> FCurrent.Y) then
  begin
    OldCurrent := FCurrent;
    FCurrent.X := ACol;
    FCurrent.Y := ARow;

    OldCurrentRect := FCurrentRect;
    RefreshCurrentRect;

    if (FCurrent.X = OldCurrent.X) and (FCurrent.Y = OldCurrent.Y) then
      OldCurrentIsTrue := False
    else  
      OldCurrentIsTrue := (OldCurrent.X >= FFixedCols) and (OldCurrent.X < FColCount) and (OldCurrent.Y >= FFixedRows) and (OldCurrent.Y < FRowCount);

    if (FCurrentRect.Top = OldCurrentRect.Top) and (FCurrentRect.Left = OldCurrentRect.Left) and (FCurrentRect.Bottom = OldCurrentRect.Bottom) and (FCurrentRect.Right = OldCurrentRect.Right) then
      OldCurrentRectIsTrue := False
    else
    begin  
      Coord1.X := 0;
      Coord1.Y := 0;
      Coord2.X := FColCount - 1;
      Coord2.Y := FRowCount - 1;
      GlobalRect := GridRect(Coord1, Coord2);  
      OldCurrentRectIsTrue := CrossedRects(GlobalRect, OldCurrentRect);

      if (OldCurrentRectIsTrue) then
      begin
        if (OldCurrentRect.Left < 0) then
          OldCurrentRect.Left := 0;
        if (OldCurrentRect.Top < 0) then
          OldCurrentRect.Top := 0;
        if (OldCurrentRect.Right > (FColCount - 1)) then
          OldCurrentRect.Right := FColCount - 1;
        if (OldCurrentRect.Bottom > (FRowCount - 1)) then
          OldCurrentRect.Bottom := FRowCount - 1;
      end;
    end;  

    //OldCurrentIsTrue := False;
    //OldCurrentRectIsTrue := False;


    if (OldCurrentIsTrue) then
      OldCellIsUnioned := Cells[OldCurrent.X, OldCurrent.Y].Unioned
    else
      OldCellIsUnioned := false;

    CurCellIsUnioned := Cells[FCurrent.X, FCurrent.Y].Unioned;

    if ([rgoShowCurCol, rgoShowCurRow] * Options = []) then
    begin
      if OldCurrentRectIsTrue then
        InvalidateRect(OldCurrentRect);

      if Show then
        ClampInView(FCurrent);

      InvalidateRect(FCurrentRect);
    end
    else
    begin
      if rgoShowCurCol in Options then
      begin
        if (OldCellIsUnioned and OldCurrentRectIsTrue) then
        begin
          InvalidRange := OldCurrentRect;
          InvalidRange.Top := 0;
          InvalidRange.Bottom := FTopLeft.Y + VisibleRowCount;
          InvalidateRect(InvalidRange);
        end
        else
        begin
          if (OldCurrentIsTrue) then
            InvalidateCol(OldCurrent.X);
        end;

        if Show then ClampInView(FCurrent);

        if CurCellIsUnioned then
        begin
          InvalidRange := FCurrentRect;
          InvalidRange.Top := 0;
          InvalidRange.Bottom := FTopLeft.Y + VisibleRowCount;
          InvalidateRect(InvalidRange);
        end
        else
          with FCurrent do InvalidateCol(X);
      end;
      if rgoShowCurRow in Options then
      begin
        if (OldCellIsUnioned and OldCurrentRectIsTrue) then
        begin
          InvalidRange := OldCurrentRect;
          InvalidRange.Left := 0;
          InvalidRange.Right := FTopLeft.X + VisibleColCount;
          InvalidateRect(InvalidRange);
        end
        else
        begin
          if (OldCurrentIsTrue) then
            InvalidateRow(OldCurrent.Y);
        end;

        if Show then ClampInView(FCurrent);

        if CurCellIsUnioned then
        begin
          InvalidRange := FCurrentRect;
          InvalidRange.Left := 0;
          InvalidRange.Right := FTopLeft.X + VisibleColCount;
          InvalidateRect(InvalidRange);
        end
        else
          with FCurrent do InvalidateRow(Y);
      end;
    end
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveTopLeft(ALeft, ATop: Longint);
var
  OldTopLeft: TRGridCoord;
begin
  if (ALeft = FTopLeft.X) and (ATop = FTopLeft.Y) then
    Exit;

  Update;

  OldTopLeft := FTopLeft;
  FTopLeft.X := ALeft;
  FTopLeft.Y := ATop;

  TopLeftMoved(OldTopLeft);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ResizeCol(Index: Longint; OldSize, NewSize: Integer);
begin
  InvalidateGrid;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ResizeRow(Index: Longint; OldSize, NewSize: Integer);
begin
  InvalidateGrid;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ScrollDataInfo(DX, DY: Integer;
  var DrawInfo: TRGridDrawInfo);
var
  ScrollArea: TRect;
  ScrollFlags: Integer;
begin
  with DrawInfo do
  begin
    ScrollFlags := SW_INVALIDATE;

    { Scroll the area }
    if (DY = 0) then
    begin
      { Scroll both the column titles and data area at the same time }
      if (not UseRightToLeftAlignment) then
        ScrollArea := Rect(Horz.FixedBoundary, 0, Horz.GridExtent, Vert.GridExtent)
      else
      begin
        ScrollArea := Rect(ClientWidth - Horz.GridExtent, 0, ClientWidth - Horz.FixedBoundary, Vert.GridExtent);
        DX := -DX;
      end;
      ScrollWindowEx(Handle, DX, 0, @ScrollArea, @ScrollArea, 0, nil, ScrollFlags);
    end
    else if (DX = 0) then
    begin
      { Scroll both the row titles and data area at the same time }
      ScrollArea := Rect(0, Vert.FixedBoundary, Horz.GridExtent, Vert.GridExtent);
      ScrollWindowEx(Handle, 0, DY, @ScrollArea, @ScrollArea, 0, nil, ScrollFlags);
    end
    else
    begin
      { Scroll titles and data area separately }
      { Column titles }
      ScrollArea := Rect(Horz.FixedBoundary, 0, Horz.GridExtent, Vert.FixedBoundary);
      ScrollWindowEx(Handle, DX, 0, @ScrollArea, @ScrollArea, 0, nil, ScrollFlags);
      { Row titles }
      ScrollArea := Rect(0, Vert.FixedBoundary, Horz.FixedBoundary, Vert.GridExtent);
      ScrollWindowEx(Handle, 0, DY, @ScrollArea, @ScrollArea, 0, nil, ScrollFlags);
      { Data area }
      ScrollArea := Rect(Horz.FixedBoundary, Vert.FixedBoundary, Horz.GridExtent, Vert.GridExtent);
      ScrollWindowEx(Handle, DX, DY, @ScrollArea, @ScrollArea, 0, nil, ScrollFlags);
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ScrollData(DX, DY: Integer);
var
  DrawInfo: TRGridDrawInfo;
begin
  CalcDrawInfo(DrawInfo);
  ScrollDataInfo(DX, DY, DrawInfo);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.TopLeftMoved(const OldTopLeft: TRGridCoord);

  function CalcScroll(const AxisInfo: TRGridAxisDrawInfo;
    OldPos, CurrentPos: Integer; var Amount: Longint): Boolean;
  var
    Start, Stop: Longint;
    I: Longint;
  begin
    Result := False;
    with AxisInfo do
    begin
      if (OldPos < CurrentPos) then
      begin
        Start := OldPos;
        Stop := CurrentPos;
      end
      else
      begin
        Start := CurrentPos;
        Stop := OldPos;
      end;
      Amount := 0;
      for I := Start to Stop - 1 do
      begin
        Inc(Amount, GetExtent(I) + EffectiveLineWidth);
        if (Amount > (GridBoundary - FixedBoundary)) then
        begin
          { Scroll amount too big, redraw the whole thing }
          InvalidateGrid;
          Exit;
        end;
      end;
      if (OldPos < CurrentPos) then
        Amount := -Amount;
    end;
    Result := True;
  end;

var
  DrawInfo: TRGridDrawInfo;
  Delta: TRGridCoord;
  k{, i}: Longint;
begin
  UpdateScrollPos;
  CalcDrawInfo(DrawInfo);
  if CalcScroll(DrawInfo.Horz, OldTopLeft.X, FTopLeft.X, Delta.X) 
    and CalcScroll(DrawInfo.Vert, OldTopLeft.Y, FTopLeft.Y, Delta.Y) then
  begin  
    ScrollDataInfo(Delta.X, Delta.Y, DrawInfo);

    //   ...
    for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
    begin
      Holder.CellsUnions.Unions[k].Invalidate();
    end;  

    {  
    //      TopLeft
    for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
    begin
      for i := 0 to Holder.CellsUnions.Unions[k].GridUnionsCount - 1 do
      begin
        if ((Delta.Y <> 0) and (FTopLeft.Y >= Holder.CellsUnions.Unions[k].GridUnions[i].FUnionRect.Top) and (FTopLeft.Y <= Holder.CellsUnions.Unions[k].GridUnions[i].FUnionRect.Bottom))
        or ((Delta.X <> 0) and (FTopLeft.X >= Holder.CellsUnions.Unions[k].GridUnions[i].FUnionRect.Left) and (FTopLeft.X <= Holder.CellsUnions.Unions[k].GridUnions[i].FUnionRect.Right))then
        begin
          Holder.CellsUnions.Unions[k].Invalidate();
          Break;
        end;
      end;
    end;
    }
    
  end;
  
    
  TopLeftChanged;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.UpdateScrollPos;
var
  DrawInfo: TRGridDrawInfo;
  MaxTopLeft: TRGridCoord;
  GridSpace, ColWidth: Integer;

  procedure SetScroll(Code: Word; Value: Integer);
  begin
    if UseRightToLeftAlignment and (Code = SB_HORZ) then
      if (ColCount <> 1) then
        Value := RMaxShortInt - Value
      else
        Value := (ColWidth - GridSpace) - Value;

    if (GetScrollPos(Handle, Code) <> Value) then
      SetScrollPos(Handle, Code, Value, True);
  end;

begin
  if (not HandleAllocated) or (ScrollBars = ssNone) then Exit;
  CalcDrawInfo(DrawInfo);
  MaxTopLeft.X := ColCount - 1;
  MaxTopLeft.Y := RowCount - 1;
  MaxTopLeft := CalcMaxTopLeft(MaxTopLeft, DrawInfo);
  if (ScrollBars in [ssHorizontal, ssBoth]) then
    if (ColCount = 1) then
    begin
      ColWidth := ColWidths[DrawInfo.Horz.FirstGridCell];
      GridSpace := ClientWidth - DrawInfo.Horz.FixedBoundary;
      if (FColOffset > 0) and (GridSpace > (ColWidth - FColOffset)) then
        ModifyScrollbar(SB_HORZ, SB_THUMBPOSITION, ColWidth - GridSpace, True)
      else
        SetScroll(SB_HORZ, FColOffset)
    end
    else
      SetScroll(SB_HORZ, LongMulDiv(FTopLeft.X - FixedCols, RMaxShortInt, MaxTopLeft.X - FixedCols));

  if (ScrollBars in [ssVertical, ssBoth]) then
    SetScroll(SB_VERT, LongMulDiv(FTopLeft.Y - FixedRows, RMaxShortInt, MaxTopLeft.Y - FixedRows));
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.UpdateScrollRange;
var
  MaxTopLeft, OldTopLeft: TRGridCoord;
  DrawInfo: TRGridDrawInfo;
  OldScrollBars: TScrollStyle;
  Updated: Boolean;

  procedure DoUpdate;
  begin
    if not Updated then
    begin
      Update;
      Updated := True;
    end;
  end;

  function ScrollBarVisible(Code: Word): Boolean;
  var
    Min, Max: Integer;
  begin
    Result := False;
    if (ScrollBars = ssBoth) 
      or ((Code = SB_HORZ) and (ScrollBars = ssHorizontal))
      or ((Code = SB_VERT) and (ScrollBars = ssVertical)) then
    begin
      GetScrollRange(Handle, Code, Min, Max);
      Result := Min <> Max;
    end;
  end;

  procedure CalcSizeInfo;
  begin
    CalcDrawInfoXY(DrawInfo, DrawInfo.Horz.GridExtent, DrawInfo.Vert.GridExtent);
    MaxTopLeft.X := ColCount - 1;
    MaxTopLeft.Y := RowCount - 1;
    MaxTopLeft := CalcMaxTopLeft(MaxTopLeft, DrawInfo);
  end;

  procedure SetAxisRange(var Max, Old, Current: Longint; Code: Word;
    Fixeds: Integer);
  begin
    CalcSizeInfo;
    if (Fixeds < Max) then
      SetScrollRange(Handle, Code, 0, RMaxShortInt, True)
    else
      SetScrollRange(Handle, Code, 0, 0, True);
    if (Old > Max) then
    begin
      DoUpdate;
      Current := Max;
    end;
  end;

  procedure SetHorzRange;
  var
    Range: Integer;
  begin
    if (OldScrollBars in [ssHorizontal, ssBoth]) then
      if (ColCount = 1) then
      begin
        Range := ColWidths[0] - ClientWidth;
        if (Range < 0) then
          Range := 0;
        SetScrollRange(Handle, SB_HORZ, 0, Range, True);
      end
      else
        SetAxisRange(MaxTopLeft.X, OldTopLeft.X, FTopLeft.X, SB_HORZ, FixedCols);
  end;

  procedure SetVertRange;
  begin
    if (OldScrollBars in [ssVertical, ssBoth]) then
      SetAxisRange(MaxTopLeft.Y, OldTopLeft.Y, FTopLeft.Y, SB_VERT, FixedRows);
  end;

begin
  if (ScrollBars = ssNone) or (not HandleAllocated) or (not Showing) then
    Exit;

  with DrawInfo do
  begin
    Horz.GridExtent := ClientWidth;
    Vert.GridExtent := ClientHeight;
    { Ignore scroll bars for initial calculation }
    if ScrollBarVisible(SB_HORZ) then
      Inc(Vert.GridExtent, GetSystemMetrics(SM_CYHSCROLL));
    if ScrollBarVisible(SB_VERT) then
      Inc(Horz.GridExtent, GetSystemMetrics(SM_CXVSCROLL));
  end;
  OldTopLeft := FTopLeft;
  { Temporarily mark us as not having scroll bars to avoid recursion }
  OldScrollBars := FScrollBars;
  FScrollBars := ssNone;
  Updated := False;
  try
    { Update scrollbars }
    SetHorzRange;
    DrawInfo.Vert.GridExtent := ClientHeight;
    SetVertRange;
    if (DrawInfo.Horz.GridExtent <> ClientWidth) then
    begin
      DrawInfo.Horz.GridExtent := ClientWidth;
      SetHorzRange;
    end;
  finally
    FScrollBars := OldScrollBars;
  end;
  UpdateScrollPos;
  if (FTopLeft.X <> OldTopLeft.X) or (FTopLeft.Y <> OldTopLeft.Y) then
    TopLeftMoved(OldTopLeft);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or WS_TABSTOP;
    if FScrollBars in [ssVertical, ssBoth] then Style := Style or WS_VSCROLL;
    if FScrollBars in [ssHorizontal, ssBoth] then Style := Style or WS_HSCROLL;
    WindowClass.style := CS_DBLCLKS;
    if FBorderStyle = bsSingle then
      if NewStyleControls and Ctl3D then
      begin
        Style := Style and not WS_BORDER;
        ExStyle := ExStyle or WS_EX_CLIENTEDGE;
      end
      else
        Style := Style or WS_BORDER;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.KeyDown(var Key: Word; Shift: TShiftState);
var
  NewTopLeft, NewCurrent, MaxTopLeft: TRGridCoord;
  StartMarking, EndMarking: TRGridCoord;
  TmpValue: Longint;
  KeyEnable: Boolean;
  DrawInfo: TRGridDrawInfo;
  PageWidth, PageHeight: Integer;
  RTLFactor: Integer;
  NeedsInvalidating: Boolean;

type
  TMarkOption = (moFalse, moTrue, moReverse);

  procedure CalcPageExtents;
  begin
    CalcDrawInfo(DrawInfo);
    PageWidth := DrawInfo.Horz.LastFullVisibleCell - LeftCol;
    if PageWidth < 1 then PageWidth := 1;
    PageHeight := DrawInfo.Vert.LastFullVisibleCell - TopRow;
    if PageHeight < 1 then PageHeight := 1;
  end;

  procedure Restrict(var Coord: TRGridCoord; MinX, MinY, MaxX, MaxY: Longint);
  begin
    with Coord do
    begin
      if X > MaxX then X := MaxX
      else if X < MinX then X := MinX;
      if Y > MaxY then Y := MaxY
      else if Y < MinY then Y := MinY;
    end;
  end;

  procedure DoMarking(StartPos, EndPos: TRGridCoord; MarkOption: TMarkOption);
  var
  k, i, m: Longint;
  MarksList: Tlist;
  NeedAdd: Boolean;

  begin
    if rgoColsMarking in FOptions then
    begin
      if (MarkOption = moFalse) then
      begin
        for k := StartPos.X to EndPos.X do
        begin
          Cols[k].Marked := False;
        end;
      end
      else if (MarkOption = moTrue) then
      begin
        for k := StartPos.X to EndPos.X do
        begin
          Cols[k].Marked := True;
        end;
      end
      else if (MarkOption = moReverse) then
      begin
        for k := StartPos.X to EndPos.X do
        begin
          Cols[k].Marked := not Cols[k].Marked;
        end;
      end;
    end
    else if rgoRowsMarking in FOptions then
    begin
      if (MarkOption = moFalse) then
      begin
        for k := StartPos.Y to EndPos.Y do
        begin
          Rows[k].Marked := False;
        end;
      end
      else if (MarkOption = moTrue) then
      begin
        for k := StartPos.Y to EndPos.Y do
        begin
          Rows[k].Marked := True;
        end;
      end
      else if (MarkOption = moReverse) then
      begin
        for k := StartPos.Y to EndPos.Y do
        begin
          Rows[k].Marked := not Rows[k].Marked;
        end;
      end;
    end
    else if rgoCellsMarking in FOptions then
    begin
      MarksList := Tlist.Create();
      MarksList.Clear();

      //   
      for k := StartPos.X to EndPos.X do
      begin
        for i := StartPos.Y to EndPos.Y do
        begin
          if (Cells[k, i].FCellsUnion <> NIL) then
          begin
            // ,     
            NeedAdd := True;
            for m := 0 to MarksList.Count - 1 do
            begin
              if (TRCell(MarksList[m]).FCellsUnion = Cells[k, i].FCellsUnion) then
              begin
                NeedAdd := False;
                Break;
              end;
            end;

            if NeedAdd then
              MarksList.Add(Cells[k, i]);
          end
          else
            MarksList.Add(Cells[k, i]);
        end;
      end;

      if (MarkOption = moFalse) then
      begin
        for m := 0 to MarksList.Count - 1 do
        begin
          Holder.Cells[TRCell(MarksList[m]).HolderCol, TRCell(MarksList[m]).HolderRow].Marked := False;
        end;
      end
      else if (MarkOption = moTrue) then
      begin
        for m := 0 to MarksList.Count - 1 do
        begin
          Holder.Cells[TRCell(MarksList[m]).HolderCol, TRCell(MarksList[m]).HolderRow].Marked := True;
        end;
      end
      else if (MarkOption = moReverse) then
      begin
        for m := 0 to MarksList.Count - 1 do
        begin
          Holder.Cells[TRCell(MarksList[m]).HolderCol, TRCell(MarksList[m]).HolderRow].Marked := not Holder.Cells[TRCell(MarksList[m]).HolderCol, TRCell(MarksList[m]).HolderRow].Marked;
        end;
      end;
    end;
  end;

begin
  inherited KeyDown(Key, Shift);
  NeedsInvalidating := False;
  if not CanGridAcceptKey(Key, Shift) then
    Key := 0;

  if not UseRightToLeftAlignment then
    RTLFactor := 1
  else
    RTLFactor := -1;

  NewCurrent := FCurrent;
  NewTopLeft := FTopLeft;
  StartMarking := FCurrent;
  //EndMarking := FCurrent;
  KeyEnable := False;

  CalcPageExtents;

  if ssCtrl in Shift then
    case Key of
      VK_UP:
        begin
          Dec(NewTopLeft.Y);
        end;

      VK_DOWN:
        begin
          Inc(NewTopLeft.Y);
        end;

      VK_LEFT:
        begin
          Dec(NewCurrent.X, PageWidth * RTLFactor);
          Dec(NewTopLeft.X, PageWidth * RTLFactor);
        end;

      VK_RIGHT:
        begin
          Inc(NewCurrent.X, PageWidth * RTLFactor);
          Inc(NewTopLeft.X, PageWidth * RTLFactor);
        end;

      VK_PRIOR:
        NewCurrent.Y := TopRow;

      VK_NEXT:
        NewCurrent.Y := DrawInfo.Vert.LastFullVisibleCell;

      VK_HOME:
        begin
          NewCurrent.X := FixedCols;
          NewCurrent.Y := FixedRows;
          NeedsInvalidating := UseRightToLeftAlignment;
        end;

      VK_END:
        begin
          NewCurrent.X := ColCount - 1;
          NewCurrent.Y := RowCount - 1;
          NeedsInvalidating := UseRightToLeftAlignment;
        end;
    end
  else
    case Key of
      VK_UP:
      begin
        if FCurrentRect.Top <> FCurrentRect.Bottom then
        begin
          StartMarking.Y := FCurrentRect.Top;
          NewCurrent.Y := FCurrentRect.Top - 1;
        end
        else
          Dec(NewCurrent.Y);

        KeyEnable := True;
      end;

      VK_DOWN:
      begin
        if FCurrentRect.Top <> FCurrentRect.Bottom then
        begin
          StartMarking.Y := FCurrentRect.Bottom;
          NewCurrent.Y := FCurrentRect.Bottom + 1;
        end
        else
          Inc(NewCurrent.Y);

        KeyEnable := True;
      end;

      VK_LEFT:
      begin
        if FCurrentRect.Left <> FCurrentRect.Right then
        begin
          StartMarking.X := FCurrentRect.Left;
          NewCurrent.X := FCurrentRect.Left - 1;
        end
        else
          Dec(NewCurrent.X, RTLFactor);

        KeyEnable := True;
      end;

      VK_RIGHT:
      begin
        if FCurrentRect.Left <> FCurrentRect.Right then
        begin
          StartMarking.X := FCurrentRect.Left;
          NewCurrent.X := FCurrentRect.Right + 1;
        end
        else
          Inc(NewCurrent.X, RTLFactor);

        KeyEnable := True;
      end;

      VK_NEXT:
      begin
        Inc(NewCurrent.Y, PageHeight);
        Inc(NewTopLeft.Y, PageHeight);
        KeyEnable := True;
      end;

      VK_PRIOR:
      begin
        Dec(NewCurrent.Y, PageHeight);
        Dec(NewTopLeft.Y, PageHeight);
        KeyEnable := True;
      end;

      VK_HOME:
      begin
        NewCurrent.X := FixedCols;

        if rgoCellsMarking in FOptions then
          KeyEnable := True;
      end;

      VK_END:
      begin
        NewCurrent.X := ColCount - 1;

        if rgoCellsMarking in FOptions then
          KeyEnable := True;
      end;

      VK_TAB:
        if not (ssAlt in Shift) then
        begin
          if ssShift in Shift then
          begin
            if FCurrentRect.Left <> FCurrentRect.Right then
              NewCurrent.X := FCurrentRect.Left - 1
            else
              Dec(NewCurrent.X);
            if NewCurrent.X < FixedCols then
            begin
              NewCurrent.X := ColCount - 1;

              if FCurrentRect.Top <> FCurrentRect.Bottom then
                NewCurrent.Y := FCurrentRect.Top - 1
              else
               Dec(NewCurrent.Y);

              if NewCurrent.Y < FixedRows then
                NewCurrent.Y := RowCount - 1;
            end;
            Shift := [];
          end
          else
          begin
            if FCurrentRect.Left <> FCurrentRect.Right then
              NewCurrent.X := FCurrentRect.Right + 1
            else
              Inc(NewCurrent.X);

            if NewCurrent.X >= ColCount then
            begin
              NewCurrent.X := FixedCols;
              if FCurrentRect.Top <> FCurrentRect.Bottom then
                NewCurrent.Y := FCurrentRect.Bottom + 1
              else
                Inc(NewCurrent.Y);

              if NewCurrent.Y >= RowCount then
                NewCurrent.Y := FixedRows;
            end;
          end;
        end;

      VK_SPACE:
      begin
        EndMarking := FCurrent;
        DoMarking(StartMarking, EndMarking, moReverse);
      end;

      VK_INSERT:
      begin
        EndMarking := FCurrent;
        DoMarking(StartMarking, EndMarking, moReverse);
        Inc(NewCurrent.Y);
      end;

      VK_MULTIPLY:
      begin
        StartMarking.X := FixedCols;
        StartMarking.Y := FixedRows;

        EndMarking.X := ColCount - 1;
        EndMarking.Y := RowCount - 1;

        DoMarking(StartMarking, EndMarking, moReverse);
      end;

      VK_ADD:
      begin
        StartMarking.X := FixedCols;
        StartMarking.Y := FixedRows;

        EndMarking.X := ColCount - 1;
        EndMarking.Y := RowCount - 1;

        DoMarking(StartMarking, EndMarking, moTrue);
      end;

      VK_SUBTRACT:
      begin
        StartMarking.X := FixedCols;
        StartMarking.Y := FixedRows;

        EndMarking.X := ColCount - 1;
        EndMarking.Y := RowCount - 1;

        DoMarking(StartMarking, EndMarking, moFalse);
      end;

      //!!! VK_F2: EditorMode := True;
    end;

  if (ssShift in Shift)  and KeyEnable and (rgoCellsMarking in FOptions) then
  begin
    if (not FKeyboardMarkRange) then
    begin
      FKeyboardMarkRange := True;

      Holder.CellsUnions.StoreMarkStatuses();

      if rgoColsMarking in FOptions then
        Cols[FCurrent.X].Marked := not Cols[FCurrent.X].Marked
      else if rgoRowsMarking in FOptions then
        Rows[FCurrent.Y].Marked := not Rows[FCurrent.Y].Marked
      else if rgoCellsMarking in FOptions then
      begin
        if Cells[FCurrent.X, FCurrent.Y].Unioned then
          Cells[FCurrent.X, FCurrent.Y].CellsUnion.Marked := not Cells[FCurrent.X, FCurrent.Y].CellsUnion.Marked
        else
          Cells[FCurrent.X, FCurrent.Y].Marked := not Cells[FCurrent.X, FCurrent.Y].Marked;
      end;

      FMarkingAnchor := FCurrent;
      FOldMarkingEnd := FCurrent;
    end;
  end
  else
    FKeyboardMarkRange := False;

  MaxTopLeft.X := ColCount - 1;
  MaxTopLeft.Y := RowCount - 1;
  MaxTopLeft := CalcMaxTopLeft(MaxTopLeft, DrawInfo);

  

  Restrict(NewTopLeft, FixedCols, FixedRows, MaxTopLeft.X, MaxTopLeft.Y);

  if (NewTopLeft.X <> LeftCol) or (NewTopLeft.Y <> TopRow) then
    MoveTopLeft(NewTopLeft.X, NewTopLeft.Y);

  Restrict(NewCurrent, FixedCols, FixedRows, ColCount - 1, RowCount - 1);

  if (NewCurrent.X <> Col) or (NewCurrent.Y <> Row) then
    FocusCell(NewCurrent.X, NewCurrent.Y, true);

  if NeedsInvalidating then
    Invalidate;

  if KeyEnable then
  begin
    if ((ssShift in Shift) and (not (rgoCellsMarking in FOptions))) 
      or ((ssAlt in Shift) and (rgoCellsMarking in FOptions))
    then
    begin
      EndMarking := FCurrent;

      if (StartMarking.X < EndMarking.X) then
      begin
        if FCurrentRect.Left <> FCurrentRect.Right then
          EndMarking.X := FCurrentRect.Left - 1
        else
          Dec(EndMarking.X);
      end
      else if (StartMarking.X > EndMarking.X) then
      begin
        if FCurrentRect.Left <> FCurrentRect.Right then
          EndMarking.X := FCurrentRect.Right + 1
        else
          Inc(EndMarking.X);

        TmpValue := StartMarking.X;
        StartMarking.X := EndMarking.X;
        EndMarking.X := TmpValue;    
      end;

      if (StartMarking.Y < EndMarking.Y) then
      begin
        if FCurrentRect.Top <> FCurrentRect.Bottom then
          EndMarking.Y := FCurrentRect.Top - 1
        else
        Dec(EndMarking.Y);
      end
      else if (StartMarking.Y > EndMarking.Y) then
      begin
        if FCurrentRect.Top <> FCurrentRect.Bottom then
          EndMarking.Y := FCurrentRect.Bottom + 1
        else
          Inc(EndMarking.Y);

        TmpValue := StartMarking.Y;
        StartMarking.Y := EndMarking.Y;
        EndMarking.Y := TmpValue;
      end;

      DoMarking(StartMarking, EndMarking, moReverse);
    end
    else if ({ssAlt}ssShift in Shift) and (rgoCellsMarking in FOptions) then
    begin
      ChangeMarkRange;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);

end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.KeyUp(var Key: Word; Shift: TShiftState);
begin
  if not (ssShift in Shift) then
  begin
    FKeyboardMarkRange := False;
  end;

  inherited KeyUp(Key, Shift);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.StopTracking;
begin
  if FTracking then begin
    TrackButton(-1, -1);
    FTracking := False;
    MouseCapture := False;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.TrackButton(X, Y: Integer);
var
  Cell: TRGridCoord;
  GridUnionRect: TRGridRect;
  NewPressed: Boolean;
begin
  Cell := MouseCoord(X, Y);

  if (Cells[FPressedCell.X, FPressedCell.Y].Unioned) then
    GridUnionRect := Cells[FPressedCell.X, FPressedCell.Y].GridUnion.UnionRect
  else
  begin
    GridUnionRect.Left   := FPressedCell.X;
    GridUnionRect.Top    := FPressedCell.Y;
    GridUnionRect.Right  := FPressedCell.X;
    GridUnionRect.Bottom := FPressedCell.Y;
  end;

  NewPressed := PtInRect(Rect(0, 0, ClientWidth, ClientHeight), Point(X, Y))
    and PointInGridRect(Cell.X, Cell.Y, GridUnionRect);

  if FPressed <> NewPressed then
  begin
    FPressed := NewPressed;
    InvalidateCell(FPressedCell.X, FPressedCell.Y);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoFixedCellClick(ACol, ARow: Longint);
begin
  if Assigned(FOnFixedCellClick) then
  begin
    if (Cells[ACol, ARow].BelongsToUnion) then
    begin
      FOnFixedCellClick(Self, Cells[ACol, ARow].CellsUnion.MainCell, ACol, ARow);
    end
    else
    begin
      FOnFixedCellClick(Self, Cells[ACol, ARow], ACol, ARow);
    end;  
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CheckFixedCellButton(ACol, ARow: Longint; var Enabled: Boolean);
begin
  if (ACol >= 0) and (ARow >= 0) and ((ACol < FixedCols) or (ARow < FixedRows)) then
  begin
    if Assigned(FOnCheckButton) then
    begin
      if (Cells[ACol, ARow].BelongsToUnion) then
      begin
        FOnCheckButton(Self, Cells[ACol, ARow].CellsUnion.MainCell, ACol, ARow, Enabled);
      end
      else
      begin  
        FOnCheckButton(Self, Cells[ACol, ARow], ACol, ARow, Enabled);
      end;
    end;  
  end
  else
    Enabled := False;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  CellHit: TRGridCoord;
  DrawInfo: TRGridDrawInfo;
  MoveDrawn, Fixed, EnableClick: Boolean;
begin
  MoveDrawn := False;

  if not (csDesigning in ComponentState) and
    (CanFocus or (GetParentForm(Self) = nil)) then
  begin
    SetFocus;
    if not IsActiveControl then
    begin
      MouseCapture := False;
      Exit;
    end;
  end;
  if (Button = mbLeft) and (ssDouble in Shift) then
  begin
    if (rgoSupportFixedButtons in Options) then
    begin
      CalcDrawInfo(DrawInfo);
      CellHit := CalcCoordFromPoint(X, Y, DrawInfo);
      if not ((CellHit.X >= 0) and (CellHit.X < FixedCols)) and not ((CellHit.Y >= 0) and (CellHit.Y < FixedRows)) then
      begin
        DblClick;
      end;
    end
    else
    begin
      DblClick;
    end;
  end
  else if Button = mbLeft then
  begin
    CalcDrawInfo(DrawInfo);
    //Check grid sizing
    CalcSizingState(X, Y, FGridState, FSizingIndex, FSizingPos, FSizingOfs, DrawInfo);

    if FGridState <> rgsNormal then
    begin
      if (FGridState = rgsColSizing) and UseRightToLeftAlignment then
        FSizingPos := ClientWidth - FSizingPos;
      DrawSizingLine(DrawInfo);
      Exit;
    end;
    CellHit := CalcCoordFromPoint(X, Y, DrawInfo);
    Fixed := ((CellHit.X >= 0) and (CellHit.X < FixedCols)) or ((CellHit.Y >= 0) and (CellHit.Y < FixedRows));

    if Fixed then
    begin
      if (rgoSupportFixedButtons in Options) and Fixed and (not (csDesigning in ComponentState)) then
      begin
        EnableClick := True;
        CheckFixedCellButton(CellHit.X, CellHit.Y, EnableClick);
        if EnableClick then begin
          MouseCapture := True;
          FTracking := True;
          FPressedCell := CellHit;
          TrackButton(X, Y);
        end
        else
          Beep;
      end;
    end
    else
    begin
      if (CellHit.X >= FixedCols) and (CellHit.Y >= FixedRows) then
      begin
        SetTimer(Handle, 1, 60, nil);

        if not (ssShift in Shift) then
        begin
          FGridState := rgsFocusMoving;
          MoveCurrent(CellHit.X, CellHit.Y, True);
        end
        else
        begin
          FGridState := rgsRangeMarking;
          Holder.CellsUnions.StoreMarkStatuses();

          MoveCurrent(CellHit.X, CellHit.Y, True);

          if rgoColsMarking in FOptions then
            Cols[FCurrent.X].Marked := not Cols[FCurrent.X].Marked
          else if rgoRowsMarking in FOptions then
            Rows[FCurrent.Y].Marked := not Rows[FCurrent.Y].Marked
          else if rgoCellsMarking in FOptions then
          begin
            if Cells[FCurrent.X, FCurrent.Y].Unioned then
              Cells[FCurrent.X, FCurrent.Y].CellsUnion.Marked := not Cells[FCurrent.X, FCurrent.Y].CellsUnion.Marked
            else
              Cells[FCurrent.X, FCurrent.Y].Marked := not Cells[FCurrent.X, FCurrent.Y].Marked;
          end;

          FMarkingAnchor := FCurrent;
          FOldMarkingEnd := FCurrent;
        end;


        //MoveCurrent(CellHit.X, CellHit.Y, True);
      end;
    end;
  end    
  else if Button = mbRight then
  begin

    CalcDrawInfo(DrawInfo);
    CellHit := CalcCoordFromPoint(X, Y, DrawInfo);
  
    if (rgoRowMoving in Options) and (CellHit.X >= 0) and
      (CellHit.X < FixedCols) and (CellHit.Y >= FixedRows) then
    begin
      FMoveIndex := CellHit.Y;
      FMovePos := FMoveIndex;
      if BeginRowDrag(FMoveIndex, FMovePos, Point(X,Y)) then
      begin
        FGridState := rgsRowMoving;
        Update;
        DrawMove;
        MoveDrawn := True;
        SetTimer(Handle, 1, 60, nil);
        MouseCapture := True;
      end;
    end
    else if (rgoColMoving in Options) and (CellHit.Y >= 0) and
      (CellHit.Y < FixedRows) and (CellHit.X >= FixedCols) then
    begin
      FMoveIndex := CellHit.X;
      FMovePos := FMoveIndex;
      if BeginColumnDrag(FMoveIndex, FMovePos, Point(X,Y)) then
      begin
        FGridState := rgsColMoving;
        Update;
        DrawMove;
        MoveDrawn := True;
        SetTimer(Handle, 1, 60, nil);
        MouseCapture := True;
      end;
    end;
  end;

  try
    inherited MouseDown(Button, Shift, X, Y);
  except
    if MoveDrawn then DrawMove;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  DrawInfo: TRGridDrawInfo;
  CellHit{, OldMarkingEnd}: TRGridCoord;
begin
  if FTracking then
    TrackButton(X, Y);

  CalcDrawInfo(DrawInfo);

  case FGridState of
    rgsColMoving, rgsRowMoving, rgsFocusMoving, rgsRangeMarking:
      begin
        CellHit := CalcCoordFromPoint(X, Y, DrawInfo);
        if (CellHit.X >= FixedCols) and (CellHit.Y >= FixedRows) and
          (CellHit.X <= DrawInfo.Horz.LastFullVisibleCell+1) and
          (CellHit.Y <= DrawInfo.Vert.LastFullVisibleCell+1) then
          case FGridState of
            rgsFocusMoving:
              if ((CellHit.X <> FCurrent.X) or (CellHit.Y <> FCurrent.Y)) then
                MoveCurrent(CellHit.X, CellHit.Y, True);

            rgsRangeMarking:
              if ((CellHit.X <> FCurrent.X) or (CellHit.Y <> FCurrent.Y)) then
              begin
                MoveCurrent(CellHit.X, CellHit.Y, True);
                ChangeMarkRange;
              end;

            rgsColMoving:
              MoveAndScroll(X, CellHit.X, DrawInfo, DrawInfo.Horz, SB_HORZ, Point(X,Y));

            rgsRowMoving:
              MoveAndScroll(Y, CellHit.Y, DrawInfo, DrawInfo.Vert, SB_VERT, Point(X,Y));
          end;
      end;
    rgsRowSizing, rgsColSizing:
      begin
        DrawSizingLine(DrawInfo); { XOR it out }

        if FGridState = rgsRowSizing then
          FSizingPos := Y + FSizingOfs
        else
          FSizingPos := X + FSizingOfs;

        DrawSizingLine(DrawInfo); { XOR it back in }
      end;
  end;
  inherited MouseMove(Shift, X, Y);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  DrawInfo: TRGridDrawInfo;
  NewSize: Integer;

  Cell: TRGridCoord;
  ACol, ARow: Longint;
  DoClick: Boolean;

  function ResizeLine(const AxisInfo: TRGridAxisDrawInfo): Integer;
  var
    I: Integer;
  begin
    with AxisInfo do
    begin
      Result := FixedBoundary;
      for I := FirstGridCell to FSizingIndex - 1 do
        Inc(Result, GetExtent(I) + EffectiveLineWidth);
      Result := FSizingPos - Result;
    end;
  end;

begin
  if FTracking and (FPressedCell.Y >= 0) and (FPressedCell.X >= 0) then
  begin
    Cell := MouseCoord(X, Y);
    DoClick := PtInRect(Rect(0, 0, ClientWidth, ClientHeight), Point(X, Y))
      and (Cell.Y = FPressedCell.Y) and (Cell.X = FPressedCell.X);
    StopTracking;
    if DoClick then begin
      ACol := Cell.X;
      ARow := Cell.Y;
      if (ARow < RowCount) and (ACol < ColCount) then
        DoFixedCellClick(ACol, ARow);
    end;
  end;

  try
    case FGridState of
      rgsFocusMoving:
      begin
        MouseMove(Shift, X, Y);
        KillTimer(Handle, 1);
        Click;
      end;

      rgsRangeMarking:
      begin
        MouseMove(Shift, X, Y);
        KillTimer(Handle, 1);
        //MouseCapture := False;
        Click;
      end;

      rgsRowSizing, rgsColSizing:
      begin
        CalcDrawInfo(DrawInfo);
        DrawSizingLine(DrawInfo);
        if (FGridState = rgsColSizing) and UseRightToLeftAlignment then
          FSizingPos := ClientWidth - FSizingPos;
        if FGridState = rgsColSizing then
        begin
          NewSize := ResizeLine(DrawInfo.Horz);
          if NewSize > 1 then
          begin
            ColWidths[FSizingIndex] := NewSize;
            UpdateDesigner;
          end;
        end
        else
        begin
          NewSize := ResizeLine(DrawInfo.Vert);
          if NewSize > 1 then
          begin
            RowHeights[FSizingIndex] := NewSize;
            UpdateDesigner;
          end;
        end;
      end;

      rgsColMoving:
      begin
        DrawMove;
        KillTimer(Handle, 1);
        if EndColumnDrag(FMoveIndex, FMovePos, Point(X,Y))
          and (FMoveIndex <> FMovePos) then
        begin
          MoveColumn(FMoveIndex, FMovePos);
          UpdateDesigner;
        end;
        //UpdateEdit;
        MouseCapture := False;
      end;

      rgsRowMoving:
      begin
        DrawMove;
        KillTimer(Handle, 1);
        if EndRowDrag(FMoveIndex, FMovePos, Point(X,Y))
          and (FMoveIndex <> FMovePos) then
        begin
          MoveRow(FMoveIndex, FMovePos);
          UpdateDesigner;
        end;
        MouseCapture := False;
      end;

    end;
    inherited MouseUp(Button, Shift, X, Y);
  finally
    FGridState := rgsNormal;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ChangeMarkRange;
var
StartPos, EndPos: TRGridCoord;
k, i: LongInt;
InsideXRange, InsideYRange, OutsideXRange, OutsideYRange: Boolean;
MarkRect, CurRect: TRGridRect;
InsideMarkRect: Boolean;


  procedure ReverceCellMarking(ACol, ARow: Longint);
  begin
    if (Cells[ACol, ARow].CellsUnion = NIL) then
      Cells[k, i].Marked := not Cells[k, i].Marked;
  end;

begin
  if (rgoColsMarking in FOptions) then
  begin
    if (FCurrent.X <> FOldMarkingEnd.X) then
    begin
      if ((FCurrent.X > FMarkingAnchor.X) and (FCurrent.X > FOldMarkingEnd.X))
        or ((FCurrent.X < FMarkingAnchor.X) and (FCurrent.X < FOldMarkingEnd.X)) then
        InsideXRange := False
      else
        InsideXRange := TRue;

      if (FOldMarkingEnd.X < FCurrent.X) then
      begin
        if InsideXRange then
        begin
          StartPos.X := FOldMarkingEnd.X;
          EndPos.X   := FCurrent.X - 1;
        end
        else
        begin
          StartPos.X := FOldMarkingEnd.X + 1;
          EndPos.X   := FCurrent.X;
        end;
      end
      else if (FOldMarkingEnd.X > FCurrent.X) then
      begin
        if InsideXRange then
        begin
          StartPos.X := FCurrent.X + 1;
          EndPos.X   := FOldMarkingEnd.X;
        end
        else
        begin
          StartPos.X := FCurrent.X;
          EndPos.X   := FOldMarkingEnd.X - 1;
        end;
      end;

      for k := StartPos.X to EndPos.X do
      begin
        if (k <> FMarkingAnchor.X) then
        begin
          Cols[k].Marked := not Cols[k].Marked;
        end;
      end;

      FOldMarkingEnd := FCurrent;
    end;
  end
  else if (rgoRowsMarking in FOptions) then
  begin
    if (FCurrent.Y <> FOldMarkingEnd.Y) then
    begin
      if ((FCurrent.Y > FMarkingAnchor.Y) and (FCurrent.Y > FOldMarkingEnd.Y))
        or ((FCurrent.Y < FMarkingAnchor.Y) and (FCurrent.Y < FOldMarkingEnd.Y)) then
        InsideYRange := False
      else
        InsideYRange := TRue;

      if (FOldMarkingEnd.Y < FCurrent.Y) then
      begin
        if InsideYRange then
        begin
          StartPos.Y := FOldMarkingEnd.Y;
          EndPos.Y   := FCurrent.Y - 1;
        end
        else
        begin
          StartPos.Y := FOldMarkingEnd.Y + 1;
          EndPos.Y   := FCurrent.Y;
        end;
      end
      else if (FOldMarkingEnd.Y > FCurrent.Y) then
      begin
        if InsideYRange then
        begin
          StartPos.Y := FCurrent.Y + 1;
          EndPos.Y   := FOldMarkingEnd.Y;
        end
        else
        begin
          StartPos.Y := FCurrent.Y;
          EndPos.Y   := FOldMarkingEnd.Y - 1;
        end;
      end;

      for k := StartPos.Y to EndPos.Y do
      begin
        if (k <> FMarkingAnchor.Y) then
        begin
          Rows[k].Marked := not Rows[k].Marked;
        end;
      end;

      FOldMarkingEnd := FCurrent;
    end;
  end
  else if (rgoCellsMarking in FOptions) then
  begin
    //  4 
    if (FCurrent.X <> FOldMarkingEnd.X) or (FCurrent.Y <> FOldMarkingEnd.Y) then
    begin
      OutsideXRange := ((FOldMarkingEnd.X > FCurrent.X) and (FOldMarkingEnd.X > FMarkingAnchor.X))
        or ((FOldMarkingEnd.X < FCurrent.X) and (FOldMarkingEnd.X < FMarkingAnchor.X));
      OutsideYRange := ((FOldMarkingEnd.Y > FCurrent.Y) and (FOldMarkingEnd.Y > FMarkingAnchor.Y))
        or ((FOldMarkingEnd.Y < FCurrent.Y) and (FOldMarkingEnd.Y < FMarkingAnchor.Y));

      begin
        //1.   X
        if OutsideXRange then
        begin
          StartPos.X := Min(FMarkingAnchor.X, FOldMarkingEnd.X);
          EndPos.X   := Max(FMarkingAnchor.X, FOldMarkingEnd.X);

          if (StartPos.X = FMarkingAnchor.X) then
            Inc(StartPos.X)
          else
            Dec(EndPos.X);

          StartPos.Y := Min(FMarkingAnchor.Y, FOldMarkingEnd.Y);
          EndPos.Y   := Max(FMarkingAnchor.Y, FOldMarkingEnd.Y);

          for k := StartPos.X to EndPos.X do
          begin
            for i := StartPos.Y to EndPos.Y do
            begin
              ReverceCellMarking(k, i);

            end;
          end;

          FOldMarkingEnd.X := FMarkingAnchor.X;
        end;

        //2.   Y
        if OutsideYRange then
        begin
          //   StartPos.X  EndPos.X     FMarkingAnchor.X ...
          StartPos.X := Min(FMarkingAnchor.X, FOldMarkingEnd.X);
          EndPos.X   := Max(FMarkingAnchor.X, FOldMarkingEnd.X);

          StartPos.Y := Min(FMarkingAnchor.Y, FOldMarkingEnd.Y);
          EndPos.Y   := Max(FMarkingAnchor.Y, FOldMarkingEnd.Y);

          if (StartPos.Y = FMarkingAnchor.Y) then
            Inc(StartPos.Y)
          else
            Dec(EndPos.Y);

          for k := StartPos.X to EndPos.X do
          begin
            for i := StartPos.Y to EndPos.Y do
            begin
              ReverceCellMarking(k, i);

            end;
          end;

          FOldMarkingEnd.Y := FMarkingAnchor.Y;
        end;
      end;

      //3.   X
      if (FCurrent.X <> FOldMarkingEnd.X) then
      begin
        if ((FCurrent.X > FMarkingAnchor.X) and (FCurrent.X > FOldMarkingEnd.X))
          or ((FCurrent.X < FMarkingAnchor.X) and (FCurrent.X < FOldMarkingEnd.X)) then
          InsideXRange := False
        else
          InsideXRange := TRue;

        if (FOldMarkingEnd.X < FCurrent.X) then
        begin
          if InsideXRange then
          begin
            StartPos.X := FOldMarkingEnd.X;
            EndPos.X   := FCurrent.X - 1;
          end
          else
          begin
            StartPos.X := FOldMarkingEnd.X + 1;
            EndPos.X   := FCurrent.X;
          end;
        end
        else if (FOldMarkingEnd.X > FCurrent.X) then
        begin
          if InsideXRange then
          begin
            StartPos.X := FCurrent.X + 1;
            EndPos.X   := FOldMarkingEnd.X;
          end
          else
          begin
            StartPos.X := FCurrent.X;
            EndPos.X   := FOldMarkingEnd.X - 1;
          end;
        end;

        StartPos.Y := Min(FMarkingAnchor.Y, FOldMarkingEnd.Y);
        EndPos.Y   := Max(FMarkingAnchor.Y, FOldMarkingEnd.Y);

        for k := StartPos.X to EndPos.X do
        begin
          for i := StartPos.Y to EndPos.Y do
          begin
            ReverceCellMarking(k, i);

          end;
        end;

        FOldMarkingEnd.X := FCurrent.X;
      end;

      //4.   Y
      if (FCurrent.Y <> FOldMarkingEnd.Y) then
      begin
        if ((FCurrent.Y > FMarkingAnchor.Y) and (FCurrent.Y > FOldMarkingEnd.Y))
          or ((FCurrent.Y < FMarkingAnchor.Y) and (FCurrent.Y < FOldMarkingEnd.Y)) then
          InsideYRange := False
        else
          InsideYRange := TRue;

        if (FOldMarkingEnd.Y < FCurrent.Y) then
        begin
          if InsideYRange then
          begin
            StartPos.Y := FOldMarkingEnd.Y;
            EndPos.Y   := FCurrent.Y - 1;
          end
          else
          begin
            StartPos.Y := FOldMarkingEnd.Y + 1;
            EndPos.Y   := FCurrent.Y;
          end;
        end
        else if (FOldMarkingEnd.Y > FCurrent.Y) then
        begin
          if InsideYRange then
          begin
            StartPos.Y := FCurrent.Y + 1;
            EndPos.Y   := FOldMarkingEnd.Y;
          end
          else
          begin
            StartPos.Y := FCurrent.Y;
            EndPos.Y   := FOldMarkingEnd.Y - 1;
          end;
        end;

        StartPos.X := Min(FMarkingAnchor.X, FOldMarkingEnd.X);
        EndPos.X   := Max(FMarkingAnchor.X, FOldMarkingEnd.X);

        for k := StartPos.X to EndPos.X do
        begin
          for i := StartPos.Y to EndPos.Y do
          begin
            ReverceCellMarking(k, i);

          end;
        end;
      end;

      FOldMarkingEnd := FCurrent;
    end;

    //   
    MarkRect := GridRect(FMarkingAnchor, FCurrent);
    for k := 0 to Holder.CellsUnions.UnionsCount - 1 do
    begin
      InsideMarkRect := False;
      for i := 0 to Holder.CellsUnions.Unions[k].CellsCount - 1 do
      begin
        if (Holder.CellsUnions.Unions[k].Cells[i].GridCol >= FFixedCols)
          and (Holder.CellsUnions.Unions[k].Cells[i].GridRow >= FFixedRows) then
        begin
          CurRect.Left := Holder.CellsUnions.Unions[k].Cells[i].GridCol;
          CurRect.Right := Holder.CellsUnions.Unions[k].Cells[i].GridCol;
          CurRect.Top := Holder.CellsUnions.Unions[k].Cells[i].GridRow;
          CurRect.Bottom := Holder.CellsUnions.Unions[k].Cells[i].GridRow;
          if CrossedRects(MarkRect, CurRect) then
          begin
            InsideMarkRect := True;
            Break;
          end;
        end;
      end;
      if InsideMarkRect then
        Holder.CellsUnions.Unions[k].Marked := not Holder.CellsUnions.Unions[k].FMarkStatus
      else
        Holder.CellsUnions.Unions[k].Marked := Holder.CellsUnions.Unions[k].FMarkStatus;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMLButtonDblClk(var Message: TWMLButtonDblClk);
var
  Cell: TRGridCoord;

begin
  if (rgoSupportFixedButtons in Options) then
  begin
    with Message do
    begin
      Cell := MouseCoord(XPos, YPos);
      if ((Cell.X >= 0) and (Cell.X < FixedCols)) or ((Cell.Y >= 0) and (Cell.Y < FixedRows)) then
      begin
        SendCancelMode(Self);

        if csCaptureMouse in ControlStyle then MouseCapture := True;

        if not (csNoStdEvents in ControlStyle) then
        begin
          with Message do
            MouseDown(mbLeft, KeysToShiftState(Keys) - [ssDouble], XPos, YPos);
        end;
        Exit;
      end;
    end;
  end;
  
  inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MoveAndScroll(Mouse, CellHit: Integer;
  var DrawInfo: TRGridDrawInfo; var Axis: TRGridAxisDrawInfo;
  ScrollBar: Integer; const MousePt: TPoint);
begin
  if UseRightToLeftAlignment and (ScrollBar = SB_HORZ) then
    Mouse := ClientWidth - Mouse;
  if (CellHit <> FMovePos) and
    not((FMovePos = Axis.FixedCellCount) and (Mouse < Axis.FixedBoundary)) and
    not((FMovePos = Axis.GridCellCount-1) and (Mouse > Axis.GridBoundary)) then
  begin
    DrawMove;   // hide the drag line
    if (Mouse < Axis.FixedBoundary) then
    begin
      if (FMovePos > Axis.FixedCellCount) then
      begin
        ModifyScrollbar(ScrollBar, SB_LINEUP, 0, False);
        Update;
        CalcDrawInfo(DrawInfo);    // this changes contents of Axis var
      end;
      CellHit := Axis.FirstGridCell;
    end
    else if (Mouse >= Axis.FullVisBoundary) then
    begin
      if (FMovePos = Axis.LastFullVisibleCell) and
        (FMovePos < Axis.GridCellCount -1) then
      begin
        ModifyScrollBar(Scrollbar, SB_LINEDOWN, 0, False);
        Update;
        CalcDrawInfo(DrawInfo);    // this changes contents of Axis var
      end;
      CellHit := Axis.LastFullVisibleCell;
    end
    else if CellHit < 0 then CellHit := FMovePos;
    if ((FGridState = rgsColMoving) and CheckColumnDrag(FMoveIndex, CellHit, MousePt))
      or ((FGridState = rgsRowMoving) and CheckRowDrag(FMoveIndex, CellHit, MousePt)) then
      FMovePos := CellHit;
    DrawMove;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetGridWidth: Integer;
var
  DrawInfo: TRGridDrawInfo;
begin
  CalcDrawInfo(DrawInfo);
  Result := DrawInfo.Horz.GridBoundary;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetGridHeight: Integer;
var
  DrawInfo: TRGridDrawInfo;
begin
  CalcDrawInfo(DrawInfo);
  Result := DrawInfo.Vert.GridBoundary;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetVisibleColCount: Integer;
var
  DrawInfo: TRGridDrawInfo;
begin
  CalcDrawInfo(DrawInfo);
  Result := DrawInfo.Horz.LastFullVisibleCell - LeftCol + 1;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetVisibleRowCount: Integer;
var
  DrawInfo: TRGridDrawInfo;
begin
  CalcDrawInfo(DrawInfo);
  Result := DrawInfo.Vert.LastFullVisibleCell - TopRow + 1;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetBorderStyle(Value: TBorderStyle);
begin
  if FBorderStyle <> Value then
  begin
    FBorderStyle := Value;
    RecreateWnd;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetCol(Value: Longint);
begin
  if Col <> Value then
    FocusCell(Value, Row, True);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetColWidths(Index: Longint; Value: Integer);
var
  HolderIndex: Longint;
begin
  HolderIndex := GridToHolderCol(Index);

  if HolderIndex > -1 then
  begin
    if TRCellsVector(FHolder.FCols[HolderIndex]).FSize <> Value then
    begin
      ResizeCol(Index, TRCellsVector(FHolder.FCols[HolderIndex]).FSize, Value);
      TRCellsVector(FHolder.FCols[HolderIndex]).FSize := Value;
      ColWidthsChanged;
    end;
  end;
end;  
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetColWidths(Index: Longint): Integer;
begin
  if (Index < 0) or (Index >= ColCount) then
    Result := DefaultColWidth
  else
    Result := TRCellsVector(FHolder.FCols[GridToHolderCol(Index)]).FSize;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetRowHeights(Index: Longint; Value: Integer);
var
  HolderIndex: Longint;
begin
  HolderIndex := GridToHolderRow(Index);

  if HolderIndex > -1 then
  begin
    if TRCellsVector(FHolder.FRows[HolderIndex]).FSize <> Value then
    begin
      ResizeRow(Index, TRCellsVector(FHolder.FRows[HolderIndex]).FSize, Value);
      TRCellsVector(FHolder.FRows[HolderIndex]).FSize := Value;
      RowHeightsChanged;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetRowHeights(Index: Longint): Integer;
begin
  if (Index < 0) or (Index >= RowCount) then
    Result := DefaultRowHeight
  else
    Result := TRCellsVector(FHolder.FRows[GridToHolderRow(Index)]).FSize;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetDefaultColWidth(Value: Integer);
var
  i: Longint;
begin
  for i := 0 to FHolder.FCols.Count - 1 do
  begin
    TRCellsVector(FHolder.FCols[i]).FSize := Value;
  end;
  FDefaultColWidth := Value;
  ColWidthsChanged;
  InvalidateGrid;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetDefaultRowHeight(Value: Integer);
var
  i: Longint;
begin
  for i := 0 to FHolder.FRows.Count - 1 do
  begin
    TRCellsVector(FHolder.FRows[i]).FSize := Value;
  end;
  FDefaultRowHeight := Value;
  RowHeightsChanged;
  InvalidateGrid;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetCols(ACol: Longint) :TRCellsVector;
begin
  Result := FHolder.Cols[GridToHolderCol(ACol)];
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetRows(ARow: Longint) :TRCellsVector;
begin
  Result := FHolder.Rows[GridToHolderRow(ARow)];
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetCells(ACol, ARow: Longint) :TRCell;
begin
  Result := FHolder.Cells[GridToHolderCol(ACol), GridToHolderRow(ARow)];
end;
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.SetMarkedCols(ACol: Longint; Value: Boolean);
var
  HolderColIndex: Longint;

begin
  HolderColIndex := GridToHolderCol(ACol);

  if HolderColIndex > -1 then
  begin
    FHolder.MarkedCols[HolderColIndex] := Value;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCustomGrid.GetMarkedCols(ACol: Longint): Boolean;
begin
  Result := FHolder.MarkedCols[GridToHolderCol(ACol)];
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.SetMarkedRows(ARow: Longint; Value: Boolean);
var
  HolderRowIndex: Longint;

begin
  HolderRowIndex := GridToHolderRow(ARow);

  if (HolderRowIndex > -1) then
  begin
    FHolder.MarkedRows[HolderRowIndex] := Value;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCustomGrid.GetMarkedRows(ARow: Longint): Boolean;
begin
  Result := FHolder.MarkedRows[GridToHolderRow(ARow)];
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
procedure TRCustomGrid.SetMarkedCells(ACol, ARow: Longint; Value: Boolean);
var
  HolderColIndex, HolderRowIndex: Longint;
begin
  HolderColIndex := GridToHolderCol(ACol);
  HolderRowIndex := GridToHolderRow(ARow);

  if (HolderRowIndex > -1) and (HolderRowIndex > -1) then
  begin
    FHolder.MarkedCells[HolderColIndex, HolderRowIndex] := Value;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCustomGrid.GetMarkedCells(ACol, ARow: Longint): Boolean;
begin
  Result := FHolder.MarkedCells[GridToHolderCol(ACol), GridToHolderRow(ARow)];
end;
}
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetMarkedCols(AIndex: Longint): TRCellsVector;
begin
  if FHolder.FNeedReGenerateMarks then
  begin
    FHolder.GenerateMarkList();
  end;

  if (AIndex < 0) or (AIndex >= FMarkList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (rgoColsMarking in FOptions) then
    Result := TRCellsVector(FMarkList[AIndex])
  else
    Result := Nil;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetMarkedRows(AIndex: Longint): TRCellsVector;
begin
  if FHolder.FNeedReGenerateMarks then
  begin
    FHolder.GenerateMarkList();
  end;

  if (AIndex < 0) or (AIndex >= FMarkList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (rgoRowsMarking in FOptions) then
    Result := TRCellsVector(FMarkList[AIndex])
  else
    Result := Nil;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetMarkedCells(AIndex: Longint): TRCell;
begin
  if FHolder.FNeedReGenerateMarks then
  begin
    FHolder.GenerateMarkList();
  end;

  if (AIndex < 0) or (AIndex >= FMarkList.Count) then
    InvalidOp(ClassName + '::' + SIndexOutOfRange);

  if (rgoCellsMarking in FOptions) then
    Result := TRCell(FMarkList[AIndex])
  else
    Result := Nil;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.GetMarkedCount: Longint;
begin
  if FHolder.FNeedReGenerateMarks then
  begin
    //FHolder.GenerateMarkList();
    Result := FMarkCount;
  end//;
  else
    Result := FMarkList.Count;
end;
//----------------------------------------------------------------------------------------------------------------------
{
function TRCustomGrid.GetColsText(ACol: Longint) :string;
var
  CellText: string;
  k: Longint;
begin
  Result := '';

  if ((ACol < 0) or (ACol >=  FColCount)) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  for k := 0 to FRowCount - 1 do
  begin
    DoGetCellText(Cells[ACol, k], CellText);
    Result := Result + CellText;

    if k < RowCount - 1 then
    begin
      Result := Result + '\n';
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
{
function TRCustomGrid.GetRowsText(ARow: Longint) :string;
var
  CellText: string;
  k: Longint;
begin
  Result := '';

  if ((ARow < 0) or (ARow >= FRowCount)) then
  begin
    InvalidOp(ClassName + '::' + SIndexOutOfRange);
  end;

  for k := 0 to FColCount - 1 do
  begin
    DoGetCellText(Cells[k, ARow], CellText);
    Result := Result + CellText;

    if k < FColCount - 1 then
    begin
      Result := Result + '\n';
    end;
  end;
end;
}
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetFocusFrameStyle(Value: TRGridFocusFrameStyle);
begin
  if FFocusFrameStyle <> Value then
  begin
    FFocusFrameStyle := Value;
    InvalidateCell(FCurrent.X, FCurrent.Y);
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetColors(const Value: TRGridColors);
begin
  FColors.Assign(Value);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetFonts(const Value: TRGridFonts);
begin
  FFonts.Assign(Value);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetGridLineWidth(Value: Integer);
begin
  if FGridLineWidth <> Value then
  begin
    FGridLineWidth := Value;
    InvalidateGrid;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetLeftCol(Value: Longint);
begin
  if FTopLeft.X <> Value then
    MoveTopLeft(Value, TopRow);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetOptions(Value: TRGridOptions);
begin
  if FOptions <> Value then
  begin
    if (rgoColsMarking in Value) and (not (rgoColsMarking in FOptions)) then
    begin
      Exclude(Value, rgoRowsMarking);
      Exclude(Value, rgoCellsMarking);

      if not (csDesigning in ComponentState) then
        FHolder.ClearMark();
    end;

    if (rgoRowsMarking in Value) and (not (rgoRowsMarking in FOptions)) then
    begin
      Exclude(Value, rgoColsMarking);
      Exclude(Value, rgoCellsMarking);

      if not (csDesigning in ComponentState) then
        FHolder.ClearMark();
    end;

    if (rgoCellsMarking in Value) and (not (rgoCellsMarking in FOptions)) then
    begin
      Exclude(Value, rgoColsMarking);
      Exclude(Value, rgoRowsMarking);

      if not (csDesigning in ComponentState) then
        FHolder.ClearMark();
    end;

    if ([rgoShowFocusCell, rgoShowFocusFrame] * Value = []) then
    begin
      if (rgoShowFocusCell in FOptions) then
        Include(Value, rgoShowFocusCell)
      else
        Include(Value, rgoShowFocusFrame);
    end;

    FOptions := Value;

    if ((rgoAutoColorCurColRow in FOptions) <> (not (rgoAutoColorCurColRow in Value))) then
      FColors.RefreshColors;

    InvalidateGrid;
    //Repaint();
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetRow(Value: Longint);
begin
  if Row <> Value then
    FocusCell(Col, Value, True);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetScrollBars(Value: TScrollStyle);
begin
  if FScrollBars <> Value then
  begin
    FScrollBars := Value;
    RecreateWnd;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetTopRow(Value: Longint);
begin
  if FTopLeft.Y <> Value then MoveTopLeft(LeftCol, Value);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMChar(var Msg: TWMChar);
begin
  inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMGetDlgCode(var Msg: TWMGetDlgCode);
begin
  Msg.Result := DLGC_WANTARROWS;
  if rgoTabs in Options then Msg.Result := Msg.Result or DLGC_WANTTAB;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMKillFocus(var Msg: TWMKillFocus);
begin
  inherited;

  InvalidateGrid;

  if Assigned(FOnChangeFocus) then
    FOnChangeFocus(Self);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMLButtonDown(var Message: TMessage);
begin
  inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMNCHitTest(var Msg: TWMNCHitTest);
begin
  DefaultHandler(Msg);
  FHitTest := ScreenToClient(SmallPointToPoint(Msg.Pos));
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMSetCursor(var Msg: TWMSetCursor);
var
  DrawInfo: TRGridDrawInfo;
  State: TRGridState;
  Index: Longint;
  Pos, Ofs: Integer;
  Cur: HCURSOR;
begin
  Cur := 0;
  with Msg do
  begin
    if HitTest = HTCLIENT then
    begin
      if FGridState = rgsNormal then
      begin
        CalcDrawInfo(DrawInfo);
        CalcSizingState(FHitTest.X, FHitTest.Y, State, Index, Pos, Ofs,
          DrawInfo);
      end else State := FGridState;
      if State = rgsRowSizing then
        Cur := Screen.Cursors[crVSplit]
      else if State = rgsColSizing then
        Cur := Screen.Cursors[crHSplit]
    end;
  end;
  if Cur <> 0 then SetCursor(Cur)
  else inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMSetFocus(var Msg: TWMSetFocus);
begin
  inherited;

  InvalidateGrid;

  if Assigned(FOnChangeFocus) then
    FOnChangeFocus(Self);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMSize(var Msg: TWMSize);
begin
  inherited;
  UpdateScrollRange;

  if UseRightToLeftAlignment then
    Invalidate;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMVScroll(var Msg: TWMVScroll);
begin
  ModifyScrollBar(SB_VERT, Msg.ScrollCode, Msg.Pos, True);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMHScroll(var Msg: TWMHScroll);
begin
  ModifyScrollBar(SB_HORZ, Msg.ScrollCode, Msg.Pos, True);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CancelMode;
var
  DrawInfo: TRGridDrawInfo;
begin
  try
    case FGridState of
      rgsFocusMoving:
        KillTimer(Handle, 1);

      rgsRangeMarking:
        KillTimer(Handle, 1);

      rgsRowSizing, rgsColSizing:
      begin
        CalcDrawInfo(DrawInfo);
        DrawSizingLine(DrawInfo);
      end;

      rgsColMoving, rgsRowMoving:
      begin
        DrawMove;
        KillTimer(Handle, 1);
      end;
    end;
  finally
    FGridState := rgsNormal;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMCancelMode(var Msg: TWMCancelMode);
begin
  StopTracking;
  inherited;
  CancelMode;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CMCancelMode(var Msg: TMessage);
begin
  inherited;
  CancelMode;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CMFontChanged(var Message: TMessage);
begin
  inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CMCtl3DChanged(var Message: TMessage);
begin
  inherited;
  RecreateWnd;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CMDesignHitTest(var Msg: TCMDesignHitTest);
begin
  Msg.Result := Longint(BOOL(Sizing(Msg.Pos.X, Msg.Pos.Y)));
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CMWantSpecialKey(var Msg: TCMWantSpecialKey);
begin
  inherited;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.TimedScroll(Direction: TRGridScrollDirection);
var
  MaxAnchor, NewAnchor: TRGridCoord;

begin
  NewAnchor := FCurrent;
  MaxAnchor.X := ColCount - 1;
  MaxAnchor.Y := RowCount - 1;

  if (rsdLeft in Direction) and (FCurrent.X > FixedCols) then
    Dec(NewAnchor.X);

  if (rsdRight in Direction) and (FCurrent.X < MaxAnchor.X) then
    Inc(NewAnchor.X);

  if (rsdUp in Direction) and (FCurrent.Y > FixedRows) then
    Dec(NewAnchor.Y);

  if (rsdDown in Direction) and (FCurrent.Y < MaxAnchor.Y) then
    Inc(NewAnchor.Y);

  if (FCurrent.X <> NewAnchor.X) or (FCurrent.Y <> NewAnchor.Y) then
  begin
    MoveCurrent(NewAnchor.X, NewAnchor.Y, True);

    if FGridState = rgsRangeMarking then
    begin
      ChangeMarkRange;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.WMTimer(var Msg: TWMTimer);
var
  Point: TPoint;
  DrawInfo: TRGridDrawInfo;
  ScrollDirection: TRGridScrollDirection;
  CellHit: TRGridCoord;
  LeftSide: Integer;
  RightSide: Integer;
begin
  if not (FGridState in [rgsFocusMoving, rgsRangeMarking, rgsRowMoving, rgsColMoving]) then
    Exit;

  GetCursorPos(Point);
  Point := ScreenToClient(Point);
  CalcDrawInfo(DrawInfo);
  ScrollDirection := [];
  with DrawInfo do
  begin
    CellHit := CalcCoordFromPoint(Point.X, Point.Y, DrawInfo);
    case FGridState of
      rgsColMoving:
        MoveAndScroll(Point.X, CellHit.X, DrawInfo, Horz, SB_HORZ, Point);

      rgsRowMoving:
        MoveAndScroll(Point.Y, CellHit.Y, DrawInfo, Vert, SB_VERT, Point);

      rgsFocusMoving, rgsRangeMarking:
      begin
        if (not UseRightToLeftAlignment) then
        begin
          if (Point.X < Horz.FixedBoundary) then
            Include(ScrollDirection, rsdLeft)
          else if (Point.X > Horz.FullVisBoundary) then
            Include(ScrollDirection, rsdRight);
        end
        else
        begin
          LeftSide := ClientWidth - Horz.FullVisBoundary;
          RightSide := ClientWidth - Horz.FixedBoundary;
          if (Point.X < LeftSide) then
            Include(ScrollDirection, rsdRight)
          else if (Point.X > RightSide) then
            Include(ScrollDirection, rsdLeft);
        end;

        if (Point.Y < Vert.FixedBoundary) then
          Include(ScrollDirection, rsdUp)
        else if (Point.Y > Vert.FullVisBoundary) then
          Include(ScrollDirection, rsdDown);

        if (ScrollDirection <> []) then
          TimedScroll(ScrollDirection);
      end;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ColWidthsChanged;
begin
  UpdateScrollRange;

  if FTracking then
    StopTracking;

  if Assigned(FOnColumnSized) then
    FOnColumnSized(Self);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.RowHeightsChanged;
begin
  UpdateScrollRange;

  if FTracking then
    StopTracking;

  if Assigned(FOnRowSized) then
    FOnRowSized(Self);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.UpdateDesigner;
var
  ParentForm: TCustomForm;
begin
  if (csDesigning in ComponentState) and HandleAllocated and
    not (csUpdating in ComponentState) then
  begin
    ParentForm := GetParentForm(Self);
    if Assigned(ParentForm) and Assigned(ParentForm.Designer) then
      ParentForm.Designer.Modified;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelDown(Shift, MousePos);
  if not Result then
  begin
    if ssCtrl in Shift then
    begin
      if Col < ColCount - 1 then Col := Col + 1;
      Result := True;
    end
    else
    begin
      if Row < RowCount - 1 then Row := Row + 1;
      Result := True;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelUp(Shift, MousePos);
  if not Result then
  begin
    if ssCtrl in Shift then
    begin
      if Col > FixedCols then Col := Col - 1;
      Result := True;
    end
    else
    begin
      if Row > FixedRows then Row := Row - 1;
      Result := True;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.CheckColumnDrag(var Origin,
  Destination: Integer; const MousePt: TPoint): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.CheckRowDrag(var Origin,
  Destination: Integer; const MousePt: TPoint): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.BeginColumnDrag(var Origin, Destination: Integer; const MousePt: TPoint): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.BeginRowDrag(var Origin, Destination: Integer; const MousePt: TPoint): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.EndColumnDrag(var Origin, Destination: Integer; const MousePt: TPoint): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
function TRCustomGrid.EndRowDrag(var Origin, Destination: Integer; const MousePt: TPoint): Boolean;
begin
  Result := True;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.CMShowingChanged(var Message: TMessage);
begin
  inherited;

  if Showing then
    UpdateScrollRange;
end;
//----------------------------------------------------------------------------------------------------------------------
{ TRGrid }
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.MouseToCell(X, Y: Integer; var ACol, ARow: Longint);
var
  Coord: TRGridCoord;
begin
  Coord := MouseCoord(X, Y);
  ACol := Coord.X;
  ARow := Coord.Y;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoColumnMoved(FromIndex, ToIndex: Longint);
begin
  //      
  //    FOnCanColumnMove
  if Assigned(FOnColumnMoved) then
    FOnColumnMoved(Self, FromIndex, ToIndex);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoRowMoved(FromIndex, ToIndex: Longint);
begin
  if FTracking then
    StopTracking;

  //      
  //    FOnCanRowMove
  if Assigned(FOnRowMoved) then
    FOnRowMoved(Self, FromIndex, ToIndex);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.DoCanFocusCell(var ACol: Longint; var ARow: Longint){: Boolean};
begin
  //Result := True;
  if Assigned(FOnFocusCell) then
    FOnFocusCell(Self, Cells[ACol, ARow], ACol, ARow{, Result});
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.ImageListChange(Sender: TObject);
begin
  if not (csDestroying in ComponentState) then
    InvalidateGrid; //Invalidate;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.SetImages(Value: TCustomImageList);
begin
  if FImages <> Value then
  begin
    if Assigned(FImages) then
    begin
      FImages.UnRegisterChanges(FImageChangeLink);
      {$ifdef COMPILER_5_UP}
        FImages.RemoveFreeNotification(FOwner);
      {$endif COMPILER_5_UP}
    end;
    FImages := Value;
    if Assigned(FImages) then
    begin
      FImages.RegisterChanges(FImageChangeLink);
      FImages.FreeNotification(Self);
    end;
    if not (csLoading in ComponentState) then
      InvalidateGrid;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TRCustomGrid.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  
  if (Operation = opRemove) then
  begin
    if (AComponent = Images) then 
    begin
      Images := nil;
      if not (csDestroying in ComponentState) then
        InvalidateGrid;
    end;
  end;
end;
//----------------------------------------------------------------------------------------------------------------------
end.
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
